<#macro renderSvkDocCommentHtml>

	<#assign el=args.htmlid?html>

	<@markup id="css" >
	   <#-- CSS Dependencies -->
	   <@link href="${url.context}/res/components/document/comments.css" group="comments"/>
	   <@link href="${url.context}/res/components/documentdatatable/documentdatatable.css" group="comments"/>
     <@link href="${url.context}/res/components/document/comment-authority-dialog.css" group="comments"/>
	   <@link href="${url.context}/res/components/people-finder/group-finder.css" group="comments"/>
	</@>
	
	<@markup id="js">
	   <#-- JavaScript Dependencies -->
	   <@script src="${url.context}/res/components/document/documentcommentdatatable.js" group="comments"/>
	   <@script src="${url.context}/res/components/document/documentwritecommentpopup.js" group="comments"/>
	   <@script src="${url.context}/res/components/documentdatatable/documentdatatable.js" group="comments"/>
     <@script src="${url.context}/res/components/document/comment-authority-dialog.js" group="comments"/>
     <@script src="${url.context}/res/components/document/change-permission-dialog.js" group="comments"/>
     <@script src="${url.context}/res/components/people-finder/lyse-group-finder.js" group="comments"/>
	</@>

	<#assign controlId = el + "-cntrl">
	<div id="writeCommentButtonContainer" class="commentButton <#if !allowCreateComment>hidden</#if>"></div>
	<div class="form-field">
		<div id="comment"></div>
	    <div class="yui-skin-sam">
	    	<!-- Table container -->
			<div id="${controlId}-table-container" class="svkCommentDatatable"></div>
		</div>
	</div>
	

<script type="text/javascript">//<![CDATA[
function createCommentButton(){
  var commentAuthorityButton = new YAHOO.widget.Button(
    {
      id: 'commentauthoritybutton',
      type: 'button',
      label: Alfresco.util.message('label.gr1NewCommentAddCommentButton'),
      container: 'writeCommentButtonContainer'
    }
  );
  commentAuthorityButton.subscribe('click', function(){

    var commentAuthorityDialog = new Alfresco.CommentAuthorityDialog("${controlId}-commentAuthorityDialog");
    var templateUrl = Alfresco.constants.URL_SERVICECONTEXT + "components/comments/comment-authority-dialog";

    commentAuthorityDialog.setOptions(
      {
        nodeRef: "${nodeRef}",
        site: Alfresco.constants.SITE,
        url: 'svk/document/comment/',
        width: "40em",
        templateUrl: templateUrl,
        destroyOnHide: true,
        onSuccess:
          {
            fn: function ()
            {
              commentsDataTable.refreshData();
            },
            scope: this
          },
      });

    commentAuthorityDialog.show();
  });
}

// Main

if (!Array.prototype.indexOf) {
	Array.prototype.indexOf = function(obj, start) {
     	for (var i = (start || 0), j = this.length; i < j; i++) {
        	if (this[i] === obj) { return i; }
     	}
    	return -1;
	}
}

YAHOO.util.Event.onDOMReady(function() {

  var nodeRef = Alfresco.util.parseURL().queryParams.nodeRef;
  // If user in document view, the reply to comment is disabled.
  var documentDetailsPage = Alfresco.constants.PAGEID === "document-details" ? false : undefined;
  createCommentButton();
  commentsDataTable = SVK.documentCommentDataTable.getCommentDataTable(
    	{
    		replyToCommentFunction : function(nodeRef){
    		 	SVK.documentComments.writeCommentPopup({
    		 		nodeRefString : nodeRef,
    		 		url: 'svk/document/comment/reply/',
    		 		title : Alfresco.util.message('label.documentCommentsAnswerTitleLabel'),
    		 		isReply: true
    		 	});
    		},
    		changePermissionFunction : function(nodeRef){
    		
				var changePermissionDialog = new Alfresco.ChangePermissionDialog("${controlId}-changePermissionDialog");
				var templateUrl = Alfresco.constants.URL_SERVICECONTEXT + "components/comments/change-permission-dialog";

				changePermissionDialog.setOptions(
				{
					nodeRef: nodeRef,
					site: Alfresco.constants.SITE,
					url: 'api/lyse/getPermissions/',
					width: "40em",
					templateUrl: templateUrl,
          destroyOnHide: true,
					onSuccess:
			        {
			          fn: function ()
			          {
				        commentsDataTable.refreshData();
			          },
			          scope: this
			        }
				});
				changePermissionDialog.show();
    		},
            documentNodeRef : "${nodeRef}",
            containerId : "${controlId}-table-container",
            commentIsDoneFormatter: SVK.DataTable.formatters.trueFalseIndicatorFactory({}),
            editable : documentDetailsPage
    	}
    );
});

//]]></script>

</#macro>
