<@markup id="css" >
  <#-- CSS Dependencies -->
  <@link rel="stylesheet" type="text/css" href="${url.context}/res/components/dashlets/lyse-tasks.css" group="dashlets"  />
</@>

<@markup id="js">
  <#-- JavaScript Dependencies -->
  <@script type="text/javascript" src="${url.context}/res/components/workflow/workflow-actions.js" group="dashlets"/>
  <@script type="text/javascript" src="${url.context}/res/components/dashlets/lyse-tasks.js" group="dashlets"/>
  <@script type="text/javascript" src="${url.context}/res/js/lyse/allsites/DebugUtils.js" group="dashlets"/>
</@>

<@markup id="widgets">
  <@createWidgets group="dashlets"/>
</@>

<@markup id="html">
  <@uniqueIdDiv>
    <#assign id = args.htmlid?html>
    <div class="dashlet lyse-tasks">
      <div class="title">${msg("header")}</div>
      <div class="toolbar flat-button">
        <div class="hidden">

          <span class="align-left yui-button yui-menu-button" id="${id}-filters">
            <span class="first-child">
              <button type="button" tabindex="0"></button>
            </span>
          </span>
          <select id="${id}-filters-menu">
          <#list filters as filter>
            <option value="${filter.type?html}">${msg("filter." + filter.type)}</option>
          </#list>
          </select>

          <span class="align-left yui-button yui-menu-button" id="${id}-sitefilters">
            <span class="first-child">
              <button type="button" tabindex="0"></button>
            </span>
          </span>
          <select id="${id}-sitefilters-menu">
            <option value="undefined">Filter by All</option>
          </select>

          <span class="align-left yui-button yui-menu-button" id="${id}-orderBy">
            <span class="first-child">
              <button type="button" tabindex="0"></button>
            </span>
          </span>
          <select id="${id}-orderBy-menu">
          <#list orderByOptions as orderBy>
            <option value="${orderBy.type?html}">${msg("orderBy." + orderBy.type)}</option>
          </#list>
          </select>

          <span class="align-left yui-button yui-menu-button" id="${id}-excludeFilters">
            <span class="first-child">
              <button type="button" tabindex="0"></button>
            </span>
          </span>
          <select id="${id}-excludeFilters-menu">
              <#list excludeFilters as excludeFilter>
                <option value="${excludeFilter.type?html}">${msg("excludeFilter." + excludeFilter.type)}</option>
              </#list>
          </select>

          <span class="align-left yui-button yui-menu-button" id="${id}-dateFilters">
            <span class="first-child">
              <button type="button" tabindex="0"></button>
            </span>
          </span>
          <select id="${id}-dateFilters-menu">
            <#list dateFilters as filter>
              <option value="${filter.type?html}">${msg("dateFilter." + filter.type)}</option>
            </#list>
          </select>

          <div class="sort-direction">
           <span id="${id}-sortAscending-button" class="yui-button yui-push-button">
              <span class="first-child">
                 <button name="doclist-sortAscending-button"></button>
              </span>
           </span>
          </div>

          <div class="clear"></div>
        </div>
      </div>
      <div class="toolbar flat-button">
        <div class="align-left" id="${id}-paginator">&nbsp;</div>
        <div class="clear"></div>
      </div>
      <div class="body scrollableList" <#if args.height??>style="height: ${args.height?html}px;"</#if>>
        <div id="${id}-tasks"></div>
      </div>
    </div>
  </@>
</@>
