//@overridden projects/slingshot/config/alfresco/site-webscripts/org/alfresco/components/data-lists/toolbar.get.js
/**
 * Copyright (C) 2005-2010 Alfresco Software Limited.
 *
 * This file is part of Alfresco
 *
 * Alfresco is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Alfresco is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Alfresco. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Main entrypoint for component webscript logic
 *
 * @method main
 */
function main()
{
   // Actions
   var myConfig = new XML(config.script),
      xmlActionSet = myConfig.actionSet,
      actionSet = [];

   for each (var xmlAction in xmlActionSet.action)
   {
	   // Lyse - remove duplicate action
	   if (xmlAction.@id.toString() == "onActionDuplicate"){
		   continue;
	   }

      actionSet.push(
      {
         id: xmlAction.@id.toString(),
         type: xmlAction.@type.toString(),
         permission: xmlAction.@permission.toString(),
         asset: xmlAction.@asset.toString(),
         href: xmlAction.@href.toString(),
         label: xmlAction.@label.toString()
      });
   }

   actionSet.push(
   {
      id: "onActionLockItems",
      type: "action-link",
      permission: "lockItem",
      asset: "",
      href: "",
      label: "menu.selected-items.lockItems"
   });

  actionSet.push(
    {
      id: "onActionUnlockItems",
      type: "action-link",
      permission: "unlockItem",
      asset: "",
      href: "",
      label: "menu.selected-items.unlockItems"
    });

   actionSet.push(
   {
       id: "onActionSubmitForReview",
       type: "action-link",
       permission: "cdlSubmitForReview",
       asset: "",
       href: "",
       label: "actions.submit-for-review"
   });

   actionSet.push(
   {
       id: "onActionVoid",
       type: "action-link",
       permission: "cdlVoidDocument",
       asset: "",
       href: "",
       label: "actions.void-document"
   });

   actionSet.push(
   {
       id: "onActionReassign",
       type: "action-link",
       permission: "canReassign",
       asset: "",
       href: "",
       label: "actions.reassign.button"	   
   });
   
   actionSet.push(
   {
       id: "onActionRevoke",
       type: "action-link",
       permission: "engRevokeDocument",
       asset: "",
       href: "",
       label: "actions.revoke-document"
   });

   actionSet.push(
   {
   	   id: "onVoidMilestone",
   	   type: "action-link",
   	   permission: "voidMilestone",
   	   asset: "",
   	   href: "",
   	   label: "actions.void-milestone"
   });

   actionSet.push(
   {
       id: "onActionRevokeSafeWorkPermit",
       type: "action-link",
       permission: "revokeSafeWorkPermit",
       asset: "",
       href: "",
       label: "menu.selected-items.revokeSafeWorkPermit"
   });

   actionSet.push(
   {
       id: "onActionCompleteSafeWorkPermit",
       type: "action-link",
       permission: "completeSafeWorkPermit",
       asset: "",
       href: "",
       label: "menu.selected-items.completeSafeWorkPermit"
   });

   actionSet.push(
   {
       id: "onActionCompleteCivilMeasuredQuantity",
       type: "action-link",
       permission: "completeCivilMeasuredQuantity",
       asset: "",
       href: "",
       label: "menu.selected-items.completeCivilMeasuredQuantity"
   });

   actionSet.push(
   {
       id: "onActionIncompleteCivilMeasuredQuantity",
       type: "action-link",
       permission: "incompleteCivilMeasuredQuantity",
       asset: "",
       href: "",
       label: "menu.selected-items.incompleteCivilMeasuredQuantity"
   });
   actionSet.push(
   {
       id: "onActionCivilMilestoneSubmitInvoice",
       type: "action-link",
       permission: "civilMilestoneSubmitInvoice",
       asset: "",
       href: "",
       label: "menu.selected-items.civilMilestoneSubmitInvoice"
   });
   model.actionSet = actionSet;

   // Widget instantiation metadata...
   var toolbar = {
      id : "DataListToolbar",
      name : "Alfresco.component.ExtDataListToolbar",
      options : {
         siteId : (page.url.templateArgs.site != null) ? page.url.templateArgs.site : ""
      }
   };

   model.widgets = [toolbar];
}

main();

