/**
 * Main entrypoint for component webscript logic
 *
 * @method main
 */
function main()
{

   // Get the root node from url
   var nodeRef = null;
   if (url.args["docLib"] !== null)
   {
       nodeRef = url.args["docLib"];
       model.rootNode = nodeRef;
   } else {
       model.rootNode = "alfresco://user/home";
   }

   var evaluateChildFolders = "true",
       maximumFolderCount = "-1";
   var docLibConfig = config.scoped["RepositoryLibrary"];
   if (docLibConfig != null)
   {
      var tree = docLibConfig["tree"];
      if (tree != null)
      {
         var tmp = tree.getChildValue("evaluate-child-folders");
         evaluateChildFolders = tmp != null ? tmp : "true";
         tmp = tree.getChildValue("maximum-folder-count");
         maximumFolderCount = tmp != null ? tmp : "-1";
      }
   }

   var repoDocListTree = {
      id : "RepositoryDocListTree",
      name : "Alfresco.RepositoryDocListTree",
      options : {
         rootNode : model.rootNode != null ? model.rootNode : "null",
         evaluateChildFolders : (evaluateChildFolders === "true"),
         maximumFolderCount : parseInt(maximumFolderCount),
         setDropTargets : true
      }
   };
   // Don't show the document library
   if(nodeRef == null){
     repoDocListTree = [];
   }

   // Show/hide the folder tree/title
   if(url.queryString.indexOf("nodeRef") !== -1 || url.queryString.indexOf("workflowId") !== -1){
     model.showTitle = false;
   } else {
     model.showTitle = true;
   }

   model.widgets = [repoDocListTree];
}

main();
