<#include "/org/alfresco/components/form/controls/common/utils.inc.ftl" />
<#-- This component is used in the case where a category value is used to
     populate a d:text property, this component looks up the values in the category tree
     (could be configured to look for site specific categories as well -->

<#if field.control.params.optionSeparator??>
    <#assign optionSeparator=field.control.params.optionSeparator>
<#else>
    <#assign optionSeparator=",">
</#if>
<#if field.control.params.labelSeparator??>
    <#assign labelSeparator=field.control.params.labelSeparator>
<#else>
    <#assign labelSeparator="|">
</#if>

<#if field.control.params.categoryLocator??>
    <#assign categoryLocator=field.control.params.categoryLocator>
</#if>

<div class="form-field">
<#if form.mode == "view">
    <div class="viewmode-field">
        <#if field.mandatory && !(field.value?is_number) && field.value?string == "">
        <span class="incomplete-warning"><img src="${url.context}/res/components/form/images/warning-16.png" title="${msg("form.field.incomplete")}" /><span>
        </#if>
        <span class="viewmode-label">${field.label?html}:</span>
        <#if field.value?string == "">
            <#assign valueToShow=msg("form.control.novalue")>
        <#else>
            <#assign valueToShow=field.value>
            <#if field.control.params.options??>
                <#list field.control.params.options?split(optionSeparator) as nameValue>
                    <#if nameValue?index_of(labelSeparator) == -1>
                        <#if nameValue == field.value?string || (field.value?is_number && field.value?c == nameValue)>
                            <#assign valueToShow=nameValue>
                            <#break>
                        </#if>
                    <#else>
                        <#assign choice=nameValue?split(labelSeparator)>
                        <#if choice[0] == field.value?string || (field.value?is_number && field.value?c == choice[0])>
                            <#assign valueToShow=msgValue(choice[1])>
                            <#break>
                        </#if>
                    </#if>
                </#list>
            </#if>
        </#if>
        <span class="viewmode-value">${valueToShow?html}</span>
    </div>
<#else>
    <script>
        //<![CDATA[
        YAHOO.util.Event.onDOMReady(
                function () {
                    <#if categoryLocator??>
                        var datalistItemNodeRef = document.getElementsByName("${categoryLocator}").length > 0 ? document.getElementsByName("${categoryLocator}")[0].value : null;
                    <#else>
                        var datalistItemNodeRef = null;
                    </#if>
                    var siteShortName;

                    var options = {};

                    options.selectedValue = "${field.value}";
                    options.categoryParentName = "${field.control.params.categoryParentName}";
                    options.fetchFromParentType = "${field.control.params.fetchFromParentType!"none"}";
                    options.sort = "${field.control.params.sort!"true"}";

                    <#if field.control.params.addEmptyOption?? && field.control.params.addEmptyOption=="true">
                        options.addEmptyOption = true;
                    </#if>

                    if (datalistItemNodeRef != null){
                        Alfresco.util.Ajax.jsonGet(
                                {
                                    url: Alfresco.constants.PROXY_URI + "/api/lyse/" + Alfresco.util.NodeRef(datalistItemNodeRef).uri + "/site-shortname",
                                    responseContentType : "application/json",
                                    successCallback:
                                    {
                                        fn: function (response)
                                        {
                                            options.siteShortName = response.json.shortName;
                                            new RPLP.CategorySelectOne("${fieldHtmlId}").setOptions(options);
                                        },
                                        scope: this
                                    }
                                });
                    } else {
                        options.siteShortName = Alfresco.constants.SITE;
                        new RPLP.CategorySelectOne("${fieldHtmlId}").setOptions(options);
                    }


                });
        //]]></script>
    <label for="${fieldHtmlId}">${field.label?html}:<#if field.mandatory><span class="mandatory-indicator">${msg("form.required.fields.marker")}</span></#if></label>
    <#if field.control.params.categoryParentName?? && field.control.params.categoryParentName != "">
        <select id="${fieldHtmlId}" name="${field.name}"  multiple="multiple" tabindex="0"
                <#if field.description??>title="${field.description}"</#if>
                <#if field.control.params.size??>size="${field.control.params.size}"</#if>
                <#if field.control.params.styleClass??>class="${field.control.params.styleClass}"</#if>
                <#if field.control.params.style??>style="${field.control.params.style}"</#if>
                <#if field.disabled  && !(field.control.params.forceEditable?? && field.control.params.forceEditable == "true")>disabled="true"</#if>>
            <option>Loading...</option>
        </select>
        <@formLib.renderFieldHelp field=field />
    <#else>
        <div id="${fieldHtmlId}-missing" class="missing-options">${msg("form.control.selectone.missing-options")}</div>
    </#if>

</#if>
</div>