<#-- This picker will list all datalist items from a site and make them pickable -->
<#-- This picker uses the 'startLocation' option from the form-config to set the rootNode and startLocation, these params are used for delimit folder tree -->

<#include "/org/alfresco/components/form/controls/common/picker.inc.ftl" />

<#if field.control.params.defaultSearchTerm??>
   <#assign defaultSearchTerm=field.control.params.defaultSearchTerm>
<#else>
   <#assign defaultSearchTerm="*">
</#if>

<#-- Make it possible to override the multipleSelect-mode from the association settings.-->
<#if field.control.params.multipleSelect??>
	<#assign multipleSelect=field.control.params.multipleSelect == "true" />
<#else>
	<#assign multipleSelect= field.endpointMany />
</#if>

<#if field.control.params.borderBoxStyleStart??>
    <#assign borderBoxStyleStart = field.control.params.borderBoxStyleStart == "true" />
<#else>
    <#assign borderBoxStyleStart = false />
</#if>
<#if field.control.params.siteType??>
    <#assign siteType = field.control.params.siteType/>
<#else>
    <#assign siteType = "default"/>
</#if>

<#assign controlId = fieldHtmlId + "-cntrl">

<script type="text/javascript">//<![CDATA[
(function()
{
    <@renderPickerJS field "picker" />
    picker.setOptions(
    {
<#if field.control.params.showTargetLink??>
  		showLinkToTarget: ${field.control.params.showTargetLink},
      	targetLinkTemplate: node_renderLinkTemplate,
</#if>
<#if field.control.params.itemType??>
        <#-- This was added because parameters defined in an ActionExecuter of type NODE_REF are always cm:object -->
        itemType: "${field.control.params.itemType?string}",
<#else>
        itemType: "${field.endpointType}",
</#if>
		rootNode:"dataLists",
        multipleSelectMode: ${multipleSelect?string},
        itemFamily: "datalist",
        finderAPI: Alfresco.constants.PROXY_URI + "api/lyse/forms/datalist-items/"+ "${siteType}",
        borderBoxStyleStart: ${borderBoxStyleStart?string},
        maxSearchResults:5000
    });

    var me = this;
    var initSiteAuthorityPicker = function (layer, args) {
        // Unsubscribe since we only want to run this once, else it will break other picker dialogs
        YAHOO.Bubbling.unsubscribe("afterFormRuntimeInit", initSiteAuthorityPicker, me);
        var startLocation = picker.options.startLocation;
        if(startLocation && startLocation != null) {
           if(startLocation == "{self}") {
             picker.setOptions(
               {
                 startLocation: startLocation
               });
           } else {
             // Get a nodeRef from a form field
             var siteNodeRef = document.getElementsByName(startLocation).length > 0 ? document.getElementsByName(startLocation)[0].value : null;
             if(siteNodeRef !== null && siteNodeRef !== undefined) {
               picker.setOptions(
               {
                 startLocation: siteNodeRef
               });
             }
           }
        }

        var defaultSearch = function (layer, args) {
            // Unsubscribe since we only want to run this once, else it will break other picker dialogs
            YAHOO.Bubbling.unsubscribe("objectFinderReady", defaultSearch, me);
            var searchTextField = Dom.get(picker.pickerId + "-searchText");
            if (searchTextField) {
                searchTextField.value = "${defaultSearchTerm}";
            }
        };
        YAHOO.Bubbling.on("objectFinderReady", defaultSearch, this);

    };

    YAHOO.Bubbling.on("afterFormRuntimeInit", initSiteAuthorityPicker, this);
})();

function node_renderLinkTemplate(item){
  var linkUrl = "${url.context}/page";
  if (Alfresco.constants.SITE) {
    linkUrl += "/site/" + Alfresco.constants.SITE;
  }
  if (item.type == "app:filelink") {
    linkUrl += "/document-details?nodeRef=" + item.destination;
  } else if (item.type == "cm:folder") {
    linkUrl += "/folder-details?nodeRef=" + item.nodeRef;
  } else {
    Alfresco.util.Ajax.jsonGet({
      url: Alfresco.constants.PROXY_URI + "api/lyse/attachment-folder?nodeRef=" + item.nodeRef,
      successCallback: {
        fn: function (response) {
          if (response.json !== undefined && response.json.nodeRef !== "" && document.getElementById(item.nodeRef) != null) {
            //Success, this datalist item has an attachment folder
            var linkUrl = "${url.context}/page";
            if (Alfresco.constants.SITE) {
              linkUrl += "/site/" + Alfresco.constants.SITE;
            }
            linkUrl += "/lyse-datalist-details?nodeRef=" + item.nodeRef + "&docLib=" + response.json.nodeRef;
            document.getElementById(item.nodeRef).href = linkUrl;
          }
        },
        scope: this
      }
    });
    linkUrl += "/lyse-datalist-details?nodeRef=" + item.nodeRef;
  }
  return linkUrl;
}

//]]></script>

<#if borderBoxStyleStart == true && form.mode != "view">
  <#if "${controlId}"?contains("meetingItems")>
    <fieldset style="margin-right:1em">
            <legend>${msg("form.hse.borderboxstyleMeeting.title")}
    </legend>
  </#if>
</#if>
   <div class="form-field" >
   <#if form.mode == "view">
      <div id="${controlId}" class="viewmode-field">
         <#if field.endpointMandatory && field.value == "">
            <span class="incomplete-warning"><img src="${url.context}/res/components/form/images/warning-16.png" title="${msg("form.field.incomplete")}" /></span>
         </#if>
         <span class="viewmode-label">${field.label?html}:</span>
  		<#if "${controlId}"?contains("meetingItems")>
          <span id="${controlId}-currentValueDisplay" class="viewmode-value current-values lyse-meetings-span"></span>
   		<#else>
          <span id="${controlId}-currentValueDisplay" class="viewmode-value current-values"></span>
		</#if>
      </div>
   <#else>
      <label for="${controlId}">${field.label?html}:<#if field.endpointMandatory><span class="mandatory-indicator">${msg("form.required.fields.marker")}</span></#if></label>

      <div id="${controlId}" class="object-finder">

         <div id="${controlId}-currentValueDisplay" class="current-values"></div>

         <#if field.disabled == false>
            <input type="hidden" id="${fieldHtmlId}" name="-" value="${field.value?html}" />
            <input type="hidden" id="${controlId}-added" name="${field.name}_added" />
            <input type="hidden" id="${controlId}-removed" name="${field.name}_removed" />
            <div id="${controlId}-itemGroupActions" class="show-picker"></div>

            <@renderPickerHTML controlId />
         </#if>
      </div>
   </#if>
</div>
