<#-- Engineering ajax comments module, included in pop up edits -->
<#-- NOTE: edit form is not implemented here. Edits should not be done on comment create. -->

<#include "editorparams.inc.ftl" />

<#assign controlId = fieldHtmlId + "-cntrl">


  <#if form.mode == "view">
    <#if field.control.params.rows??><#assign rows=field.control.params.rows><#else><#assign rows=5></#if>
    <#if field.control.params.columns??>
      <#assign columns=field.control.params.columns>
    <#else>
      <#assign columns=60>
    </#if>
    <div class="form-field ajax-comments-view">

    <#if !(field.control.params.hideCommentTextarea?? && field.control.params.hideCommentTextarea == "true")>
      <div style="display: block;font-weight: bold" class="hide-in-print-view">
      	<div>${msg("form.label.comment.write")}</div>
          <!--div class="yui-u"-->
          <!--start -->
          <script type="text/javascript">//<![CDATA[
            (function() {
                require([Alfresco.constants.URL_RESCONTEXT + "components/form/rich-text.js",
                         Alfresco.constants.URL_RESCONTEXT + "js/lyse/allsites/LyseRichTextControl.js",
                         Alfresco.constants.URL_RESCONTEXT + "components/form/comments.js"], function(){
                 var art=new Alfresco.LyseRichTextControl("${fieldHtmlId}").setOptions(
                      {
                              <#if form.mode == "view" || (field.disabled && !(field.control.params.forceEditable?? && field.control.params.forceEditable == "true"))>disabled: false,</#if>
                          currentValue: "${field.value?string}",
                          mandatory: ${field.mandatory?string},
                          <@editorParameters field />
                      }).setMessages(${messages});


               var commentsControl = new Alfresco.CommentsControls("${fieldHtmlId}-list").setOptions({
                   height: ${args.editorHeight!180},
                   width: ${args.editorWidth!700},

               	  commentTopic: "Comments",

                   <#if (form.mode == "view") && args.itemId??>
                      itemNodeRef: "${args.itemId?string}"
                   <#else>
                      itemNodeRef: ""
                   </#if>
                   
               }).setMessages(${messages});
               commentsControl.onReady();  <#-- Seems to be necessary when loaded from Ajax -->


               <#-- Add listener to Comments submit button. -->
               YAHOO.util.Event.addListener("${fieldHtmlId}-list-form-submit-button","click",function(e){
                 var clickedButton = e.target;
                 <#-- Strip HTML tags and &nbsp; so we can check if the comment is really empty -->
                 var stripHTML = /<\S[^><]*>/g;
                 var commentText = art.editor.getContent({format: 'html'}).replace(stripHTML, "").replace(/&nbsp;/g,"");
                 if (YAHOO.lang.trim(commentText).length > 0) {
                   clickedButton.disabled = true;
                   
				   <#if (field.control.params.commentRestriction?? && field.control.params.commentRestriction == "true")>   
				   
				   var restrictionDialog = function(html){
			          
			          var prompt = Alfresco.util.PopupManager.getUserInput({
			            title: Alfresco.util.message("comment.restriction.popup.label"),
			            buttons: [
			              {
			                  text: Alfresco.util.message("comment.restriction.add"),
			                  handler: function () {
			                    var e = document.getElementById("restrictbox");
			                    var selectedRestriction = e.options[e.selectedIndex].value;
			
			                    postComment(selectedRestriction);
			                    this.destroy();
			                  },
			                  isDefault: true
			              },
			              {
			                  text: Alfresco.util.message("comment.restriction.cancel"),
			                  handler: function () {
			                      this.destroy();
			                      clickedButton.disabled = false;
			                  }
			              }],
			            html: html
			            });
			
			         // Make OK button enabled.
			         var okButton = prompt.getButtons()[0];
			         okButton.set("disabled", false);  	
			       };			   		
			       var nodeRef = new Alfresco.util.NodeRef("${args.itemId?string}");
		            // Get the restriction options for this nodeRef
		            Alfresco.util.Ajax.jsonGet(
		            {
		               url: Alfresco.constants.PROXY_URI + "api/lyse/comment/restrictions/"+encodeURI(nodeRef.uri),
		               successCallback:
		               {
		                fn: function (response){
		   	               if (response.json !== undefined)
		   	               {
		   	               	 var selections = "";
		   	               	 var items = response.json;
		   	               	
		   	            	 for (var i = 0; i<items.length;  i++)
  					         {
  					         	selections = selections + '<option value="' + items[i].value + '">' + items[i].label +'</option>\n';
  					         }
  					         var html = '<select id="restrictbox">'+selections+'</select>';
  					         restrictionDialog(html); 
		   	               }
		   	            },
		                scope: this
		               }
		            });
   
   					
				   <#else>
				   	<#if !(field.control.params.companyInternal?? && field.control.params.companyInternal == "true")>
				   		postComment("ALL");
				   	<#else>
	                    postComment("INTERNAL");             
	               	</#if>
				   </#if>          
                   
                   function postComment(restrictionValue){
	                   Alfresco.util.Ajax.jsonPost({
                            url: Alfresco.constants.PROXY_URI + "api/lyse/${args.itemId?replace('://','/')}/comment?restriction=" + restrictionValue,
                            dataObj: {
                                content: art.editor.getContent()
                            },
                            successCallback: {
                                fn: function () {
                                    // Clear editor and reload comments
                                    art.editor.setContent("");
                                    commentsControl._loadCommentsList(0);
                                    clickedButton.disabled = false;
                                },
                                scope: this
                            },
                           failureCallback: {
                               fn: function () {
                                   commentsControl._loadCommentsList(0);
                                   clickedButton.disabled = false;
                                   Alfresco.util.PopupManager.displayPrompt(
                                   {
                                       title: Alfresco.util.message("message.failure", this.name),
                                       text: "Failed to add comment!"
                                   });
                               },
                               scope: this
                           }
	                   });
	               }
                 }
               });
              });
            })();
          //]]></script>

          <textarea id="${fieldHtmlId}" name="${field.name}" rows="${rows}" columns="${columns}" tabindex="0"
                    <#if field.description??>title="${field.description}"</#if>
                    <#if field.control.params.styleClass??>class="${field.control.params.styleClass}"</#if>
                    <#if field.control.params.style??>style="${field.control.params.style}"</#if>
                    <#if field.disabled && !(field.control.params.forceEditable?? && field.control.params.forceEditable == "true")>disabled="false"</#if>></textarea>

      <!--end-->

      </div>
    </#if>

    <br />
    <br />

    
    <div>
      <input id="${fieldHtmlId}-list-form-submit-button" type="button" value="${msg("form.label.comment.add")}"/>
    </div>
    
  </#if>

  <#-- Common for edit and view -->
  <div id="${fieldHtmlId}-list" class="comment-list" style="display:none;">
    <div class="postlist-infobar">
      <div id="${fieldHtmlId}-list-paginator" class="paginator"></div>
    </div>
    <div class="clear"></div>

          	<h3>${msg("form.label.comments")}</h3>
         
    <div id="${fieldHtmlId}-list-comments"></div>
  </div>
