<#include "editorparams.inc.ftl" />
<#if field.control.params.rows??><#assign rows=field.control.params.rows><#else><#assign rows=8></#if>
<#if field.control.params.columns??><#assign columns=field.control.params.columns><#else><#assign columns=60></#if>

<div class="form-field">
<#if form.mode == "view">
    <div class="viewmode-field">
        <#if field.mandatory && field.value == "">
        <span class="incomplete-warning"><img src="${url.context}/res/components/form/images/warning-16.png" title="${msg("form.field.incomplete")}" /><span>
        </#if>
        <span class="viewmode-label">${field.label?html}:</span>
        <span class="viewmode-value">
            <#if field.value == "">
                ${msg("form.control.novalue")}
            <#else>
                <textarea id="${fieldHtmlId}" name="${field.name}" rows="${rows}" columns="${columns}" tabindex="0"
                          <#if field.description??>title="${field.description}"</#if>
                          <#if field.control.params.styleClass??>class="${field.control.params.styleClass}"</#if>
                          <#if field.control.params.style??>style="${field.control.params.style}"</#if>>
                    ${field.value?html}
                </textarea>
                <div class="print-richtext" style="display:none;">
                	${field.value?string}
                </div>
            </#if>
        </span>
    </div>
<#else>

    <label for="${fieldHtmlId}">${field.label?html}:<#if field.mandatory><span class="mandatory-indicator">${msg("form.required.fields.marker")}</span></#if></label>
   <textarea id="${fieldHtmlId}" name="${field.name}" rows="${rows}" columns="${columns}" tabindex="0"
             <#if field.description??>title="${field.description}"</#if>
             <#if field.control.params.styleClass??>class="${field.control.params.styleClass}"</#if>
             <#if field.control.params.style??>style="${field.control.params.style}"</#if>>
   ${field.value?html}
    </textarea>
</#if>
</div>

<script type="text/javascript">//<![CDATA[
(function() {
    require([Alfresco.constants.URL_RESCONTEXT + "components/form/rich-text.js", Alfresco.constants.URL_RESCONTEXT + "js/lyse/allsites/LyseRichTextControl.js"], function(){
        var art = new Alfresco.LyseRichTextControl("${fieldHtmlId}").setOptions(
                {
                    currentValue: "${field.value?js_string}",
                    mandatory: ${field.mandatory?string},
                    lyseChangeListenerAdded: false,
                <#if form.mode == "view">
                    <@editorParameters field true/>
                <#else>
                    <@editorParameters field />
                </#if>
                }).setMessages(${messages});
        YAHOO.Bubbling.on("editorInitialized", function() {
            if (!art.options.lyseChangeListenerAdded) {
                art.editor.getEditor().on('change', function() {
                    art._handleContentChange();
                });
                art.options.lyseChangeListenerAdded = true;
            }
        });
    });
})();
//]]></script>
