<#include "/org/alfresco/components/form/controls/common/utils.inc.ftl" />

<#if field.control.params.optionSeparator??>
   <#assign optionSeparator=field.control.params.optionSeparator>
<#else>
   <#assign optionSeparator=",">
</#if>
<#if field.control.params.labelSeparator??>
   <#assign labelSeparator=field.control.params.labelSeparator>
<#else>
   <#assign labelSeparator="|">
</#if>

<div class="form-field">
   <#if form.mode == "view">
      <div class="viewmode-field">
         <#if field.mandatory && !(field.value?is_number) && field.value?string == "">
            <span class="incomplete-warning"><img src="${url.context}/res/components/form/images/warning-16.png" title="${msg("form.field.incomplete")}" /><span>
         </#if>
         <span class="viewmode-label">${field.label?html}:</span>
         <#if field.value?string == "">
            <#assign valueToShow=msg("form.control.novalue")>
         <#else>
            <#assign valueToShow=field.value>
            <#if field.control.params.options??>
              <#list field.control.params.options?split(optionSeparator) as nameValue>
                 <#if nameValue?index_of(labelSeparator) == -1>
                    <#if nameValue == field.value?string || (field.value?is_number && field.value?c == nameValue)>
                       <#assign valueToShow=nameValue>
                       <#break>
                    </#if>
                 <#else>
                    <#assign choice=nameValue?split(labelSeparator)>
                    <#if choice[0] == field.value?string || (field.value?is_number && field.value?c == choice[0])>
                       <#assign valueToShow=msgValue(choice[1])>
                       <#break>
                    </#if>
                 </#if>
              </#list>
            </#if>
         </#if>
         <span class="viewmode-value">${valueToShow?html}</span>
      </div>
   <#else>
   <script>//<![CDATA[

       
    var options = {};
    options.selectedValue = "${field.value}";
    options.datalistType = window.RPLP.selectedNodeType.replace(":","_");
    // Set default value if missing
    if (options.datalistType==''){
      options.datalistType = 'lysedl_issueList';
    }
    
    var selectTemplate = new RPLP.SelectTemplate("${fieldHtmlId}").setOptions(options);

  //]]></script>
      <label for="${fieldHtmlId}">${field.label?html}:<#if field.mandatory><span class="mandatory-indicator">${msg("form.required.fields.marker")}</span></#if></label>
         <select onchange="selectTemplate.onChange(this);" id="${fieldHtmlId}" name="${field.name}" tabindex="0"
               <#if field.description??>title="${field.description}"</#if>
               <#if field.control.params.size??>size="${field.control.params.size}"</#if>
               <#if field.control.params.styleClass??>class="${field.control.params.styleClass}"</#if>
               <#if field.control.params.style??>style="${field.control.params.style}"</#if>
               <#if field.disabled  && !(field.control.params.forceEditable?? && field.control.params.forceEditable == "true")>disabled="true"</#if>>
               <option>Loading...</option>
         </select>
         <@formLib.renderFieldHelp field=field />
      
   </#if>
</div>
<div class="form-field">
  <input id="${fieldHtmlId}-defaultfilename" name="${field.name}-filename" type="hidden"/>
</div>