<#-- @overridden projects/web-framework-commons/config/alfresco/site-webscripts/org/alfresco/components/form/controls/authority.ftl -->
<#-- This picker uses the 'startLocation' option from the form-config to retrieve a node ref used as a site context for user search. -->
<#-- The picker will also automatically do a search for '*' to show all users in the site-->

<#include "/org/alfresco/components/form/controls/common/picker.inc.ftl" />


<#if field.control.params.defaultSearchTerm??>
  <#assign defaultSearchTerm=field.control.params.defaultSearchTerm>
<#else>
  <#assign defaultSearchTerm="*">
</#if>

<#if field.control.params.excludeConsumers??>
  <#assign excludeConsumers=field.control.params.excludeConsumers == "true" />
<#else>
  <#assign excludeConsumers=false />
</#if>

<#-- Make it possible to override the multipleSelect-mode from the association settings.-->
<#if field.control.params.multipleSelect??>
  <#assign multipleSelect=field.control.params.multipleSelect == "true" />
<#else>
  <#assign multipleSelect= field.endpointMany />
</#if>

<#if field.control.params.includeBaseGroups??>
  <#assign includeBaseGroups=field.control.params.includeBaseGroups == "true" />
<#else>
  <#assign includeBaseGroups=false />
</#if>

<#if field.control.params.excludeContractorGroups??>
  <#assign excludeContractorGroups=field.control.params.excludeContractorGroups == "true" />
<#else>
  <#assign excludeContractorGroups=false />
</#if>
<#if field.control.params.excludeContainerGroups??>
  <#assign excludeContainerGroups=field.control.params.excludeContainerGroups == "true" />
<#else>
  <#assign excludeContainerGroups=false />
</#if>

<#if field.control.params.includeOnlyCommGroups??>
  <#assign includeOnlyCommGroups=field.control.params.includeOnlyCommGroups == "true" />
<#else>
  <#assign includeOnlyCommGroups=false />
</#if>

<#assign controlId = fieldHtmlId + "-cntrl">

<script type="text/javascript">//<![CDATA[
  (function()
  {
    <@renderPickerJS field "picker" />
    picker.setOptions(
      {
        <#if field.control.params.itemType??>
        <#-- This was added because parameters defined in an ActionExecuter of type NODE_REF are always cm:object -->
        itemType: "${field.control.params.itemType?string}",
        <#else>
        itemType: "${field.endpointType}",
        </#if>
        multipleSelectMode: ${multipleSelect?string},
        itemFamily: "authority",
        siteShortName: Alfresco.constants.SITE,
        excludeConsumers : "${excludeConsumers?string('true', 'false')}",
	      includeBaseGroups : "${includeBaseGroups?string('true', 'false')}",
        excludeContractorGroups : "${excludeContractorGroups?string('true', 'false')}",
        excludeContainerGroups : "${excludeContainerGroups?string('true', 'false')}",
        includeOnlyCommGroups : "${includeOnlyCommGroups?string('true', 'false')}",
        relatedSiteTypeToFetchFrom : "${field.control.params.relatedSiteTypeToFetchFrom!"none"}",
        <#if field.control.params.addNone??>
        addNoneOption: "${field.control.params.addNone}",
        </#if>
        <#if field.control.params.includeAnonymous??>
	        includeAnonymous: "${field.control.params.includeAnonymous}",
	    </#if>

        finderAPI: Alfresco.constants.PROXY_URI + "api/lyse/forms/site-users/authority"
      });
    var me = this;
    var initSiteAuthorityPicker = function (layer, args) {
      // Unsubscribe since we only want to run this once, else it will break other picker dialogs
      YAHOO.Bubbling.unsubscribe("afterFormRuntimeInit", initSiteAuthorityPicker, me);
      var startLocation = picker.options.startLocation;
      if(startLocation && startLocation !== null)
      {
        if(startLocation == "{self}") {
          picker.setOptions(
            {
              startLocation: startLocation
            });
        }
        else {
          // Get a nodeRef from a form field
          var siteNodeRef = document.getElementsByName(startLocation).length > 0 ? document.getElementsByName(startLocation)[0].value : null;

          if(siteNodeRef !== null && siteNodeRef !== undefined) {
            picker.setOptions(
              {
                startLocation: siteNodeRef
              });
          }
        }
      }

      var defaultSearch = function (layer, args) {
        // Unsubscribe since we only want to run this once, else it will break other picker dialogs
        YAHOO.Bubbling.unsubscribe("objectFinderReady", defaultSearch, me);
        var searchTextField = Dom.get(picker.pickerId + "-searchText");
        if (searchTextField) {
          searchTextField.value = "${defaultSearchTerm}";
        }
      };
      YAHOO.Bubbling.on("objectFinderReady", defaultSearch, this);
    };

   YAHOO.util.Event.onDOMReady(
    function () {
      YAHOO.Bubbling.on('resetForm', function (layer, args) {
            var displayValue = Dom.get('${controlId}-currentValueDisplay');
            if (displayValue !== undefined && displayValue !== null){
            	displayValue.innerHTML = "";
            }
            var hiddenValue = Dom.get('${controlId}-added');
            if (hiddenValue !== undefined && hiddenValue !== null){
            	hiddenValue.value = "";
            }
            picker.selectedItems =  {};
	  });
    });

    YAHOO.Bubbling.on("afterFormRuntimeInit", initSiteAuthorityPicker, this);
  })();
  //]]></script>


<div class="form-field" >
  <#if form.mode == "view">
    <div id="${controlId}" class="viewmode-field">
      <#if field.endpointMandatory && field.value == "">
      <span class="incomplete-warning"><img src="${url.context}/res/components/form/images/warning-16.png" title="${msg("form.field.incomplete")}" /><span>
         </#if>
         <span class="viewmode-label">${field.label?html}:</span>
         <span id="${controlId}-currentValueDisplay" class="viewmode-value current-values"></span>
      </div>
   <#else>
      <label for="${controlId}">${field.label?html}:<#if field.endpointMandatory><span class="mandatory-indicator">${msg("form.required.fields.marker")}</span></#if></label>

      <div id="${controlId}" class="object-finder">

         <div id="${controlId}-currentValueDisplay" class="current-values"></div>

         <#if field.disabled == false>
            <input type="hidden" id="${fieldHtmlId}" name="-" value="${field.value?html}" />
            <input type="hidden" id="${controlId}-added" name="${field.name}_added" />
            <input type="hidden" id="${controlId}-removed" name="${field.name}_removed" />
            <div id="${controlId}-itemGroupActions" class="show-picker"></div>

            <@renderPickerHTML controlId />
         </#if>
      </div>
   </#if>
</div>



