<@markup id="css" >
	<@link href="${url.context}/res/components/comments/comments-list.css" group="comments"/>
    <@link href="${url.context}/res/components/data-lists/datalist-details.css" />
</@>

<@markup id="js">
<#-- JavaScript Dependencies -->
    <@script src="${url.context}/res/components/workflow/lyse-workflow-history.js" />
    <@script type="text/javascript" src="${url.context}/res/components/data-lists/datalist-details-actions.js" />
</@>

<@markup id="widgets">
    <@createWidgets/>
</@>


<@markup id="html">
<#assign id=args.htmlid?html>

<style>

	.dropdown-hidden{
		display: none !important;
	}

    .dropdown {
        position: relative;
        display: inline-block;
    }

    #dropdown-button
    {
        background-color: #f9f9f9;
    }

    .dropdown-content {
        display: none;
        position: absolute;
        background-color: #f9f9f9;
        box-shadow: 8px 8px 16px 0px rgba(0,0,0,0.2);
        padding: 0px 0px;
        z-index: 1;
    }

    .dropdown:hover .dropdown-content {
        display: block;
    }

    .dropdown-content button {
        width:160px;

    }
    .share-form{
        border-bottom:1px dashed #c2c2c2;
        <#if hide>display:none;</#if>

    }
</style>

<div class="share-form">
    <div class="form-manager buttons">
        <div class="buttons-container">
            <ul id="lyse-main-navigation">
	            <div class="datalist-details-wrapper">
	            	<li>
		                <button id="task">${msg("actions.task")}</button>
		                <div class="dropdown-content">
			                <ul id="task-buttons">
			        			<li>
			                        <button id="${id}-submit-for-review">${msg("actions.submit-for-review")}</button>
			                    </li>
			                    <li>
                                  <#if isMQ?? && isMQ == true>
                                    <button id="${id}-start-workflow">${msg("actions.start-new-mq-version")}</button>
                                  <#else>
			                        <button id="${id}-start-workflow">${msg("actions.start-workflow")}</button>
                                  </#if>
			                    </li>
			                </ul>
		            	</div>
	                </li>
	            </div>
	            <div class="datalist-details-wrapper">
	            	<li>
		                <button id="share-dropdown">${msg("actions.share")}</button>
		                <div class="dropdown-content">
		                    <ul id="share-dropdown-buttons">
		                    	<li>
					            	<button id="${id}-share-for-comment">${msg("actions.start-share-workflow.dropdown.for-commenting")}</button>
		                        </li>
		                        <li>
					            	<button id="${id}-share-for-information">${msg("actions.start-share-workflow.dropdown.for-information")}</button>
		                        </li>
		                    </ul>
		                </div>
	                </li>
	            </div>
	            <div class="datalist-details-wrapper">
	            	<li>
		                <button id="task-dropdown">${msg("actions.more")}</button>
		                <div class="dropdown-content">
		                    <ul id="task-dropdown-buttons">
                                <li>
                                  <button id="${id}-with-all-comments">${msg("action.print")}</button>
                                </li>
		                        <li>
		                            <button id="${id}-share-history-list">${msg("actions.show-share-history")}</button>
		                        </li>
		                        <li>
		                            <button id="${id}-workflow-history-list">${msg("actions.show-workflow-history")}</button>
		                        </li>
		                        <li>
		                            <button id="${id}-upload-revision">${msg("actions.upload-new-revision")}</button>
		                        </li>
		                    </ul>
		                </div>
	                </li>
	            </div>
	            <div id="delete-buttopn-wrapper" class="datalist-details-wrapper">
		        	<li>
						<button id="${id}-delete">${msg("actions.delete")}</button>
					</li>
				</div>
	            <div id="edit-buttopn-wrapper" class="datalist-details-wrapper">
		        	<li>
						<button id="${id}-edit">${msg("actions.edit")}</button>
					</li>
				</div>
	            <div class="datalist-details-wrapper">
		            <li>
		            	<button id="close-button" onclick="window.close()">${msg("button.close.window")}</button>
		            </li>
	        	</div>
            </ul>
        </div>
    </div>
    <h1 id="data-list-item-header">${msg("header.task.information")}</h1>
</div>
</@>
