model.jsonModel = {
  widgets: [
    {
      name: "lyse/reports/overview",
      config: {
        dataLists:
          [
            {
              dataList: "actionlistmember",
              dataListName: "Action Per Member",
              sitetype:"contractor-project",
              dataListURLParam: "Actions",
              responsibleUser : "taskResponsible",
              filterStatusProperty:"prop_lyse_genericActionReviewStatus",
              filterStatusConstraints: {
                "draft_count": "draft",
                "action_count": "action",
                "for_closing_count": "for_closing",
                "done_count": "done",
                "closed_count": "closed"
              },
              filterBeforeOverdueProperties: {
                "prop_lyse_genericActionDueDate":"prop_lyse_genericActionReviewStatus%253Daction"
              },
              filterOverdueProperties: {
                 "overdue_count": "prop_lyse_genericActionDueDate"
              },
              columns: ['user', 'draft_count', 'action_count', 'done_count', 'overdue_count', 'for_closing_count', 'closed_count', 'user_total'],
              showChart: false,
              orderList: false,
              showTotals: true,
            },
            {
              dataList: "civilactionlistmember",
              dataListName: "Action Per Member",
              sitetype:"civil-site",
              dataListURLParam: "Actions",
              responsibleUser : "taskResponsible",
              filterStatusProperty:"prop_lyse_genericActionReviewStatus",
              filterStatusConstraints: {
                "draft_count": "draft",
                "action_count": "action",
                "for_closing_count": "for_closing",
                "done_count": "done",
                "closed_count": "closed"
              },
              filterBeforeOverdueProperties: {
                "prop_lyse_genericActionDueDate":"prop_lyse_genericActionReviewStatus%253Daction"
              },
              filterOverdueProperties: {
                 "overdue_count": "prop_lyse_genericActionDueDate"
              },
              columns: ['user', 'draft_count', 'action_count', 'done_count', 'overdue_count', 'for_closing_count', 'closed_count', 'user_total'],
              showChart: false,
              orderList: false,
              showTotals: true,
            },
            {
              dataList: "interfaceactionlistmember",
              dataListName: "Action Per Member",
              sitetype:"interface-site",
              dataListURLParam: "Actions",
              responsibleUser : "taskResponsible",
              filterStatusProperty:"prop_lyse_genericActionReviewStatus",
              filterStatusConstraints: {
                "draft_count": "draft",
                "action_count": "action",
                "for_closing_count": "for_closing",
                "done_count": "done",
                "closed_count": "closed"
              },
              filterBeforeOverdueProperties: {
                "prop_lyse_genericActionDueDate":"prop_lyse_genericActionReviewStatus%3Daction"
              },
              filterOverdueProperties: {
                 "overdue_count": "prop_lyse_genericActionDueDate"
              },
              columns: ['user', 'draft_count', 'action_count', 'done_count', 'overdue_count', 'for_closing_count', 'closed_count', 'user_total'],
              showChart: false,
              orderList: false,
              showTotals: true,
            },
            {
              dataList: "engineeringactionlistmember",
              dataListName: "Action Per Member",
              sitetype:"epc-engineering-site",
              dataListURLParam: "Actions",
              responsibleUser : "taskResponsible",
              filterStatusProperty:"prop_lyse_genericActionReviewStatus",
              filterStatusConstraints: {
                "draft_count": "draft",
                "action_count": "action",
                "for_closing_count": "for_closing",
                "done_count": "done",
                "closed_count": "closed"
              },
              filterBeforeOverdueProperties: {
                "prop_lyse_genericActionDueDate":"prop_lyse_genericActionReviewStatus%253Daction"
              },
              filterOverdueProperties: {
                 "overdue_count": "prop_lyse_genericActionDueDate"
              },
              columns: ['user', 'draft_count', 'action_count', 'done_count', 'overdue_count', 'for_closing_count', 'closed_count', 'user_total'],
              showChart: false,
              orderList: false,
              showTotals: true
            }
          ],
        overrides:
          [
            {
              dataList: "mcc-signals-test-status-remote",
              override: "mccSignal",
              dataListName: "Signals - Test status (remote)",
              sitetype:"mcc-site",
              showChart: true,
              orderList: false,
              dataListURLParam: "Signals",
              uniqueCartId: "SignalsR",
              filterStatusProperty: "prop_lyse_mccSignalTestStatusRemote",
              filterStatusConstraints: {
                "New or Revised": "New or Revised",
                "For Approval": "For Approval",
                "Approved": "Approved",
                "Approved with comments": "Approved with comments",
                "Rejected": "Rejected",
                "Voided": "Voided",
                "Not applicable":"Not applicable"
              }
            },
            {
              dataList: "mcc-signals-test-status-local",
              override: "mccSignal",
              dataListName: "Signals - Test status (local)",
              sitetype:"mcc-site",
              showChart: true,
              orderList: false,
              dataListURLParam: "Signals",
              uniqueCartId: "SignalsL",
              filterStatusProperty: "prop_lyse_mccSignalTestStatusLocal",
              filterStatusConstraints: {
                "New or Revised": "New or Revised",
                "For Approval": "For Approval",
                "Approved": "Approved",
                "Approved with comments": "Approved with comments",
                "Rejected": "Rejected",
                "Voided": "Voided"
              }
            },
            {
              dataList: "mcc-cables-test-status",
              override: "mccCables",
              dataListName: "Cables - Test status",
              sitetype:"mcc-site",
              showChart: true,
              orderList: false,
              dataListURLParam: "Cables",
              filterStatusProperty: "prop_lyse_mccCablesTestStatus",
              filterStatusConstraints: {
                "New or Revised": "New or Revised",
                "For Approval": "For Approval",
                "Approved": "Approved",
                "Approved with comments": "Approved with comments",
                "Rejected": "Rejected",
                "Voided": "Voided"
              }
            }
          ],
        extensions:
          [
            {
              extend: "milestoneItem",
              filterBeforeOverdueProperties: {
                "prop_lysedl_milestoneDate":"prop_lysedl_milestoneStatus%3Dfor_approval,not_approved,invoice_for_approval"
              },
              showTotals: true,
              excludeFromTotalCount: ["Overdue"]
            },
            {
              extend: "civilMilestone",
              filterBeforeOverdueProperties: {
                "prop_lyse_civilMilestoneDate":"prop_lyse_civilMilestoneStatus%3Dfor_approval,not_approved,invoice_for_approval"
              },
              showTotals: true,
              excludeFromTotalCount: ["Overdue"]
            },
             {
          		extend: "actionWithProject",
                filterBeforeOverdueProperties: {
              	  "prop_lyse_actionWithProjectDueDate":"prop_lyse_actionWithProjectReviewStatus%3Daction,for_closing"
                }
            },
            {
              extend: "punchList",
              filterBeforeOverdueProperties: {
                "prop_lyse_punchDueDate":"prop_lyse_punchReviewStatus%3Dfor_action"
              }
            },
            {
              extend: "civilPunchList",
              filterBeforeOverdueProperties: {
                "prop_lyse_civilpunchDueDate":"prop_lyse_civilpunchReviewStatus%3Dfor_action"
              }
            },
            {
              extend: "civilTechnicalQuery",
              filterBeforeOverdueProperties: {
                "prop_lyse_civilTqDueDate":"prop_lyse_civilTqStatus%3Dfor_clarification"
              }
            },
            {
              extend: "issueList",
              filterBeforeOverdueProperties: {
                "prop_lysedl_issueDueDate":"prop_lysedl_issueStatus%3Daction"
              },
              uniqueCartId: "issueListR"
            },
            {
              extend: "genericDocumentList",
              forceLinks: true
            },
            {
              extend: "genericActionList",
              forceLinks: true,
              filterBeforeOverdueProperties: {
                "prop_lyse_genericActionDueDate":"prop_lyse_genericActionReviewStatus%3Daction,for_closing"
              },
              filterStatusConstraints: {
                "For action": "action",
                "Closed": "closed",
                "For closing": "for_closing"
              },
              orderList: [
                "Draft",
                "For action",
                "For closing",
                "Closed",
                "Overdue"
              ]
            },
            {
              extend: "ncrList",
              filterBeforeOverdueProperties: {
                "prop_lysedl_ncrDate":"prop_lysedl_ncrStatus%3Dreview"
              }
            },
            {
              extend: "correspondenceItem",
              filterBeforeOverdueProperties: {
                "prop_lysedl_correspondenceDueDate":"prop_lysedl_correspondenceStatus%3Dopen"
              }
            },
            {
              extend: "civilCorrespondenceItem",
              filterBeforeOverdueProperties: {
                "prop_lysedl_civilCorrespondenceDueDate":"prop_lysedl_civilCorrespondenceStatus%3Dopen"
              }
            },
            {
              extend: "civilMeasuredQuantity",
              filterBeforeOverdueProperties: {
                "prop_lyse_civilMqBillDate":"prop_lyse_civilMqStatus%3Dnot_started"
              }
            },
            {
              extend: "cdlDataList",
              filterBeforeOverdueProperties: {
                "prop_lyse_cdlDueDate":"prop_lyse_cdlReviewStatus%3Ddraft",
                "prop_lyse_cdlReviewDueDate":"prop_lyse_cdlReviewStatus%3DcompanyReview"
              },
              filterOverdueProperties: {
                "Document overdue": "prop_lyse_cdlDueDate",
                "Review overdue": "prop_lyse_cdlReviewDueDate"
              }
            },
            {
              extend: "civilCdlDataList",
              filterBeforeOverdueProperties: {
                "prop_lyse_civilCdlDueDate":"prop_lyse_civilCdlReviewStatus%3Ddraft",
                "prop_lyse_civilCdlReviewDueDate":"prop_lyse_civilCdlReviewStatus%3DcompanyReview"
              },
              filterOverdueProperties: {
                "Document overdue": "prop_lyse_civilCdlDueDate",
                "Review overdue": "prop_lyse_civilCdlReviewDueDate"
              }
            },
            {
              extend: "contractDataList",
              filterBeforeOverdueProperties: {
                "prop_lyse_cdlDueDate":"prop_lyse_cdlReviewStatus%3Ddraft",
                "prop_lyse_cdlReviewDueDate":"prop_lyse_cdlReviewStatus%3DcompanyReview"
              },
              filterOverdueProperties: {
                "Document overdue": "prop_lyse_cdlDueDate",
                "Review overdue": "prop_lyse_cdlReviewDueDate"
              }
            },
            {
              extend: "civilContractDataList",
              filterBeforeOverdueProperties: {
                "prop_lyse_civilCdlDueDate":"prop_lyse_civilCdlReviewStatus%3Ddraft",
                "prop_lyse_civilCdlReviewDueDate":"prop_lyse_civilCdlReviewStatus%3DcompanyReview"
              },
              filterOverdueProperties: {
                "Document overdue": "prop_lyse_civilCdlDueDate",
                "Review overdue": "prop_lyse_civilCdlReviewDueDate"
              }
            },
            {
              extend: "civilAction",
              filterBeforeOverdueProperties: {
                "prop_lyse_hseDueDate":"prop_lyse_civilActionReviewStatus%3Daction"
              },
              uniqueCartId: "civilActionR"
            },
            {
              extend: "mccAction",
              filterBeforeOverdueProperties: {
                "prop_lyse_mccDueDate":"prop_lyse_mccActionReviewStatus%3Daction,for_closing"
              }
            },
            {
              extend: "interfaceAction",
              filterBeforeOverdueProperties: {
                "prop_lysedl_interfaceActionDueDate":"prop_lysedl_interfaceActionStatus%3Daction,for_closing"
              },
              uniqueCartId: "interfaceActionR"
            },
            {
              extend: "hseAction",
              filterBeforeOverdueProperties: {
                "prop_lyse_hseDueDate":"prop_lyse_hseActionReviewStatus%3Daction,for_closing"
              }
            },
            {
              extend: "ruiList",
              filterBeforeOverdueProperties: {
                "prop_lyse_hseDueDate":"prop_lyse_ruiReviewStatus%3Dfor_action,for_closing"
              }
            },
            {
              extend: "riskReducingMeasures",
              filterBeforeOverdueProperties: {
                "prop_lyse_hseDueDate":"prop_lyse_rrmStatus%3Dfor_action,done"
              }
            },
            {
              extend: "sjaDataList",
              filterBeforeOverdueProperties: {
                "prop_lyse_hseDueDate":"prop_lyse_sjaStatus%3Dfor_action"
              }
            },
            {
              extend: "irlDataList",
              filterBeforeOverdueProperties: {
                "prop_lyse_irlDueDate":"prop_lyse_irlReviewStatus%3DdiscussionSupplier,discussionDefiner,agree"
              }
            },
            {
              extend: "companysDocumentDataList",
              filterBeforeOverdueProperties: {
                "prop_lyse_companysDocumentDueDate":"prop_lyse_companysDocumentReviewStatus%3Ddraft",
                "prop_lyse_companysDocumentReviewDueDate":"prop_lyse_companysDocumentReviewStatus%3DcompanyReview"
              },
              filterOverdueProperties: {
                "Document overdue": "prop_lyse_companysDocumentDueDate",
                "Review overdue": "prop_lyse_companysDocumentReviewDueDate"
              },
              orderList: [
                "Not started",
                "Voided",
                "Review in progress",
                "Approved with comments",
                "Approved",
                "IFC",
                "Redlined",
                "As Built",
                "Revoked",
                "Rejected",
                "Review overdue",
                "Document overdue"
              ]
            },
            {
              extend: "variationOrderRequestItem",
              showTotals: true,
              excludeFromTotalCount: ["VOR-withdrawn"],
              orderList: [
                "DVO",
                "DVO-returned",
                "DVO-contrasigned",
                "DVO-closed",
                "VO-draft",
                "VO",
                "VO-returned",
                "VO-contrasigned",
                "VO-closed",
                "VOR-draft",
                "VOR",
                "VOR-returned",
                "VOR-withdrawn"
              ]
            },
            {
              extend: "civilVariationOrderRequestItem",
              showTotals: true
            },
            {
              extend: "qaList",
              filterBeforeOverdueProperties: {
                "prop_lyse_qaDueDate":"prop_lyse_qaReviewStatus%3Dfor_action",
                showTotals: true
              }
            },
            {
              extend: "siteQueries",
              filterBeforeOverdueProperties: {
                "prop_lyse_siteQueryNgDueDate":"prop_lyse_siteQueryNgStatus%3Dfor_clarification",
                showTotals: true
              }
            }
          ]
      }
    },
  ]
};
