<@markup id="css" >
   <#-- No CSS Dependencies -->
</@>

<@markup id="js">
   <#-- No JavaScript Dependencies -->
</@>

<@markup id="widgets">
   <@createWidgets group="dashlets"/>
</@>

<@markup id="html">
   <@uniqueIdDiv>
      <div class="dashlet site-profile">
         <div class="title">${msg("header.projectInformation")}</div>
         <div class="body">
            <div class="msg dashlet-padding">
            	<#if projectInformation??>
              	<h2>${projectInformation.projectName!"Project"}</h2><br />
  
              	<#if projectInformation.projectLevelLabel?has_content><span>${msg("label.projectLevel")}: ${projectInformation.projectLevelLabel}</span><br /></#if>
             		<#if projectInformation.projectProgramName?has_content><span>${msg("label.projectProgramName")}: ${projectInformation.projectProgramName}</span><br /></#if>
              	<#if projectInformation.projectNumber?has_content><span>${msg("label.projectNumber")}: ${projectInformation.projectNumber}</span><br /></#if>
              	<#if projectInformation.projectCaseNumbers?has_content><span>${msg("label.projectCaseNumber")}: ${projectInformation.projectCaseNumbers}</span><br /></#if>
              	<#if projectInformation.projectStatusLabel?has_content><span>${msg("label.projectStatus")}: ${projectInformation.projectStatusLabel}</span><br /></#if>
              	<#if projectInformation.projectStartDate?has_content><span>${msg("label.projectStartDate")}: ${projectInformation.projectStartDate}</span><br /></#if>
              	<#if projectInformation.projectEndDate?has_content><span>${msg("label.projectEndDate")}: ${projectInformation.projectEndDate}</span><br /></#if>
              	<#if projectInformation.projectTypeLabel?has_content><span>${msg("label.projectType")}: ${projectInformation.projectTypeLabel}</span><br /></#if>
              	<#if projectInformation.projectId?has_content><span>${msg("label.projectId")}: ${projectInformation.projectId}</span><br /></#if>
              	
              	<#if projectInformation.projectManagerUserName?has_content>
              	<span>
              		${msg("label.projectManagerName")}: <a href="${url.context}/page/user/${projectInformation.projectManagerUserName}/profile">${projectInformation.projectManagerName}</a>
              	</span>
              	</#if>
              	<br />
              	
              	<#if projectInformation.parents?has_content>
              		<br />
          	    	<h3>${msg("label.parentProjects")}</h3>
      	        	<div class="parent_list">
  	            		<#list projectInformation.parents as parent>
              				<span class="parent">
              					<a href="${url.context}/page/site/${parent.siteShortname}/dashboard">${parent.projectName}</a>
              					<#if parent_has_next><span> >></span></#if>
              				</span>
              			</#list>
              		</div>
              	<#else>
              		<!-- span>${msg("message.doesNotHaveParents")}</span -->
              	</#if>
              	
              	<#if projectInformation.children?has_content>
  	            	<br />
              		<h3>${msg("label.subProjects")}:</h3>
              		<ul class="child_list">
              			<#list projectInformation.children as child>
              				<li class="child">
              					<a href="${url.context}/page/site/${child.siteShortname}/dashboard">${child.projectName}</a>
              					<span class="project_type">(${child.projectLevelLabel})</span>
              				</li>
              			</#list>
              		</ul>
              	<#else>
              		<br />
              		<!-- span>${msg("message.doesNotHaveChildren")}</span -->
              	</#if>

            	<#else>
            		<span>${msg("message.errorWhileRenderingBasicInformation")}</span>
            	</#if>
            </div>
        
            <div class="clear"></div>
         </div>
      </div>
     <script type="text/javascript">//<![CDATA[
       document.title = "Unosys - Project Information";
       //]]>
     </script>
   </@>
</@>
