<#include "common/picker.inc.ftl" />

<#assign controlId = fieldHtmlId + "-cntrl">

<script type="text/javascript">//<![CDATA[
(function()
{
   <@renderPickerJS field "picker" />
   picker.setOptions(
   {
   <#if field.control.params.showTargetLink??>
      showLinkToTarget: ${field.control.params.showTargetLink},
      targetLinkTemplate: attachment_renderLinkTemplate,
   </#if>
   <#if field.control.params.allowNavigationToContentChildren??>
      allowNavigationToContentChildren: ${field.control.params.allowNavigationToContentChildren},
   </#if>
      itemType: "${field.endpointType}",
      multipleSelectMode: ${field.endpointMany?string},
      parentNodeRef: "alfresco://company/home",
      itemFamily: "node",
      displayMode: "${field.control.params.displayMode!"items"}"
   });
   new Alfresco.AttachmentControl("${controlId}-upload", "${fieldHtmlId}-upload").setOptions(
   {
   	objectFinder: picker
   }).setMessages(
      ${messages}
   );
})();

function attachment_renderLinkTemplate(item){
    var linkUrl = "${url.context}/page";

    if (item.site) {
        linkUrl += "/site/" + item.site;
    } else if (Alfresco.constants.SITE) {
        linkUrl += "/site/" + Alfresco.constants.SITE;
    }

	if (item.type == "app:filelink"){
		linkUrl += "/document-details?nodeRef=" + item.destination;
	}else if (item.type == "cm:folder"){
		linkUrl += "/folder-details?nodeRef=" + item.nodeRef;
	}else{
		linkUrl += "/document-details?nodeRef=" + item.nodeRef;
	}
    return linkUrl;
}

//]]></script>

<div class="form-field">
   <#if form.mode == "view">
      <div id="${controlId}" class="viewmode-field">
         <#if (field.endpointMandatory!false || field.mandatory!false) && field.value == "">
            <span class="incomplete-warning"><img src="${url.context}/res/components/form/images/warning-16.png" title="${msg("form.field.incomplete")}" /><span>
         </#if>
         <span class="viewmode-label">${field.label?html}:</span>
         <span id="${controlId}-currentValueDisplay" class="viewmode-value current-values"></span>
      </div>
   <#else>
      <label for="${controlId}">${field.label?html}:<#if field.endpointMandatory!false || field.mandatory!false><span class="mandatory-indicator">${msg("form.required.fields.marker")}</span></#if></label>

      <div id="${controlId}" class="object-finder">

         <div id="${controlId}-currentValueDisplay" class="current-values"></div>

         <#if field.disabled == false>
            <input type="hidden" id="${fieldHtmlId}" name="-" value="${field.value?html}" />
            <input type="hidden" id="${controlId}-added" name="${field.name}_added" />
            <input type="hidden" id="${controlId}-removed" name="${field.name}_removed" />
            <div id="${controlId}-itemGroupActions" class="show-picker"><span id="${controlId}-upload"><button id="${controlId}-upload-button">${msg("form.control.attachments.upload")}</button></span></div>
            <div id="${controlId}-upload-destination-dialog"></div>

            <@renderPickerHTML controlId />
         </#if>
      </div>
   </#if>
</div>
