<#include "/org/alfresco/components/form/controls/common/picker.inc.ftl" />

<#assign controlId = fieldHtmlId + "-cntrl">

<#if field.control.params.allowNavigation??>
<#assign allowNavigation=field.control.params.allowNavigation == "true" />
<#else>
<#assign allowNavigation=true />
</#if>

<#if field.control.params.multipleSelectMode??>
<#assign multipleSelectMode=field.control.params.multipleSelectMode == "true"/>
<#else>
<#assign multipleSelectMode=field.endpointMany/>
</#if>

<#assign allowUploadInViewMode=field.control.params.allowUploadInViewMode!"false"/>
<#assign uploadRevisions=field.control.params.uploadRevisions!"false"/>

<#if field.control.params.borderBoxStyleEnd??>
    <#assign borderBoxStyleEnd=field.control.params.borderBoxStyleEnd == "true" />
<#else>
    <#assign borderBoxStyleEnd= false />
</#if>

<script type="text/javascript">//<![CDATA[
(function()
{
   <#assign pickerJS>
     <@renderPickerJS field "picker" />
   </#assign>
   ${pickerJS?replace("Alfresco.ObjectFinder", "Alfresco.AttachmentControlMod")}
   picker.setOptions(
   {
   <#if field.control.params.showTargetLink??>
      showLinkToTarget: ${field.control.params.showTargetLink},
      targetLinkTemplate: attachment_renderLinkTemplate,
   </#if>
   <#if field.control.params.allowNavigationToContentChildren??>
      allowNavigationToContentChildren: ${field.control.params.allowNavigationToContentChildren},
   </#if>
   <#if form.mode == "view">
       allowRemoveAction: false,
   <#elseif field.control.params.allowRemoveAction??>
       allowRemoveAction: ${field.control.params.allowRemoveAction},
   </#if>
   <#if form.mode == "view">
       allowRemoveAllAction: false,
   <#elseif field.control.params.allowRemoveAllAction??>
       allowRemoveAllAction: ${field.control.params.allowRemoveAllAction},
   </#if>
      itemType: "${field.endpointType}",
      multipleSelectMode: ${multipleSelectMode?string("true", "false")},
      parentNodeRef: "alfresco://company/home",
      itemFamily: "node",
      displayMode: "${field.control.params.displayMode!"items"}",
      allowNavigation: ${allowNavigation?string("true", "false")},
      borderBoxStyleEnd: ${borderBoxStyleEnd?string},
      uploadRevisions: ${uploadRevisions?string},
    <#if field.control.params.startLocation??>
      startLocation: "${field.control.params.startLocation}",
      <#if args.itemId??>currentItem: "${args.itemId?js_string}",</#if>
      <#if form.mode == "create" && form.destination?? && form.destination?length &gt; 0>currentItem: "${form.destination?js_string}",</#if>
   </#if>
   <#if field.control.params.startLocationParams??>
      startLocationParams: "${field.control.params.startLocationParams?js_string}",
   </#if>
   <#if field.control.params.onlyDelete??>
      onlyDelete: ${field.control.params.onlyDelete?string},
   </#if>
   <#if field.control.params.allowUploadNewVersion??>
       allowUploadNewVersion: ${field.control.params.allowUploadNewVersion?string},
   </#if>
   <#if field.control.params.newVersionMandatory??>
       newVersionMandatory: ${field.control.params.newVersionMandatory?string},
   </#if>

   <#if form.mode == "view" && allowUploadInViewMode == "true" && !form.arguments.itemId?starts_with("versionStore://version2Store")>
      <#-- Make sure associations are created to the uploaded attachments -->
       allowCreateAssociations: true,
      <#-- Set disabled to false again, it is set to true since the form is in view mode by the renderPickerJS-->
       disabled: false
   </#if>

   }).setMessages(
      ${messages}
   );
})();
function attachment_renderLinkTemplate(item){

    var linkUrl = "${url.context}/page";

    if (item.site) {
        linkUrl += "/site/" + item.site;
    } else if (Alfresco.constants.SITE) {
        linkUrl += "/site/" + Alfresco.constants.SITE;
    }

	if (item.type == "app:filelink"){
		linkUrl += "/document-details?nodeRef=" + item.destination;
	}else if (item.type == "cm:folder"){
		linkUrl += "/folder-details?nodeRef=" + item.nodeRef;
	}else{
		linkUrl += "/document-details?nodeRef=" + item.nodeRef;
	}
    return linkUrl;
}

//]]></script>

<div class="form-field">
   <#if form.mode == "view" && (allowUploadInViewMode == "false")>
      <div id="${controlId}" class="viewmode-field">
         <#if (field.endpointMandatory!false || field.mandatory!false) && field.value == "">
            <span class="incomplete-warning"><img src="${url.context}/res/components/form/images/warning-16.png" title="${msg("form.field.incomplete")}" /><span>
         </#if>
         <span class="viewmode-label">${field.label?html}:</span>
         <span id="${controlId}-currentValueDisplay" class="viewmode-value current-values"></span>
      </div>
   <#else>
      <label for="${controlId}">${field.label?html}:<#if field.endpointMandatory!false || field.mandatory!false><span class="mandatory-indicator">${msg("form.required.fields.marker")}</span></#if></label>

      <div id="${controlId}" class="object-finder">
         <div id="${controlId}-currentValueDisplay" class="current-values"></div>
      	 <#if (field.disabled == false || (field.disabled == true && form.mode == "view" && allowUploadInViewMode == "true")) && (!form.arguments.itemId?starts_with("versionStore://version2Store"))>
            <input type="hidden" id="${fieldHtmlId}" name="-" value="${field.value?html}" />
            <input type="hidden" id="${controlId}-added" name="${field.name}_added" />
            <input type="hidden" id="${controlId}-removed" name="${field.name}_removed" />

            <div id="${controlId}-itemGroupActions" class="show-picker"><span id="${controlId}-upload"><button id="${controlId}-upload-button">${msg("form.control.attachments.upload")}</button></span></div>
            <div id="${controlId}-upload-destination-dialog"></div>
            <@renderPickerHTML controlId />
         </#if>
      </div>

      <#-- Do we require the user to upload a new version of a file? Set hidden field for the transitions component to handle this. -->
      <#if field.control.params.newVersionMandatory?? && field.value?? && field.value != "">
        <input type="hidden" id="${controlId}-newVersionUploaded" name="${field.name}_newVersionUploaded"/>
      </#if>
   </#if>
</div>
<#if borderBoxStyleEnd == true>
    </fieldset>
</#if>
