<#include "/org/alfresco/components/form/controls/common/utils.inc.ftl" />
<#if field.control.params.size??><#assign size=field.control.params.size><#else><#assign size=5></#if>

<#if field.control.params.optionSeparator??>
   <#assign optionSeparator=field.control.params.optionSeparator>
<#else>
   <#assign optionSeparator=",">
</#if>
<#if field.control.params.labelSeparator??>
   <#assign labelSeparator=field.control.params.labelSeparator>
<#else>
   <#assign labelSeparator="|">
</#if>

<#assign fieldValue=field.value>
<#if fieldValue?string == "" && field.control.params.defaultValueContextProperty??>
   <#if context.properties[field.control.params.defaultValueContextProperty]??>
      <#assign fieldValue = context.properties[field.control.params.defaultValueContextProperty]>
   <#elseif args[field.control.params.defaultValueContextProperty]??>
      <#assign fieldValue = args[field.control.params.defaultValueContextProperty]>
   </#if>
</#if>

<#assign values=[]>
<#assign valueToInput="">
<#if field.control.params.defaultValues??>

    <#assign fieldValue = field.control.params.defaultValues>
  
     <#assign first=true>
  <#list fieldValue?split(optionSeparator) as nameValue>
    <#if !first>
        <#assign valueToInput=valueToInput + ",">
      <#else>
        <#assign first=false>
      </#if>
    <#assign choice=nameValue?split(labelSeparator)>
        <#assign values=values + [choice[0]]>
        <#assign valueToInput=valueToInput + choice[0]>
   </#list>

<#elseif fieldValue?string != "">
   <#assign values=fieldValue?split(",")>
  <#assign valueToInput=fieldValue>
</#if>

<div class="form-field">
   <#if form.mode == "view">
      <div class="viewmode-field">
         <span class="viewmode-label">${field.label?html}:</span>
         <#if fieldValue?string == "">
            <#assign valueToShow=msg("form.control.novalue")>
         <#else>
            <#if field.control.params.options?? && field.control.params.options != "" &&
                 field.control.params.options?index_of(labelSeparator) != -1>
                 <#assign valueToShow="">
                 <#assign firstLabel=true>
                 <#list field.control.params.options?split(optionSeparator) as nameValue>
                    <#assign choice=nameValue?split(labelSeparator)>
                    <#if isSelected(choice[0])>
                       <#if !firstLabel>
                          <#assign valueToShow=valueToShow + ",">
                       <#else>
                          <#assign firstLabel=false>
                       </#if>
                       <#assign valueToShow=valueToShow + choice[1]>
                    </#if>
                 </#list>
            <#else>
               <#assign valueToShow=fieldValue>
            </#if>
         </#if>
         <span class="viewmode-value">${valueToShow?html}</span>
      </div>
   <#else>
      <script>
      
   //<![CDATA[
   YAHOO.util.Event.onDOMReady(
    function () {
      YAHOO.Bubbling.on('resetForm', function (layer, args) {
           	var lists = YAHOO.util.Selector.query('select');
            for(i = 0; i < lists.length; i++){
                if(lists[i].id.endsWith('-entry')){
                    Dom.get(lists[i].id.replace('-entry','')).value = "";
                }
            }
	  });
    });
  //]]></script>
  
      <label for="${fieldHtmlId}-entry">${field.label?html}:</label>
      <input id="${fieldHtmlId}" type="hidden" name="${field.name}" value="" />
      <#if field.control.params.options?? && field.control.params.options != "">
         <select id="${fieldHtmlId}-entry" name="-" multiple="multiple" size="${size}" tabindex="0"
               onchange="javascript:Alfresco.util.updateMultiSelectListValue('${fieldHtmlId}-entry', '${fieldHtmlId}', false);"
               <#if field.description??>title="${field.description}"</#if> 
               <#if field.control.params.styleClass??>class="${field.control.params.styleClass}"</#if>
               <#if field.control.params.style??>style="${field.control.params.style}"</#if>
               <#if field.disabled && !(field.control.params.forceEditable?? && field.control.params.forceEditable == "true")>disabled="true"</#if>>
               <#--  This is used to remove duplicates -->
               <#assign optionValues = [] >
               <#list field.control.params.options?split(optionSeparator) as nameValue>
                  <#-- contractors docs should not have the engineering aspect related review values as options, that would confuse the users -->
                  <#assign reviewStatus=nameValue?split(labelSeparator)>
                  <#if !(reviewStatus[0]?string == "ifc" || reviewStatus[0]?string == "asBuilt" || reviewStatus[0]?string == "redlined" || reviewStatus[0]?string == "revoked" ) >
                     
                     <#if nameValue?index_of(labelSeparator) == -1>
                       <option value="${nameValue?html}"<#if isSelected(nameValue)> selected="selected"</#if>>${nameValue?html}</option>
                     <#else>
                       <#assign choice=nameValue?split(labelSeparator)>
                       <#if !optionValues?seq_contains(choice[1])>
                         <option value="${choice[0]?html}"<#if isSelected(choice[0])> selected="selected"</#if>>${msgValue(choice[1])?html}</option>
                         <#assign optionValues=optionValues+[choice[1]]/>
                       </#if>
                     </#if>
                  </#if>
               </#list>
         </select>
         <@formLib.renderFieldHelp field=field />
      <#else>
         <div id="${fieldHtmlId}" class="missing-options">${msg("form.control.selectone.missing-options")}</div>
      </#if>
   </#if>
</div>

<#function isSelected optionValue>
<#-- Don't select any default values defined on the model in the filter!
   <#list values as value>
      <#if optionValue == value?string || (value?is_number && value?c == optionValue)>
         <#return true>
      </#if>
   </#list>
-->
   <#return false>
</#function>