<#-- Renders a hidden form field, allowing you to easily set a field to a certain value -->
<#assign fieldValue = "">
<#if field.control.params.contextProperty??>
    <#if context.properties[field.control.params.contextProperty]??>
        <#assign fieldValue = context.properties[field.control.params.contextProperty]>
    <#elseif args[field.control.params.contextProperty]??>
        <#assign fieldValue = args[field.control.params.contextProperty]>
    </#if>
<#elseif context.properties[field.name]??>
    <#assign fieldValue = context.properties[field.name]>
<#elseif field.control.params.fieldValue??>
    <#assign fieldValue = field.control.params.fieldValue>
<#else>
    <#assign fieldValue = field.value>
</#if>

<#if form.mode == "edit" || form.mode == "create">
    <#if form.mode == "create" && field.name?starts_with("assoc_")>
        <#-- Allows adding of some association upon creation -->
        <input type="hidden" name="${field.name}_added" value="${fieldValue?html}" />
    <#else>
        <input type="hidden" name="${field.name}" value="${fieldValue?html}" />
    </#if>
</#if>
