<#include "*/no/lyse/allsites/alfresco/components/form/controls/editorparams.inc.ftl" />

<#assign controlId = fieldHtmlId + "-cntrl">
<#if form.mode == "edit" || form.mode == "view">
    <#if field.control.params.rows??><#assign rows=field.control.params.rows><#else><#assign rows=5></#if>
    <#if field.control.params.columns??><#assign columns=field.control.params.columns><#else><#assign columns=60></#if>
    <#-- Note: we cannot use field.mandatory since that is for the relatedDatalistItem field which is always mandatory -->
    <#if field.control.params.mandatoryComment??><#assign mandatoryComment=true><#else><#assign mandatoryComment=false></#if>
    <#if field.control.params.helperText??><#assign helperText=true><#else><#assign helperText=false></#if>

  <div class="form-field wf-comments">

    <label for="${field.id}-addCommentText">${field.label?html}:<#if mandatoryComment><span class="mandatory-indicator">${msg("form.required.fields.marker")}</span></#if></label>
    <#if helperText><span>${msg("${field.control.params.helperTextMsgId}")}</span></#if>
    <#if !(field.control.params.hideCommentTextarea?? && field.control.params.hideCommentTextarea == "true")>
        <div class="yui-u">
            <textarea id="${field.id}-addCommentText" name="${field.id}-addCommentText" rows="${rows}" cols="${columns}" tabindex="0"
                <#if field.description??>title="${field.description}"</#if>
                <#if field.control.params.styleClass??>class="${field.control.params.styleClass}"</#if>
                <#if field.control.params.style??>style="${field.control.params.style}"</#if>
                <#if field.disabled && !(field.control.params.forceEditable?? && field.control.params.forceEditable == "true")>disabled="true"</#if>>
            </textarea>
        </div>
        <#if (field.control.params.companyInternal?? && field.control.params.companyInternal == "true")>
            <input type="hidden" id="${field.id}-addCommentTextInternal" value="true" />
        <#else>
            <input type="hidden" id="${field.id}-addCommentTextInternal" value="false" />
        </#if>

    </#if>
    <br />

        <div id="${fieldHtmlId}-list" class="comment-list" style="display:none;">
            <div class="postlist-infobar">
                <div id="${fieldHtmlId}-list-paginator" class="paginator"></div>
            </div>
            <div class="clear"></div>
            <div id="${fieldHtmlId}-list-comments"></div>
        </div>

    <input type="hidden" id="${field.id}" name="${field.name}" value="${field.value}" />

      <script type="text/javascript">//<![CDATA[
      (function() {

          <#if !(field.control.params.hideCommentTextarea?? && field.control.params.hideCommentTextarea == "true")>
          var fid="${field.id}-addCommentText";
          if (${mandatoryComment?string}) {
              // Add a mandatory validation for the rich text field
              var addValidation = function (layer, args) {
                  var formUI = args[1];
                  formUI.runtime.addValidation(fid, Alfresco.forms.validation.mandatory, null, "submit", Alfresco.util.message("validation-hint.mandatory"));
              };

              YAHOO.Bubbling.on("afterFormRuntimeInit", addValidation, this);
          }
          </#if>

          require([Alfresco.constants.URL_RESCONTEXT + "components/form/rich-text.js",
              Alfresco.constants.URL_RESCONTEXT + "js/lyse/allsites/LyseRichTextControl.js",
              Alfresco.constants.URL_RESCONTEXT + "components/form/comments.js"], function(){

            <#if !(field.control.params.hideCommentTextarea?? && field.control.params.hideCommentTextarea == "true")>
              var art = new Alfresco.LyseRichTextControl(fid).setOptions({
                <#if form.mode == "edit" || (field.disabled && !(field.control.params.forceEditable?? && field.control.params.forceEditable == "true"))>disabled: false,</#if>
                currentValue: "",
                mandatory: ${mandatoryComment?string},
                lyseChangeListenerAdded: false,
                <@editorParameters field />
              }).setMessages(${messages});

              YAHOO.Bubbling.on("editorInitialized", function() {
                if (!art.options.lyseChangeListenerAdded) {
                  art.editor.getEditor().on('change', function() {
                    art._handleContentChange();
                  });
                  art.options.lyseChangeListenerAdded = true;
                }
              });
            </#if>

              var commentsControl = new Alfresco.CommentsControls("${fieldHtmlId}-list").setOptions({
                  height: ${args.editorHeight!180},
                  width: ${args.editorWidth!700},
                  commentTopic: "Comments",
                  <#if (field.control.params.loadPermissionGroups?? && field.control.params.loadPermissionGroups == "true")>
                  	  loadPermissionGroups: true,
                  </#if>

                  <#if (form.mode == "edit" || form.mode == "view") && field.value??>
                      itemNodeRef: "${field.value?js_string}"
                  <#else>
                      itemNodeRef: ""
                  </#if>
              }).setMessages(${messages});
              commentsControl.onReady();
          });
      })();
      //]]>
      </script>
  </div>
</#if>
