//@overridden projects/slingshot/config/alfresco/site-webscripts/org/alfresco/components/profile/user-notifications.get.js

/**
 * User Profile Component - User Notifications GET method
 */

function main()
{
  // Call the repo to retrieve user properties
  var emailFeedDisabled = false;
  var nodeRef = null;
  var result = remote.call("/api/people/" + encodeURIComponent(user.id));
  if (result.status == 200)
  {
    var res = JSON.parse(result);
    // we are interested in the "cm:emailFeedDisabled" property
    emailFeedDisabled = res.emailFeedDisabled;
    nodeRef = res.nodeRef;
  }
  model.emailFeedDisabled = emailFeedDisabled;

  var emailNotificationDisabled = false;
  var emailReminderNotificationDisabled = false;
  result = remote.call("/api/metadata?nodeRef=" + nodeRef);
  if (result.status == 200)
  {
    var res = JSON.parse(result);
    emailNotificationDisabled = res.properties["{http://ns.lyse.no/model/1.0}emailNotificationDisabled"] || false;
    emailReminderNotificationDisabled = res.properties["{http://ns.lyse.no/model/1.0}emailReminderNotificationDisabled"] || false;
  }

  model.emailNotificationDisabled = emailNotificationDisabled;
  model.emailReminderNotificationDisabled = emailReminderNotificationDisabled;

  // Widget instantiation metadata...
  var userNotification = {
    id : "UserNotifications",
    name : "Alfresco.UserNotifications"
  };
  model.widgets = [userNotification];
}

main();

