/**
 * Console Export component.
 *
 * @namespace Alfresco
 * @class Alfresco.ConsoleExport
 */
(function()
{
   /**
    * YUI Library aliases
    */
   var Dom = YAHOO.util.Dom,
       Event = YAHOO.util.Event,
       Element = YAHOO.util.Element;

   var $html = Alfresco.util.encodeHTML;
   /**
    * Console Export constructor.
    *
    * @param {String} htmlId The HTML id of the parent element
    * @return {Alfresco.ConsoleExport} The new component instance
    * @constructor
    */
   Alfresco.ConsoleExport = function(htmlId)
   {
      this.name = "Alfresco.ConsoleExport";
      Alfresco.ConsoleExport.superclass.constructor.call(this, htmlId);

      /* Register this component */
      Alfresco.util.ComponentManager.register(this);

      /* Load YUI Components */
      Alfresco.util.YUILoaderHelper.require(["button", "container"], this.onComponentsLoaded, this);

      /* Define panel handlers */
      var parent = this;

      ViewPanelHandler = function ConsoleExport_ViewPanelHandler_constructor()
      {
         ViewPanelHandler.superclass.constructor.call(this, "view");
      };

      YAHOO.extend(ViewPanelHandler, Alfresco.ConsolePanelHandler,
      {

          /**
          * Fired by YUI when parent element is available for scripting
          * @method onReady
          */
          onLoad: function ConsoleExport_ViewPanelHandler_onLoad()
          {
	            parent.widgets.exportCsvButton = Alfresco.util.createYUIButton(parent, "exportUsers-button", parent.onExportUsers);
          }

      });
      new ViewPanelHandler();
     return this;
  };

  YAHOO.extend(Alfresco.ConsoleExport, Alfresco.ConsoleTool,
  {

    /**
     * Fired by YUILoaderHelper when required component script files have
     * been loaded into the browser.
     *
     * @method onComponentsLoaded
     */
    onComponentsLoaded: function ConsoleExport_onComponentsLoaded()
    {
      Event.onContentReady(this.id, this.onReady, this, true);
    },

    /**
     * Fired by YUI when parent element is available for scripting.
     * Component initialisation, including instantiation of YUI widgets and event listener binding.
     *
     * @method onReady
     */
    onReady: function ConsoleExport_onReady()
    {
      // Call super-class onReady() method
      Alfresco.ConsoleExport.superclass.onReady.call(this);
    },

    onExportUsers: function ConsoleExport_onExportUsers(e, args)
    {
      window.location.href = Alfresco.constants.PROXY_URI + "export/users";
    }

  });

})();
