
var Lyse = Lyse || {};
Lyse.component = Lyse.component || {};


(function() {

   var Dom = YAHOO.util.Dom,
      Event = YAHOO.util.Event,
      Selector = YAHOO.util.Selector,
      Bubbling = YAHOO.Bubbling;

   var $html = Alfresco.util.encodeHTML,
      $combine = Alfresco.util.combinePaths;

   Lyse.component.ProjectInformation = function ProjectInformation_constructor(htmlId)
   {
      Lyse.component.ProjectInformation.superclass.constructor.call(this, "Lyse.component.ProjectInformation", htmlId, ["container", "datasource", "datatable"]);
   	  this.id = htmlId;
   };
   

   YAHOO.extend(Lyse.component.ProjectInformation, Alfresco.component.Base,
   {

      options:
      {
          siteId: "",
          listId: "",
          listTitle: "",
          ListContent: ""
          
      },

      onReady: function ProjectInformation_onReady()
      {
      	 this.loadData();
      	 
         // Create edit button of the element in the ftl file defined as: ${el}-1-edit
         this.widgets.editButton = Alfresco.util.createYUIButton(this, this.options.listId+"-edit", this.onEditButton);
      	 Dom.removeClass(Selector.query(".toolbar div", this.id+"-"+this.options.listId, true), "hidden");
      },
      
      loadData: function ProjectInformation_loadData(){
   		Alfresco.util.Ajax.jsonGet(
        {
            url: Alfresco.constants.PROXY_URI + "/lyse/project/information/informationContent" + this.options.listId + "/informationTitle" + this.options.listId + "/" + this.options.siteId,
            responseContentType : "application/json",
            successCallback:
            {
                fn: function (response)
                {
                	var obj = response.json;
                	if(obj){
	                	this.options.nodeRef = obj.nodeRef;
	                	this.options.listTitle = obj.title;
	                	this.options.ListContent = obj.content;
        				this.renderContent();
                    }
                },
                scope: this
            }
        });
      },
      
      onEditButton: function ProjectInformation_onEditButton(event)
      {		
      	this.onCreateDialog();
      },
      
      renderContent: function ProjectInformation_renderContent() 
      {
      	Dom.get(this.id + "-" + this.options.listId + "-content").innerHTML = this.options.ListContent;
      	Dom.get(this.id + "-" + this.options.listId + "-header").innerHTML = this.options.listTitle;
      },
      
      onCreateDialog: function ProjectInformation_onCreateDialog(){
          var templateUrl = YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&formId={formId}&itemId={itemId}&mode={mode}&submitType={submitType}&showCancelButton=true",
          {
              itemKind: "node",
              itemId: this.options.nodeRef,
              mode: "edit",
			  formId: "edit-information-" + this.options.listId,
              submitType: "json"
          });
	       
		   var doBeforeDialogShow = function(p_form, p_dialog)
	       {
	          Alfresco.util.populateHTML(
	             [ p_form.formId + "-container_h", "Edit container" ],
	             [ p_form.formId + "-submit-button", "Save" ]
	          );
	       };
	       
	   	   var dialog = new Alfresco.module.SimpleDialog(this.id + "-form-edit-" + Alfresco.util.generateDomId());
	   	   dialog.setOptions(
		   {
	         templateUrl: templateUrl,
	         actionUrl: null,
	         destroyOnHide: true,
	         doBeforeDialogShow:
	         {
	            fn: doBeforeDialogShow,
	            scope: this
	         },
	         width: "400px",
	         onSuccess:
	         {
	           fn: function(response) {
      	 		   this.loadData();
	           },
	           scope: this
	         }
	       }).show();
      }
 	});
})();
