YAHOO.namespace("lyse.bulkimport");

(function () {
  var renderWaitingBar = function() {
    if (!YAHOO.lyse.bulkimport.wait) {
      // Initialize the temporary Panel to display while waiting for external content to load
      YAHOO.lyse.bulkimport.wait =
        new YAHOO.widget.Panel("wait", {
          width: "220px",
          fixedcenter: true,
          close: false,
          draggable: false,
          zindex:4,
          modal: true,
          visible: false
        });

      YAHOO.lyse.bulkimport.wait.setHeader("Loading, please wait...");
      YAHOO.lyse.bulkimport.wait.setBody("<img src=\"http://l.yimg.com/a/i/us/per/gr/gp/rel_interstitial_loading.gif\"/>");
      YAHOO.lyse.bulkimport.wait.render(document.body);
    }
  }

  /**
   * This method calls BulkImportPostPogress webscript on a 2s interval
   * an polls the current batch job progress (if it exists).
   */
  var getProgressBulkImport = function() {
    Alfresco.util.Ajax.jsonGet({
      url: Alfresco.constants.PROXY_URI + "lyse/api/bulk-import?nodeRef=" + Alfresco.util.parseURL().queryParams.nodeRef,
      responseContentType : "application/json",
      successCallback: {
        fn: function (response) {
          if (response.json !== undefined) {
            var response = JSON.parse(response.serverResponse.responseText);
            var progress = response.data.progress;
            var text = response.data.text;
            if(text === "In progress") {
              YAHOO.lyse.bulkimport.wait.show();
              YAHOO.lyse.bulkimport.wait.setBody("" +
                "<img src=\"http://l.yimg.com/a/i/us/per/gr/gp/rel_interstitial_loading.gif\"/>" +
                "<br/>" + progress + " finished");
              setTimeout((function () {
                getProgressBulkImport();
              }), 2000);
            } else if (text === "Done"){
              YAHOO.lyse.bulkimport.wait.hide();
              if(response.data.validate === "true") {
                createDataTable(response);
                createStatusMessage(response);
              } else {
                Alfresco.util.PopupManager.displayPrompt({
                  title: "Import has been processed",
                  modal: true,
                  close: true,
                  text : "The import process has been processed. Please give it a couple minutes to create the nodes. A log file of the created nodes will be created in your home folders.",
                });
              }
            } else {
              if(YAHOO.lyse.bulkimport.wait != null) {
                YAHOO.lyse.bulkimport.wait.hide();
              }
            }
            var validateButton = document.getElementById("validateBulkImport-button");
            validateButton.disabled = false;
            document.getElementById("validateBulkImport-button").disabled = false
            document.getElementById("validateBulkImport").className = "yui-button yui-button-button";
          }
        },
        scope: this
      },
      failureCallback: {
        fn: function(response) {
          Alfresco.util.PopupManager.displayPrompt({
            title: "Oops, something went wrong!",
            text : JSON.parse(response.serverResponse.responseText).message,
            modal: true,
            close: true
          });
        },
        scope: this
      }
    });
  };

  var postBulkImport = function (validate) {
    var url = 'lyse/api/bulk-import?nodeRef=' + Alfresco.util.parseURL().queryParams.nodeRef;

    if(validate === "true") {
      url += '&validate=true';
    } else if(validate === "false"){
      url += '&validate=false';
    }
    if(Alfresco.util.parseURL().queryParams.type != null) {
      url += '&type='+Alfresco.util.parseURL().queryParams.type;
    }
    if (Alfresco.util.CSRFPolicy.isFilterEnabled()) {
      url += "&" + Alfresco.util.CSRFPolicy.getParameter() + "=" + encodeURIComponent(Alfresco.util.CSRFPolicy.getToken());
    }

    // Disable button so the user doesn't send multiple requests
    var validateButton = document.getElementById("validateBulkImport-button");
    var importButton = document.getElementById("startBulkImport-button");
    validateButton.disabled = true;
    importButton.disabled = true;
    document.getElementById("validateBulkImport").className = "yui-button yui-button-disabled";
    document.getElementById("startBulkImport").className = "yui-button yui-button-disabled";

    var oReq = new XMLHttpRequest();
    oReq.open("POST", Alfresco.constants.PROXY_URI + url, true);
    oReq.setRequestHeader(Alfresco.util.CSRFPolicy.getHeader(), Alfresco.util.CSRFPolicy.getToken());
    oReq.onload = function() {
      if(oReq.status == 200) {
        // Sucess, we can use this if the imported file is small.
        var response = JSON.parse(oReq.response);

        if(validate === "true") {
          validateButton.disabled = false;
          document.getElementById("validateBulkImport-button").disabled = false
          document.getElementById("validateBulkImport").className = "yui-button yui-button-button";
          var hasError = false;
          for(var key in response.data.errors) {
            if(response.data.errors.hasOwnProperty(key)
              && response.data.errors[key].containsError === "true"){
              hasError = true;
              break;
            }
          }
          if(hasError === false) {
            importButton.disabled = false;
            document.getElementById("startBulkImport-button").disabled = false;
            document.getElementById("startBulkImport").className = "yui-button yui-button-button";
          }
        }
      } else if(oReq.status == 400 || oReq.status == 500){
        Alfresco.util.PopupManager.displayPrompt({
          title: "Oops, something went wrong!",
          text : JSON.parse(oReq.response).message,
          modal: true,
          close: true
        });
        validateButton.disabled = false;
        document.getElementById("validateBulkImport").className = "yui-button yui-button-button";
      }
    };

    oReq.send(new FormData(document.getElementById("bulk-import-form")));

    // Wait a few seconds before we get import process
    // since it takes a couple seconds for the Job batch to initiate
    YAHOO.lyse.bulkimport.wait.setBody("<img src=\"http://l.yimg.com/a/i/us/per/gr/gp/rel_interstitial_loading.gif\"/>");
    YAHOO.lyse.bulkimport.wait.show();
    setTimeout((function () {
      getProgressBulkImport();
    }), 5000);
  };

  function createStatusMessage(json) {
    var totalNodes = json.data.totalNodes;
    var errors = 0;
    var errorz = [];
    var element = document.getElementById('bulk-import-status');
    element.innerHTML = "";
    element.innerHTML += '<h2>Total nodes: ' + totalNodes + '</h2><br/>';

    for(var key in json.data.errors) {
      if(json.data.errors.hasOwnProperty(key)
          && json.data.errors[key].containsError === "true"){
        errors++;
        errorz.push(json.data.errors[key]);
      }
    }
    element.innerHTML += '<h2>Total errors: ' + errors + '</h2><br/>';

    for(var error in errorz) {
      if(errorz.hasOwnProperty(error)) {
        element.innerHTML += '<b>Row:</b> ' + errorz[error].row + ' with <b>ID:</b> ' + errorz[error].id + ' has the <b>following issue:</b> ' + errorz[error].exception + '<br/><br/>';
      }
    }

    // Enable import button if there's no errors.
    if(errors == 0) {
      var importButton = document.getElementById("startBulkImport-button");
      importButton.disabled = false;
      document.getElementById("startBulkImport-button").disabled = false;
      document.getElementById("startBulkImport").className = "yui-button yui-button-button";
    }
  }
  /**
   * Creates the data table
   *
   * @method createDataTable
   */
  function createDataTable(json) {
    document.getElementById("bulk-import-title").style.display = "block";

    var columnDefinitions = [];
    for(var key in json.data.headers) {
      if(json.data.headers.hasOwnProperty(key)){
        var column= {
            key: key,
            label: json.data.headers[key].toString(),
        }
      }
      columnDefinitions.push(column);
    }

    var dsLocalJSON = new YAHOO.util.LocalDataSource(json.data);
    dsLocalJSON.responseType = YAHOO.util.DataSource.TYPE_JSON;

    var fields = [];
    for(var keyz in json.data.headers) {
      if(json.data.headers.hasOwnProperty(keyz)){
        fields.push(keyz)
      }
    }
    dsLocalJSON.responseSchema = {
      resultsList: "nodes",
      fields: fields

    };

    //Define a custom row formatter function
    var myRowFormatter = function(elTr, oRecord) {
      var id = oRecord.getData('itemId');
      for(var key in json.data.errors) {
        if(json.data.errors.hasOwnProperty(key)
          && json.data.errors[key].id === id
          && json.data.errors[key].containsError === "true"){
              elTr.style.backgroundColor="#f44242";
        }
      }
      return true;
    };
    new YAHOO.widget.DataTable(
      "bulk-import",
      columnDefinitions,
      dsLocalJSON,
      {formatRow: myRowFormatter}
    );
  }

  var oValidateBulkImport = new YAHOO.widget.Button({
    id: "validateBulkImport",
    type: "button",
    label: "Validate",
    container: "validate-button-container"
  });
  var oStartBulkImport = new YAHOO.widget.Button({
    id: "startBulkImport",
    type: "button",
    label: "Start import",
    container: "import-button-container",
  });

  oValidateBulkImport.on("click", function(){
    postBulkImport("true");
  });
  oStartBulkImport.on("click", function(){
    postBulkImport("false");
  });

  YAHOO.util.Event.onAvailable("startBulkImport", function() {
    renderWaitingBar();
    // Check if an import/validation is in progress on page load first.
    getProgressBulkImport();
    // Disable buttons if there's an ongoing import/validation.
    document.getElementById("startBulkImport").className = "yui-button yui-button-disabled";
    document.getElementById("startBulkImport-button").disabled = "true";
    document.getElementById("validateBulkImport").className = "yui-button yui-button-disabled";
    document.getElementById("validateBulkImport-button").disabled = "true";
  });
})();





