(function () {
    Lyse = Lyse || {};

    Lyse.DatalistDetailsActions = function (htmlId) {
        Lyse.DatalistDetailsActions.superclass.constructor.call(this,
            "Lyse.DatalistDetailsActions", htmlId, ["button"]);//, "Lyse.component.WorkflowForm" , "Lyse.component.WorkflowHistory"
        return this;
    };

    var $html = Alfresco.util.encodeHTML;

    var buttonPermissionsMap = {
        shareForCommentButton: ["startShareForCommentingWorkflow"],
        shareForInformationButton: ["startShareForInformationWorkflow"],
        editButton: ["edit"],
        workflowHistoryListButton: ["showWorkflowHistory"],
        shareHistoryListButton: ["showShareHistory"],
        uploadNewRevisionButton: ["cdlRevise", "genericDocumentUpload","engRevise"],
        submitForReviewButton: ["cdlSubmitForReview"]
    };

    YAHOO.extend(Lyse.DatalistDetailsActions, Alfresco.component.Base,
        {
            onReady: function()
            {
                YAHOO.Bubbling.on("workflowFormReady", this.setTitle.bind(this));
                YAHOO.util.Event.onDOMReady(this.setTitle.bind(this));
                this.setupActionButtons();
                YAHOO.Bubbling.on("workflowFormReady", this.getPermissions.bind(this));
                YAHOO.util.Event.onDOMReady(this.getPermissions.bind(this));
            },
            dropDownEmpty:function(element)
            {
                var button = element._button.id;
                var taskButtons = document.getElementById(button+"s");
                var taskButtonsArray = [];
                for(var i = 0;i<taskButtons.children.length;i++)
                {
                    taskButtonsArray.push(taskButtons.children[i]);
                }
                return !taskButtonsArray.some(function(element)
                {
                   return element.innerHTML.trim().length>0;
                });
            },
            getPermissions:function()
            {
                var itemRef = this.getItemNodeRef();
                if(!itemRef)
                {
                     return;
                }

                // When we have a nodeRef, we look for share-tasks.
            	this.getShareTasks(itemRef);
                var nodeRef = new Alfresco.util.NodeRef(itemRef);

                Alfresco.util.Ajax.jsonGet({
                    url: Alfresco.constants.PROXY_URI + "lyse/api/permissions/" + nodeRef.uri,
                    responseContentType : "application/json",
                    successCallback: {
                        fn: function (response) {
                            var permissions = response.json;
                            this.permissions = permissions;
                            var usedPermissions = []; // keep track of which permissions are "connected" to a button

                            if(permissions['delete']) {
                              this.widgets.deleteButton._setDisabled(false);
                            }else{
                              this.widgets.deleteButton.destroy();
                              var wrapper = YAHOO.util.Dom.get('delete-buttopn-wrapper');
                              if(wrapper){
                                wrapper.parentElement.removeChild(wrapper);
                              }
                            }

                            for (var button in buttonPermissionsMap) {
                                buttonPermissions = buttonPermissionsMap[button];

                                var hasPermission = false;

                                for (i = 0; i < buttonPermissions.length; i++) {
                                    var buttonPermission = buttonPermissions[i];

                                    if (permissions.hasOwnProperty(buttonPermission)) {
                                        hasPermission = permissions[buttonPermission];
                                        if (hasPermission) {
                                            usedPermissions.push(buttonPermission);
                                            break;
                                        }
                                    }
                                }

                                if (hasPermission) {
                                    this.widgets[button]._setDisabled(false);
                                } else {
                                    this.widgets[button].destroyed = true;
                                    this.widgets[button].destroy();
                                    if(button == 'editButton') {
                                      var wrapper = YAHOO.util.Dom.get('edit-buttopn-wrapper');
                                      if (wrapper) {
                                        wrapper.parentElement.removeChild(wrapper);
                                      }
                                    }
                                }
                            }

                            Object.keys(permissions).forEach(function(key)
                            {
                               if(permissions[key] && key.indexOf("Workflow") !== -1 && usedPermissions.indexOf(key) === -1)
                                {
                                    //check if workflow is already active.
                                    if(!Alfresco.util.parseURL().queryParams.workflowId)
                                    {
                                        this.widgets.startWorkflowButton._setDisabled(false);
                                    }
                                }
                            },this);
                            if(this.widgets.startWorkflowButton._button.disabled)
                            {
                                this.widgets.startWorkflowButton.destroyed = true;
                                this.widgets.startWorkflowButton.destroy()
                            }
                            if(this.dropDownEmpty(this.widgets.moreDropdown))
                            {
                                this.widgets.moreDropdown.destroy();
                            }
                            if(this.dropDownEmpty(this.widgets.actionsDropdown))
                            {
                      	    	this.widgets.actionsDropdown.addClass("dropdown-hidden");
                            }
                            if(this.dropDownEmpty(this.widgets.shareDropdown))
                            {
                                this.widgets.shareDropdown.destroy();
                            }
                        },
                        scope: this
                    }
                });
            },
            setupActionButtons:function()
            {
                this.widgets.shareDropdown = new YAHOO.widget.Button("share-dropdown");
                this.widgets.actionsDropdown = new YAHOO.widget.Button("task");
                this.widgets.moreDropdown = new YAHOO.widget.Button("task-dropdown");
                this.widgets.printWithAllComments = new YAHOO.widget.Button(this.id + "-with-all-comments");
                this.widgets.printWithAllComments.on("click",this.onActionPrintWithAllComments.bind(this));
                this.widgets.shareForCommentButton = new YAHOO.widget.Button(this.id + "-share-for-comment");
                this.widgets.shareForCommentButton.on("click",this.onActionStartShareForCommentingWorkflow.bind(this));
                this.widgets.shareForInformationButton = new YAHOO.widget.Button(this.id + "-share-for-information");
                this.widgets.shareForInformationButton.on("click",this.onActionStartShareForInformationWorkflow.bind(this));
                this.widgets.editButton = new YAHOO.widget.Button(this.id + "-edit");
                this.widgets.editButton.on("click",this.onActionEdit.bind(this));
                this.widgets.deleteButton = new YAHOO.widget.Button(this.id + "-delete");
                this.widgets.deleteButton.on("click",this.onDeleteItem.bind(this));
                this.widgets.workflowHistoryListButton = new YAHOO.widget.Button(this.id + "-workflow-history-list");
                this.widgets.workflowHistoryListButton.on("click",this.onShowWorkflowHistoryList.bind(this));
                this.widgets.shareHistoryListButton = new YAHOO.widget.Button(this.id + "-share-history-list");
                this.widgets.shareHistoryListButton.on("click",this.onShowShareHistoryList.bind(this));
                this.widgets.uploadNewRevisionButton = new YAHOO.widget.Button(this.id + "-upload-revision");
                this.widgets.uploadNewRevisionButton.on("click",this.onActionUploadNewRevision.bind(this));
                this.widgets.submitForReviewButton = new YAHOO.widget.Button(this.id + "-submit-for-review");
                this.widgets.submitForReviewButton.on("click",this.onActionSubmitForReview.bind(this));
                this.widgets.startWorkflowButton = new YAHOO.widget.Button(this.id + "-start-workflow");
                this.widgets.startWorkflowButton.on("click",this.onActionStartWorkflow.bind(this));
                this.widgets.closeButton = new YAHOO.widget.Button("close-button");
                this.widgets.closeButton.on("click",function()
                {
                    Lyse.util.closeWindow();
                });
                Object.keys(buttonPermissionsMap).forEach(function(key) {
                    this.widgets[key]._setDisabled(true);
                },this);
                this.widgets.startWorkflowButton._setDisabled(true);
                this.widgets.deleteButton._setDisabled(true);

                // Remove standard look of button, new look is defined in datalist-details.css
                for (var property in this.widgets) {
                    if(typeof this.widgets[property].replaceClass === 'function'){
                        this.widgets[property].removeClass("yui-button");
                    }
                }
            },
            getShareTasks: function (nodeRef) {
 				var nodeRefs =  [nodeRef];
	            Alfresco.util.Ajax.jsonPost({
	              url : Alfresco.constants.PROXY_URI + "api/lyse/datatable-metadata",
	              dataObj: nodeRefs,
	              responseContentType : "application/json",
	              successCallback : {
	                fn : function(response) {
	                  var metadataList = response.json;
	                  if(metadataList.length > 0 && metadataList[0].workflowTasks.length > 0) {

	                  	var shareButtons = {};
	                  	// For each share-task, make sure it really is share-task before continue
                	    for(var i = 0;i<metadataList[0].workflowTasks.length;i++) {
                	      var task = metadataList[0].workflowTasks[i];
        				  if(task.name == "lysewf:shareForCommenting" || task.name == "lysewf:shareForInformation" || task.name == "lysewf:shareInformOriginator" ||
                            task.name == "lysewf:cdlCompanyReviewUserTask" || task.name == "lysewf:cdlCompanyDiscussionUserTask"){

         				  	// Create button with title of task
					        var taskButton = document.createElement("button");
                            taskButton.innerHTML = "Task: " + task.title;

                      	    // Add <li> and append to Task-items
                            var listItem = document.createElement("li").appendChild(taskButton);
                            YAHOO.util.Dom.get("task-buttons").appendChild(listItem);

                            // Create event on button click
                            var button = new YAHOO.widget.Button(taskButton);
                            button.removeClass("yui-button");
                            shareButtons[button._button.id] = {"taskid": task.id, "workflowid": task.workflowId};
                            button.on("click",(function(button) {
                              document.location = YAHOO.lang.substitute("{taskUrl}&workflowId={workflowId}", {
                     			taskUrl: Alfresco.constants.URL_PAGECONTEXT + 'lyse-task-edit?taskId=' + $html(shareButtons[button.target.id].taskid), // task.id
                                workflowId: shareButtons[button.target.id].workflowid //task.workflowId
                      		  });
                      	    }).bind(this));
                      	    if(this.widgets.actionsDropdown.hasClass("dropdown-hidden")){
                      	    	this.widgets.actionsDropdown.removeClass("dropdown-hidden");
                      	    }
                      	  }
                        }
                      }
	                },
	                scope : this,
	              }
	            });
	          return;
            },
            getItemNodeRef: function () {
                var workflowForm = Alfresco.util.ComponentManager.findFirst("Lyse.component.WorkflowForm");
                var datalistNodeRef;
                if (workflowForm && workflowForm.datalistNodeRef) {
                    datalistNodeRef = workflowForm.datalistNodeRef;
                }
                else {
                    datalistNodeRef = Alfresco.util.parseURL().queryParams.nodeRef;
                }
                return datalistNodeRef;
            },
            setTitle: function () {
                var queryParam = this.getItemNodeRef();
                if (!queryParam) {
                    return;
                }
                var nodeRef = new Alfresco.util.NodeRef(queryParam);
                Alfresco.util.Ajax.request(
                    {
                        url: Alfresco.constants.PROXY_URI + "api/lyse/" + nodeRef.uri + "/datalist-item",
                        successCallback: {
                            fn: function (response) {
                                var siteName = response.json.siteTitle || response.json.shortName;
                                var datalistName = response.json.datalistTitle || response.json.datalistName;
                                document.getElementById("data-list-item-header").innerHTML = siteName + ": " + datalistName;
                                //please don't judge, this "constant" is set to "" in datalist-details.. this is so the stupid category-selectmany picker works....
                                Alfresco.constants.SITE = response.json.shortName;
                                this.itemType = response.json.datalistItemType;
                            },
                            scope: this
                        },
                        failureMessage: "Could not load title"
                    });
            },
            // Print with all comments on the same page.
            onActionPrintWithAllComments:function(){
                var commentsControl = Alfresco.util.ComponentManager.findFirst("Alfresco.CommentsControls");
                commentsControl._setCommentsPerPageSize(9999); // Reset page to max comments per page.
                commentsControl._loadAllCommentsListAndPrint(0); // Update and refresh page.
            },
            onActionStartWorkflow:function()
            {
                Lyse.DatalistActions.onActionStartWorkflow.call(this,this.getItemNodeRef(),function()
                    {
                        // do nothing
                    });
            },
            onActionStartShareForInformationWorkflow: function () {
                Lyse.DatalistActions.onActionStartShareForInformationWorkflow.call(this,this.getItemNodeRef(),function()
                {
                    Alfresco.util.PopupManager.displayPrompt(
                        {
                            text: this.msg("actions.start-share-workflow.success")
                        });
                });
            },
            onActionEdit: function () {
                Lyse.DatalistActions.onActionEdit.call(this,this.getItemNodeRef(),null,function()
                {
                    Alfresco.util.PopupManager.displayPrompt(
                        {
                            text: this.msg("message.details.success")
                        });
                    location.reload();
                });
            },
            onActionStartShareForCommentingWorkflow: function () {
               Lyse.DatalistActions.onActionStartShareForCommentingWorkflow.call(this,this.getItemNodeRef(),function()
               {
                   Alfresco.util.PopupManager.displayPrompt(
                       {
                           text: this.msg("actions.start-share-workflow.success")
                       });
               });
            },
        onDeleteItem:function() {
          var nodeRef = this.getItemNodeRef();
          var me = this;
          var fnActionDeleteConfirm = function DataListActions__onActionDelete_confirm(nodeRef){
		    var config = {
         	  url: Alfresco.constants.PROXY_URI + "api/node/" + nodeRef.replace("://","/"),
			  method: Alfresco.util.Ajax.DELETE,
     		  successCallback: {
		      	fn: function(response) {
                	var displayTime = 3;
	                Alfresco.util.PopupManager.displayMessage({
	                  text: this.msg("datalist.prompt.delete.success"),
                      displayTime: displayTime
	                });
                    if (window.opener.refreshDataGrid) {
                      window.opener.refreshDataGrid();
                    }
                    else{
                      console.warn("No refreshDataGrid function in opener!");
                      window.opener.location.reload();
                    }
	                window.setTimeout(Lyse.util.closeWindow, displayTime * 1000);
		        },
		        scope: this
		      },
     		  failureMessage: this.msg("datalist.prompt.delete.failure")
		    };
            Alfresco.util.Ajax.jsonRequest(config);
          };

          Alfresco.util.PopupManager.displayPrompt({
            title: this.msg("button.delete"),
            text: this.msg("datalist.prompt.delete.title"),
            buttons: [
            {
               text: this.msg("button.delete"),
               handler: function DataListActions__onActionDelete_delete()
            {
                  this.destroy();
                  fnActionDeleteConfirm.call(me, nodeRef);
               }
            },
            {
               text: this.msg("button.cancel"),
               handler: function DataListActions__onActionDelete_cancel()
               {
                  this.destroy();
               },
               isDefault: true
            }]
          });
        },
        onShowWorkflowHistoryList:function() {
                Lyse.DatalistActions.onShowWorkflowHistoryList.call(this,this.getItemNodeRef());
            },
            onShowShareHistoryList:function()
            {
                Lyse.DatalistActions.onShowShareHistoryList.call(this,this.getItemNodeRef());
            },
            onActionUploadNewRevision:function()
            {
                var nodeRef = new Alfresco.util.NodeRef(this.getItemNodeRef());
                Alfresco.util.Ajax.jsonPost(
                    {
                        url: Alfresco.constants.PROXY_URI + "slingshot/datalists/item/node/" + nodeRef.uri,
                        responseContentType : "application/json",
                        successCallback:
                            {
                                fn: function (response)
                                {
                                    var item = response.json.item;
                                    Lyse.DatalistActions.onActionUploadNewRevision.call(this,item,this.itemType);
                                },
                                scope: this
                            },
                        failureCallback:
                            {
                                fn: function ExtDataGrid_onActionUploadNewRevision_failure(response)
                                {
                                    Alfresco.util.PopupManager.displayPrompt(
                                        {
                                            text: response.json.message
                                        });
                                },
                                scope: this
                            }
                    });
            },
            onActionSubmitForReview:function()
            {
                //itemType is set in setTitle..
                var nodeRef = new Alfresco.util.NodeRef(this.getItemNodeRef());
                Alfresco.util.Ajax.jsonPost(
                    {
                        url: Alfresco.constants.PROXY_URI + "slingshot/datalists/item/node/" + nodeRef.uri,
                        responseContentType : "application/json",
                        successCallback:
                            {
                                fn: function (response)
                                {
                                    var item = response.json.item;
                                    Lyse.DatalistActions.onActionSubmitForReview.call(this,item,this.itemType,function()
                                    {
                                        Alfresco.util.PopupManager.displayPrompt(
                                            {
                                                text: this.msg("actions.submit-for-review-success")
                                            });
                                    });
                                },
                                scope: this
                            },
                        failureCallback:
                            {
                                fn: function ExtDataGrid_onActionSubmitForReview_failure(response)
                                {
                                    Alfresco.util.PopupManager.displayPrompt(
                                        {
                                            text: response.json.message
                                        });
                                },
                                scope: this
                            }
                    });

            }
        });

})();
