window.RPLP = window.RPLP || {};
window.RPLP.selectedNodeType = "";
YAHOO.namespace("lyse.extended.toolbar");

(function() {

  /**
   * YUI Library aliases
   */
  var Dom = YAHOO.util.Dom, Event = YAHOO.util.Event, Selector = YAHOO.util.Selector, Bubbling = YAHOO.Bubbling;

  /**
   * Alfresco Slingshot aliases
   */
  var $html = Alfresco.util.encodeHTML,
  $links = Alfresco.util.activateLinks,
  $combine = Alfresco.util.combinePaths,
  $userProfile = Alfresco.util.userProfileLink,
  $hasEventInterest = Alfresco.util.hasEventInterest;

  Alfresco.component.ExtDataListToolbar = function(htmlId) {
    return Alfresco.component.ExtDataListToolbar.superclass.constructor.call(this, htmlId);
    Alfresco.util.ComponentManager.reregister(this);
  };

  /**
   * Extend Alfresco.component.DataGrid
   */
  YAHOO.extend(Alfresco.component.ExtDataListToolbar, Alfresco.component.DataListToolbar);

  /**
   * Augment prototype with Common Actions module
   */
  YAHOO.lang.augmentProto(Alfresco.component.ExtDataListToolbar, Alfresco.service.DataListActions);

  /**
   * Augment prototype with main class implementation, ensuring overwrite is
   * enabled
   */
  YAHOO.lang.augmentObject(Alfresco.component.ExtDataListToolbar.prototype, {
    isRunning: false,
    /**
     * Fired by YUI when parent element is available for scripting.
     *
     * @method onReady
     */
    onReady : function DataListToolbar_onReady() {
      this.dialogs = {};
      this.widgets.exportCsvButton = Alfresco.util.createYUIButton(this, "exportCsvButton", this.onExportCsv, {
        disabled : true
      });
      this.widgets.importCsvButton = Alfresco.util.createYUIButton(this, "importCsvButton", this.onImportCsv, {
        disabled : true
      });
      this.widgets.workflowDiagramButton = Alfresco.util.createYUIButton(this, "workflowDiagramButton", this.onWorkflowDiagram, {
        disabled : true
      });
      this.widgets.newVoButton = Alfresco.util.createYUIButton(this, "newVoButton", this.onNewVO, {
        disabled: true,
        value : "createVO"
      });
      this.widgets.newVorButton = Alfresco.util.createYUIButton(this, "newVorButton", this.onNewVOR, {
        disabled: true,
        value : "createVOR"
      });
      this.widgets.newCivilVoButton = Alfresco.util.createYUIButton(this, "newCivilVoButton", this.onNewVO, {
        disabled: true,
        value : "createCivilVO"
      });
      this.widgets.newCivilVorButton = Alfresco.util.createYUIButton(this, "newCivilVorButton", this.onNewVOR, {
        disabled: true,
        value : "createCivilVOR"
      });
      this.widgets.newNcrButton = Alfresco.util.createYUIButton(this, "newNcrButton", this.onNewNCR, {
          disabled: true,
          value : "createNCR"
      });
      this.widgets.newMilestoneButton = Alfresco.util.createYUIButton(this, "newMilestoneButton", this.onNewMilestone, {
        disabled: true,
        value : "createMilestone"
      });
      this.widgets.newCivilMilestoneButton = Alfresco.util.createYUIButton(this, "newCivilMilestoneButton", this.onNewCivilMilestone, {
        disabled: true,
        value : "createCivilMilestone"
      });

      if (Alfresco.util.getQueryStringParameter("list", document.location.href) == null) {
        // If no list is selected hide these buttons, so it only displays the disabled "New Item" button
        this.widgets.newVoButton.destroy();
        this.widgets.newVorButton.destroy();
        this.widgets.newNcrButton.destroy();
        this.widgets.newMilestoneButton.destroy();
        this.widgets.newCivilMilestoneButton.destroy();
        this.widgets.newCivilVoButton.destroy();
        this.widgets.newCivilVorButton.destroy();
      }


      Bubbling.on("activeDataListChanged", this.onActiveDataListChanged, this);
      Alfresco.component.ExtDataListToolbar.superclass.onReady.call(this);

      Alfresco.util.Ajax.request({
        url: Alfresco.constants.URL_SERVICECONTEXT + "components/people-finder/people-finder?site=" + Alfresco.constants.SITE,
        dataObj:
        {
           htmlid: this.id + "-peopleFinder"
        },
        successCallback:
        {
           fn: this.onPeopleFinderLoaded,
           scope: this
        },
        failureMessage: "Could not load People Finder component, make sure current site is present.",
        execScripts: true
      });
    },

	 onPeopleFinderLoaded: function TEH_onPeopleFinderLoaded(response)
	 {
	       // Inject the component from the XHR request into it's placeholder DIV element
	       var finderDiv = Dom.get(this.id + "-peopleFinder");
	       finderDiv.innerHTML = response.serverResponse.responseText;

	       // Create the Assignee dialog
	       this.dialogs.reassignPanel = Alfresco.util.createYUIPanel(this.id + "-reassignPanel");

	       // Find the People Finder by container ID
	       this.dialogs.peopleFinder = Alfresco.util.ComponentManager.get(this.id + "-peopleFinder");

           // Set the correct options for our use
           this.dialogs.peopleFinder.setOptions({
        	  siteId: Alfresco.constants.SITE,
              singleSelectMode: true,
              addButtonLabel: this.msg("button.select"),
              filterBaseGroup: "true"
           });

           // Reinitialize dataSource definition
           var peopleSearchUrl = Alfresco.constants.PROXY_URI + YAHOO.lang.substitute(this.dialogs.peopleFinder.options.dataWebScript, this.dialogs.peopleFinder.options);
           peopleSearchUrl += (peopleSearchUrl.indexOf("?") < 0) ? "?" : "&";
           this.dialogs.peopleFinder.widgets.dataSource = new YAHOO.util.DataSource(peopleSearchUrl,
           {
              responseType: YAHOO.util.DataSource.TYPE_JSON,
              connXhrMode: "queueRequests",
              responseSchema:
              {
                 resultsList: "people"
              }
           });

           // Make sure we listen for events when the user selects a person
           YAHOO.Bubbling.on("personSelected", this.onPersonSelected, this);
	},

	  /**
	   * Called when the user has selected an assigne from the people finder.
	   *
	   * @method onPersonSelected
	   * @param e DomEvent
	   * @param args Event parameters (depends on event type)
	   */
	  onPersonSelected: function TEH_onPersonSelected(e, args)
	  {
	     // This is a "global" event so we ensure the event is for the current panel by checking panel visibility.
	     if ($hasEventInterest(this.dialogs.peopleFinder, args))
	     {
	        this.dialogs.reassignPanel.hide();
	        this._fetchAndUpdateTasks(
	        {
	           "cm_owner": args[1].userName
	        }, "reassign");
	     }
	  },

	  _fetchAndUpdateTasks: function RL_fetchTasks(properties, action){
      	var items = this.modules.dataGrid.getSelectedItems();
      	var me = this;

	  	  // Task, send 1 each time first, later add possibility to send multiple.
	      items.forEach(function(item) {
      		var wf = item.itemData.prop_lysedl_workflowId.value;
      		if(wf != undefined) {

	           Alfresco.util.Ajax.jsonGet({
	           url: Alfresco.constants.PROXY_URI_RELATIVE + "api/lyse/all-workflow-tasks/" + wf,
	           successCallback:
	           {
	              fn: function(response)
	              {
	              	// Is there any workflows with multiple tasks active at the same time? In that case this will probably be a bad idea.
	              	// For now its only used within lysedl:issueList.
					me._updateTaskProperties(properties, action, response.json.workflowTasks[0].id, item);
	              },
	              obj: action,
	              scope: this
	           },
	           failureCallback:
	           {
	              fn: function(response)
	              {
	                 Alfresco.util.PopupManager.displayPrompt(
	                 {
	                    title: Alfresco.util.message("message.failure"),
	                    text: Alfresco.util.message("message." + action + ".failure")
	                 });
	              },
	              scope: this
	           }
	        });


	       }
	  	});
	  },

      _updateTaskProperties: function TEH__updateTaskProperties(properties, action, task, item)
      {
      	var me = this;
        Alfresco.util.Ajax.jsonPut({
           url: Alfresco.constants.PROXY_URI_RELATIVE + "api/task-instances/" + task,
           dataObj: properties,
           successCallback:
           {
              fn: function(response, action)
              {
              	if(response.json.status && response.json.status.code != 200){
					        Alfresco.util.PopupManager.displayPrompt(
					        {
	                    title: Alfresco.util.message("message.failure"),
	                    text: Alfresco.util.message("message." + action + ".failure")
					        });
              	}else{
                  var finish = (function (msg) {
                    me.modules.dataGrid.refreshItem(item.nodeRef, "actions.update-owner");
                  });
                  if(action=="reassign") {
                    Alfresco.util.Ajax.jsonGet(
                    {
                      url: Alfresco.constants.PROXY_URI + "lyse/api/set-responsible/" + task,
                      dataObj: properties,
                      successCallback:
                      {
                        fn:function()
                        {
                          finish();
                        }
                      },
                      failureCallback:
                      {
                        fn:function()
                        {
                          finish("Failed to set responsible on associated datalist item.");
                        }
                      }
                    });
                  } else {
                    finish();
                  }
				        }
              },
              obj: action,
              scope: this
           },
           failureCallback:
           {
              fn: function(response)
              {
                 Alfresco.util.PopupManager.displayPrompt(
                 {
                    title: Alfresco.util.message("message.failure"),
                    text: Alfresco.util.message("message." + action + ".failure")
                 });
              },
              scope: this
           }
        });
      },


    onActiveDataListChanged : function ExtDatalistToolbar_onActiveDataListChanged(layer, args) {

      var obj = args[1];
      if ((obj !== null) && (obj.dataList !== null)) {

        if ("lysedl:contractDataList" === obj.dataList.itemType || "lysedl:civilContractDataList" === obj.dataList.itemType ||
          "lysedl:companysDocumentDataList" === obj.dataList.itemType) {

          Alfresco.util.Ajax.jsonGet({
            url: Alfresco.constants.PROXY_URI + "api/people/"+Alfresco.constants.USERNAME,
            responseContentType : "application/json",
            successCallback: {
              fn: function (response) {
                var isAdmin = response.json.isAdminAuthority;
                Alfresco.util.Ajax.jsonGet({
                  url: Alfresco.constants.PROXY_URI + "api/lyse/forms/is-company-user?shortName=" + this.options.siteId,
                  responseContentType :  "application/json",
                  successCallback: {
                    fn: function (response) {
                      var companyUser = response.json.isCompanyUser;
                      if(companyUser === false && isAdmin === false){this.widgets.newRowButton._configs.disabled = true;}
                    },
                    scope: this
                  }
                });
              },
              scope: this
            }
          });
        }
        if ("lysedl:variationOrderRequestItem" === obj.dataList.itemType) {
          this.widgets.newRowButton.destroy();
        } else {
          this.widgets.newVoButton.destroy();
          this.widgets.newVorButton.destroy();
        }
        if ("lysedl:civilVariationOrderRequestItem" === obj.dataList.itemType) {
           this.widgets.newRowButton.destroy();
        } else {
              this.widgets.newCivilVoButton.destroy();
              this.widgets.newCivilVorButton.destroy();
        }

        if ("lysedl:ncrList" === obj.dataList.itemType){
        	this.widgets.newRowButton.destroy();
        } else {
        	this.widgets.newNcrButton.destroy();
        }

        if ("lysedl:milestoneItem" === obj.dataList.itemType){
          this.widgets.newRowButton.destroy();
        } else {
          this.widgets.newMilestoneButton.destroy();
        }

        if ("lysedl:civilMilestone" === obj.dataList.itemType){
          this.widgets.newRowButton.destroy();
        } else {
          this.widgets.newCivilMilestoneButton.destroy();
        }

        // Remove the "Workflow Diagram" button if the current data list has no workflow
        switch (obj.dataList.itemType) {
          case "lysedl:cdlDataList":
          case "lysedl:contractDataList":
          case "lysedl:correspondenceItem":
          case "lysedl:epbDataList":
          case "lysedl:iasDataList":
          case "lysedl:interfaceAction":
          case "lysedl:irlDataList":
          case "lysedl:issueList":
          case "lysedl:genericActionList":
          case "lysedl:milestoneItem":
          case "lysedl:ncrList":
          case "lysedl:punchList":
          case "lysedl:ruiList":
          case "lysedl:qaList":
          case "lysedl:hseAction":
          case "lysedl:variationOrderRequestItem":
          case "lysedl:sjaDataList":
          case "lysedl:riskReducingMeasures":
          case "lysedl:companysDocumentDataList":
          case "lysedl:userFeedback":
          case "lysedl:mccCommissioningPackages":
          case "lysedl:mccPackages":
          case "lysedl:mccAction":
          case "lysedl:actionWithProject":
          case "lysedl:siteQuery":
          case "lysedl:siteQueries":
          case "lysedl:contractDataList":
          case "lysedl:safeWorkPermitItem":
          case "lysedl:civilContractDataList":
          case "lysedl:civilMeasuredQuantity":
          case "lysedl:civilPunchList":
          case "lysedl:civilAction":
          case "lysedl:civilVariationOrderRequestItem":
          case "lysedl:civilCdlDataList":
          case "lysedl:civilMilestone":
          case "lysedl:civilTechnicalQuery":
          case "lysedl:civilCorrespondenceItem":
                break;
          default:
                this.widgets.workflowDiagramButton.destroy();
                break;
        }

        Alfresco.util.Ajax.jsonGet({
          url: Alfresco.constants.PROXY_URI + "api/people/"+Alfresco.constants.USERNAME,
          responseContentType : "application/json",
          successCallback: {
            fn: function (response) {
              var isAdmin = response.json.isAdminAuthority;
              var importableDataListTypes = ["lysedl:cdlDataList", "lysedl:mccSignal", "lysedl:genericDocumentList", "lysedl:mccCables",
                "lysedl:meetingMinutes", "lysedl:hseMeetingList", "lysedl:civilMeasuredQuantity", "lysedl:punchList", "lysedl:companysDocumentDataList"];
              if(!isAdmin) {
                // Check if user is SiteManager
                var siteName = this.options.siteId;
                Alfresco.util.Ajax.jsonGet({
                  url: Alfresco.constants.PROXY_URI + "api/sites/" + siteName + "/memberships/" + Alfresco.constants.USERNAME,
                  responseContentType :  "application/json",
                  successCallback: {
                    fn: function (response) {
                      var role = response.json.role;
                      if(role !== "SiteManager" || importableDataListTypes.indexOf(obj.dataList.itemType) < 0) {
                        this.widgets.importCsvButton.destroy();
                      }
                    },
                    scope: this
                  }
                });
              } else {
                if(importableDataListTypes.indexOf(obj.dataList.itemType) < 0) {
                  this.widgets.importCsvButton.destroy();
                }
              }
            },
            scope: this
          }
        });

      }
    },

    /**
     * Export CSV button click handler
     *
     * @method onExportCsv
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onExportCsv : function ExtDataListToolbar_onExportCsv(e, p_obj) {
      var nodeRef = Alfresco.util.NodeRef(this.modules.dataGrid.datalistMeta.nodeRef);
      var me = this;

      var renderWaitingBar = function() {
        if (!YAHOO.lyse.extended.toolbar.wait) {
          // Initialize the temporary Panel to display while waiting for external content to load
          YAHOO.lyse.extended.toolbar.wait =
            new YAHOO.widget.Panel("wait", {
              width: "220px",
              fixedcenter: true,
              close: false,
              draggable: false,
              zindex:4,
              modal: true,
              visible: false
            });

          YAHOO.lyse.extended.toolbar.wait.setHeader("Loading, please wait...");
          YAHOO.lyse.extended.toolbar.wait.setBody("<img src=\"http://l.yimg.com/a/i/us/per/gr/gp/rel_interstitial_loading.gif\"/>");
          YAHOO.lyse.extended.toolbar.wait.render(document.body);
        }
      };

      var downloadSpreadSheet = function(response, oReq) {
        YAHOO.lyse.extended.toolbar.wait.hide();

        var blob = new Blob([response], {type: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'});
        var downloadUrl = URL.createObjectURL(blob);
        var responseHeaders = oReq.getResponseHeader("Content-Disposition");
        var fileName = responseHeaders.substring(responseHeaders.indexOf("filename=")+9, responseHeaders.indexOf("filename=").length);

        // Make link to download element, then delete it.
        var a = document.createElement("a");
        a.href = downloadUrl;
        a.download = fileName;
        document.body.appendChild(a);
        a.click();
        a.parentNode.removeChild(a);
      };

      /**
       * This method calls DataListDownloadWebScriptProgress webscript on a 2s interval
       * an polls the current batch job progress (if it exists).
       */
      var getProgress = function(format) {
        var sendRequest = function(format) {
          request.open("GET", Alfresco.constants.PROXY_URI + "/fme/slingshot/datalists/progress/node?nodeRef=" + nodeRef + "&format=" + format);
          if(format == "json") {
            request.responseType = 'json';
          } else if(format == "xlsx") {
            request.responseType = 'blob';
          }
          request.send();
        };

        var request = new XMLHttpRequest();
        request.onload = function() {
          if(request.status == 200) {
            YAHOO.lyse.extended.toolbar.wait.show();
            if(!(request.response.message === "100%" || request.responseType === "blob")) {
              YAHOO.lyse.extended.toolbar.wait.setBody("" +
                "<img src=\"http://l.yimg.com/a/i/us/per/gr/gp/rel_interstitial_loading.gif\"/>" +
                "<br/>" + request.response.message + " finished");
              setTimeout((function () {
                getProgress("json");
              }), 2000);
            } else {
              if(format == "xlsx") {
                downloadSpreadSheet(this.response, request);
              } else if(format == "json") {
                getProgress("xlsx");
              }
            }
          } else if(request.status == 400 || request.status == 500) {
            Alfresco.util.PopupManager.displayPrompt({
              title: "Oops, something went wrong!",
              text : request.status + "An error occurred when trying to export the datalist",
              modal: true,
              close: true
            });
          }
        };

        sendRequest(format);
      };

      // Internet Explorer
      if (YAHOO.env.ua.ie > 0) {
        window.location.href = Alfresco.constants.PROXY_URI + "/fme/slingshot/datalists/list/node/" + nodeRef.uri + "?format=xlsx";
      } else {
        var oReq = new XMLHttpRequest();
        oReq.open("GET", Alfresco.constants.PROXY_URI + "/fme/slingshot/datalists/list/node/" + nodeRef.uri + "?format=xlsx");
        oReq.responseType = 'blob'; // Get a binary response
        oReq.send();
        renderWaitingBar();
        YAHOO.lyse.extended.toolbar.wait.show()
        setTimeout((function () {
          getProgress("json");
        }), 5000);
      }
    },

    onImportCsv : function ExtDataListToolbar_onImportCsv(e, p_obj) {
      var nodeRef = Alfresco.util.NodeRef(this.modules.dataGrid.datalistMeta.nodeRef);
      window.open(Alfresco.constants.URL_CONTEXT + 'page'+'/bulk-import?nodeRef=' + nodeRef, "_blank");
    },

    onWorkflowDiagram : function ExtDataListToolbar_onWorkflowDiagram(e, p_obj) {
      var datalistItemType = this.modules.dataGrid.datalistMeta.itemType;

      // The Contractors Docs and the Engineering Docs nowadays share the same list type, but
      // they have different workflow, so hack the datalistItemType to the old one just to be
      // able to show a different diagram.
      if (datalistItemType == "lysedl:cdlDataList"){
    	  if (this.modules.dataGrid.datalistMeta.name == "Engineerings Documents"){
    		  datalistItemType = "lysedl:engDataList";
    	  }
      }
      var old = window.getPageSize;
      window.getPageSize = function()
      {
        var weirdArrayResult = old();
        weirdArrayResult[0] = window.innerWidth;
        return weirdArrayResult;
      };
      Alfresco.Lightbox.show({ src: Alfresco.constants.URL_RESCONTEXT + 'components/images/workflow-diagrams/' + datalistItemType.replace(':', '_') + '.png' });
    },

    displayCreateForm : function(e, p_obj, title, templateUrl) {
      var datalistMeta = this.modules.dataGrid.datalistMeta, destination = datalistMeta.nodeRef, itemType = datalistMeta.itemType;

      // Intercept before dialog show
      var doBeforeDialogShow = function DataListToolbar_onNewVO_doBeforeDialogShow(p_form, p_dialog) {
        Alfresco.util.populateHTML([ p_dialog.id + "-dialogTitle", this.msg(title) ]);
      };

      // Using Forms Service, so always create new instance
      var createRow = new Alfresco.module.SimpleDialog(this.id + "-createRow");

      createRow.setOptions({
        width : this.options.newItemDialogWidth,
        templateUrl : templateUrl,
        actionUrl : null,
        destroyOnHide : true,
        doBeforeDialogShow : {
          fn : doBeforeDialogShow,
          scope : this
        },
        onSuccess : {
          fn : function DataListToolbar_onNewVO_success(response) {
            YAHOO.Bubbling.fire("dataItemCreated", {
              nodeRef : response.json.persistedObject
            });

            Alfresco.util.PopupManager.displayMessage({
              text : this.msg("message.new-row.success")
            });
          },
          scope : this
        },
        onFailure : {
          fn : function DataListToolbar_onNewVO_failure(response) {
            Alfresco.util.PopupManager.displayMessage({
              text : this.msg("message.new-row.failure")
            });
          },
          scope : this
        }
      }).show();

    },

    /**
     * New NCR button click handler
     *
     * @method onNewNCR
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onNewNCR : function DataListToolbar_onNewNCR(e, p_obj) {
      var datalistMeta = this.modules.dataGrid.datalistMeta, destination = datalistMeta.nodeRef, itemType = datalistMeta.itemType;

      this.displayCreateForm(e, p_obj, "label.new-ncr.title", YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&itemId={itemId}&destination={destination}&formId={formId}&mode={mode}&submitType={submitType}&site={site}&showCancelButton=true", {
        itemKind : "type",
        itemId : itemType,
        destination : destination,
        mode : "create",
        submitType : "json",
        site: Alfresco.constants.SITE
      }));
    },

    /**
     * New VO button click handler
     *
     * @method onNewVO
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onNewVO : function DataListToolbar_onNewVO(e, p_obj) {
      var datalistMeta = this.modules.dataGrid.datalistMeta, destination = datalistMeta.nodeRef, itemType = datalistMeta.itemType;

      this.displayCreateForm(e, p_obj, "label.new-vo.title", YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&itemId={itemId}&destination={destination}&formId={formId}&mode={mode}&submitType={submitType}&site={site}&showCancelButton=true", {
        itemKind : "type",
        itemId : itemType,
        formId : "variationOrder",
        destination : destination,
        mode : "create",
        submitType : "json",
        site: Alfresco.constants.SITE
      }));
    },

    /**
     * New VOR button click handler (basically same as onNewRow)
     *
     * @method onNewVOR
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onNewVOR : function DataListToolbar_onNewVOR(e, p_obj) {
      var datalistMeta = this.modules.dataGrid.datalistMeta, destination = datalistMeta.nodeRef, itemType = datalistMeta.itemType;

      this.displayCreateForm(e, p_obj, "label.new-vor.title", YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&itemId={itemId}&destination={destination}&mode={mode}&submitType={submitType}&site={site}&showCancelButton=true", {
        itemKind : "type",
        itemId : itemType,
        destination : destination,
        mode : "create",
        submitType : "json",
        site: Alfresco.constants.SITE
      }));
    },

	onActionLockItems: function(e)
    {
      var refs = [];
      e.forEach(function(item)
      {
        refs.push(item.nodeRef);
      });
      Alfresco.util.Ajax.jsonPost({
        url : Alfresco.constants.PROXY_URI + "api/lyse/lock-nodes",
        responseContentType : "application/json",
        dataObj : refs,
        successCallback : {
          fn : function () {

            Alfresco.util.PopupManager.displayMessage({
              text : this.msg("message.success")
            });
            location.reload();

          },
          scope : this
        },
        failureCallback : {
          fn : function ExtDataListToolbar_onActionSubmitForReview_failure(response) {
            Alfresco.util.PopupManager.displayMessage({

              text:response.json.message || this.msg("message.failed")
            });
          },
          scope : this
        }
      });
    },

    onActionUnlockItems: function(e)
    {
      var refs = [];
      e.forEach(function(item)
      {
        refs.push(item.nodeRef);
      });
      Alfresco.util.Ajax.jsonPost({
        url : Alfresco.constants.PROXY_URI + "api/lyse/unlock-nodes",
        responseContentType : "application/json",
        dataObj : refs,
        successCallback : {
          fn : function () {

            Alfresco.util.PopupManager.displayMessage({
              text : this.msg("message.success")
            });
            location.reload();

          },
          scope : this
        },
        failureCallback : {
          fn : function ExtDataListToolbar_onActionSubmitForReview_failure(response) {
            Alfresco.util.PopupManager.displayMessage({
              text:response.json.message || this.msg("message.failed")
            });
          },
          scope : this
        }
      });
    },
    /**
     * New milestone button click handler (basically same as onNewRow)
     *
     * @method onNewMilestone
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onNewMilestone : function DataListToolbar_onNewMilestone(e, p_obj) {
      var datalistMeta = this.modules.dataGrid.datalistMeta, destination = datalistMeta.nodeRef, itemType = datalistMeta.itemType;

      this.displayCreateForm(e, p_obj, "label.new-milestone.title", YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&itemId={itemId}&destination={destination}&mode={mode}&submitType={submitType}&site={site}&showCancelButton=true", {
        itemKind : "type",
        itemId : itemType,
        destination : destination,
        mode : "create",
        submitType : "json",
        site: Alfresco.constants.SITE
      }));
    },

    onNewCivilMilestone : function DataListToolbar_onNewCivilMilestone(e, p_obj) {
      var datalistMeta = this.modules.dataGrid.datalistMeta, destination = datalistMeta.nodeRef, itemType = datalistMeta.itemType;

      this.displayCreateForm(e, p_obj, "label.new-milestone.title", YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&itemId={itemId}&destination={destination}&mode={mode}&submitType={submitType}&site={site}&showCancelButton=true", {
        itemKind : "type",
        itemId : itemType,
        destination : destination,
        mode : "create",
        submitType : "json",
        site: Alfresco.constants.SITE
      }));
    },

    onActionReassign : function ExtDataListToolbar_onActionReassign (e, p_obj) {
         this.dialogs.peopleFinder.clearResults();
         this.dialogs.reassignPanel.show();
    },
	onVoidMilestone : function ExtDataListToolbar_onVoidMilestone (e, p_obj) {

        var nodeRefs = [];
        for (var i = 0, j = e.length; i < j; i++) {
          var row = e[i];
          nodeRefs.push(row.nodeRef);
        }


		Alfresco.util.PopupManager.getUserInput(
        {
          title: Alfresco.util.message("dialog.void.title"),
          text: Alfresco.util.message("dialog.void.reason"),
          input: "text",
          callback:
          {
            fn: function promptCallback (comment)
            {
              url = Alfresco.constants.PROXY_URI + "lyse/api/void-milestone";

              var config =
              {
                method: "POST",
                url: url,
                successCallback: {
                  fn: function (response) {
                  	var success = true;
                    if(response.json.status){
                 	  if(response.json.status.code != '200'){
                 	  	success = false;
                    	Alfresco.util.PopupManager.displayMessage({
                         	text : Alfresco.util.message("message.failure.void-milestone")
                    	});
                      }
                    }
                    if(success){
                        Bubbling.fire("dataItemsDuplicated");
                        Alfresco.util.PopupManager.displayMessage({
                                  text : Alfresco.util.message("message.success.void-milestone")
                        });
                    }
                  },
                  scope: this
                },
                failureCallback : {
                  fn : function ExtDataListToolbar_onVoidMilestone_failure(response) {
                    Alfresco.util.PopupManager.displayMessage({
                         text : Alfresco.util.message("message.failure.void-milestone")
                    });
                  },
                  scope : this
                },
                dataObj:
                {
                  nodes: this,
                  comment : comment
                }
                };

              Alfresco.util.Ajax.jsonRequest(config);
            },
          scope : this
        },
        failureCallback : {
          fn : function ExtDataListToolbar_onActionSubmitForReview_failure(response) {
            Alfresco.util.PopupManager.displayMessage({
              text : this.msg("message.failure.void-milestone")
            });
            console.log(response.json.message);
          },
          scope : this
        }
      });
	},

    /**
     * Submit for review
     *
     * @method onActionSubmitForReview
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onActionSubmitForReview : function ExtDataListToolbar_onActionSubmitForReview(e, p_obj) {
      // Collect nodes to operate on.
      var nodesRefs = [];
      for (var i = 0, j = e.length; i < j; i++) {
        var row = e[i];
        var nodeRef = {
          nodeRef : row.nodeRef
        };

        if (this.modules.dataGrid.datalistMeta.itemType === "lysedl:cdlDataList") {

          if (row.itemData.prop_lysedl_cdlCompanyReviewResponsibleAsText === undefined) {
            Alfresco.util.PopupManager.displayPrompt(
                {
                  text: Alfresco.util.message("message.missingReviewers.multiple")
                });
            return false;

          }
        }
        else if (this.modules.dataGrid.datalistMeta.itemType === "lysedl:contractDataList") {
          if (row.itemData.prop_lysedl_contractContractorReviewResponsibleAsText === undefined) {
            Alfresco.util.PopupManager.displayPrompt(
              {
                text: Alfresco.util.message("message.missingReviewers.multiple")
              });
            return false;
          }
        }
        else if (this.modules.dataGrid.datalistMeta.itemType === "lysedl:civilCdlDataList") {

          if (row.itemData.prop_lysedl_civilCdlCompanyReviewResponsibleAsText === undefined) {
            Alfresco.util.PopupManager.displayPrompt(
                {
                  text: Alfresco.util.message("message.missingReviewers.multiple")
                });
            return false;

          }
        }else if (this.modules.dataGrid.datalistMeta.itemType === "lysedl:companysDocumentDataList") {

              if (row.itemData.prop_lysedl_companysDocumentCompanyReviewResponsibleAsText === undefined) {
                  Alfresco.util.PopupManager.displayPrompt(
                      {
                          text: Alfresco.util.message("message.missingReviewers.multiple")
                      });
                  return false;

              }
          }
        else {
          if (row.itemData.prop_lysedl_civilContractContractorReviewResponsibleAsText === undefined) {
            Alfresco.util.PopupManager.displayPrompt(
                {
                  text: Alfresco.util.message("message.missingContractorReviewers.multiple")
                });
            return false;

          }
        }

        nodesRefs.push(nodeRef);
      }

      var payload = {
 	   firstUserTask : "default",
 	   nodes : nodesRefs
 	  };

      Alfresco.util.Ajax.jsonPost({
        url : Alfresco.constants.PROXY_URI + "/lyse/api/start-workflow",
        responseContentType : "application/json",
        dataObj : payload,
        successCallback : {
          fn : function ExtDataListToolbar_onActionSubmitForReview_success(response) {

            Alfresco.util.PopupManager.displayMessage({
              text : this.msg("actions.submit-for-review-success")
            });

          },
          scope : this
        },
        failureCallback : {
          fn : function ExtDataListToolbar_onActionSubmitForReview_failure(response) {
            Alfresco.util.PopupManager.displayMessage({
              text : response.json.message
            });
          },
          scope : this
        }
      });

    },

    /**
     * Void cdl document
     *
     * @method onActionVoid
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onActionVoid : function ExtDataListToolbar_onActionVoid(e, p_obj) {
      // Collect nodes to operate on.
      var nodes = [];
      for (var i = 0, j = e.length; i < j; i++) {
        var row = e[i];
        var nodeRef = {
          nodeRef : row.nodeRef
      };

      if (typeof row.itemData.prop_lysedl_workflowId !== 'undefined') {
	        var workflowId = row.itemData.prop_lysedl_workflowId.value.toString();
	        if (workflowId) {

	             Alfresco.util.PopupManager.displayMessage(
		    	 {
		    	   text: Alfresco.util.message("message.inOngoingWorkflow")
		    	 });
	             return false;

	  	     }
         }

        nodes.push(nodeRef);
      }

      Alfresco.util.PopupManager.getUserInput(
      {
        title: Alfresco.util.message("dialog.void.title"),
        text: Alfresco.util.message("dialog.void.reason"),
        input: "text",
        callback:
        {
           fn: function promptCallback (comment)
           {
              url = Alfresco.constants.PROXY_URI + "lyse/api/void-document";

              var config =
              {
                 method: "POST",
                 url: url,
                 successCallback:
                 {
                    fn: function (response)
                    {
                        // Fire "dataItemsDuplicated" event to refresh datagrid
                        Bubbling.fire("dataItemsDuplicated");
                    	Alfresco.util.PopupManager.displayMessage({
                            text : Alfresco.util.message("actions.void-document-success")
                        });
                    },
                    scope: this
                 },
                 failureCallback : {
                     fn : function ExtDataListToolbar_onActionVoid_failure(response) {
                       Alfresco.util.PopupManager.displayMessage({
                         text : response.json.message
                       });
                     },
                     scope : this
                  },
                  dataObj:
                  {
                	nodes: this,
                    comment : comment
                  }
              };

              Alfresco.util.Ajax.jsonRequest(config);
           },
           scope: nodes
        }
     });


    },
    /**
     * Revoke an engineering workflow
     *
     * @method onActionRevoke
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onActionRevoke : function ExtDataListToolbar_onActionRevoke(e, p_obj) {
      // Collect nodes to operate on.
      var nodes = [];
      for (var i = 0, j = e.length; i < j; i++) {
        var row = e[i];
        var nodeRef = {
          nodeRef : row.nodeRef
        };
        nodes.push(nodeRef);
      }

      Alfresco.util.PopupManager.getUserInput(
      {
        title: Alfresco.util.message("dialog.revoke.title"),
        text: Alfresco.util.message("dialog.revoke.reason"),
        input: "text",
        callback:
        {
           fn: function promptCallback (comment)
           {
              url = Alfresco.constants.PROXY_URI + "lyse/api/revoke-document";

              var config =
              {
                 method: "POST",
                 url: url,
                 successCallback:
                 {
                    fn: function (response)
                    {
                        // Fire "dataItemsDuplicated" event to refresh datagrid
                        Bubbling.fire("dataItemsDuplicated");
                    	Alfresco.util.PopupManager.displayMessage({
                            text : Alfresco.util.message("actions.revoke-document-success")
                        });
                    },
                    scope: this
                 },
                 failureCallback : {
                     fn : function ExtDataListToolbar_onActionRevoke_failure(response) {
                       Alfresco.util.PopupManager.displayMessage({
                         text : response.json.message
                       });
                     },
                     scope : this
                  },
                  dataObj:
                  {
                	nodes: this,
                    comment : comment
                  }
              };

              Alfresco.util.Ajax.jsonRequest(config);
           },
           scope: nodes
        }
     });


    },
      /**
       * Revoke a safe work permit
       *
       * @method onActionRevokeSafeWorkPermit
       * @param e
       *            {object} DomEvent
       * @param p_obj
       *            {object} Object passed back from addListener method
       */
      onActionRevokeSafeWorkPermit : function ExtDataListToolbar_onActionRevokeSafeWorkPermit(e, p_obj) {
          // Collect nodes to operate on.
          var nodes = [];
          for (var i = 0, j = e.length; i < j; i++) {
              var row = e[i];
              var nodeRef = {
                  nodeRef : row.nodeRef
              };

              if (typeof row.itemData.prop_lysedl_workflowId == 'undefined' || typeof row.itemData.prop_lysedl_workflowId == '') {
                // ??
              }
              else {
                nodes.push(nodeRef);
              }
          }

          var config =
              {
                  method: "POST",
                  url: Alfresco.constants.PROXY_URI + "lyse/api/revoke-safe-work-permit",
                  successCallback:
                      {
                          fn: function (response)
                          {
                              // Fire "dataItemsDuplicated" event to refresh datagrid
                              Bubbling.fire("dataItemsDuplicated");
                              // Fire to update the "Selected items" menu
                              Bubbling.fire("selectedItemsChanged");
                              var message = Alfresco.util.message("actions.revoke-safe-work-permit-success");
                              if (response.json.data.failed.length > 0) {
                                  message = Alfresco.util.message("actions.revoke-safe-work-permit-partial-success", this, {
                                    success: response.json.data.success.length,
                                    failed: response.json.data.failed.length
                                  });
                              }
                              Alfresco.util.PopupManager.displayMessage({
                                  text : message
                              });
                          },
                          scope: this
                      },
                  failureCallback : {
                      fn : function ExtDataListToolbar_onActionRevoke_failure(response) {
                          Alfresco.util.PopupManager.displayMessage({
                              text : Alfresco.util.message("actions.revoke-safe-work-permit-failed") +
                              (response.json ? response.json.message : response.serverResponse.statusText)
                          });
                      },
                      scope : this
                  },
                  dataObj:
                      {
                          nodes: nodes
                      }
              };

          Alfresco.util.Ajax.jsonRequest(config);
      },

      /**
       * Complete a Civil Measured Quantity
       *
       * @method onActionCompleteCivilMeasuredQuantity
       * @param e
       *            {object} DomEvent
       * @param p_obj
       *            {object} Object passed back from addListener method
       */
      onActionCompleteCivilMeasuredQuantity : function ExtDataListToolbar_onActionCompleteCivilMeasuredQuantity(e, p_obj) {
        // Collect nodes to operate on.
        var nodes = [];
        for (var i = 0, j = e.length; i < j; i++) {
          var row = e[i];
          var nodeRef = {
              nodeRef : row.nodeRef
          };

          if (typeof row.itemData.prop_lysedl_workflowId == 'undefined' || typeof row.itemData.prop_lysedl_workflowId == '') {
            // ??
          }
          else {
            nodes.push(nodeRef);
          }
        }

        var config =
        {
            method: "POST",
            url: Alfresco.constants.PROXY_URI + "lyse/api/complete-civil-measured-quantities",
            successCallback:
            {
              fn: function (response)
              {
                // Fire "dataItemsDuplicated" event to refresh datagrid
                Bubbling.fire("dataItemsDuplicated");
                // Fire to update the "Selected items" menu
                Bubbling.fire("selectedItemsChanged");
                var message = Alfresco.util.message("actions.complete-civil-measured-quantities-success");
                if (response.json.data.failed.length > 0) {
                  message = Alfresco.util.message("actions.complete-civil-measured-quantities-partial-success", this, {
                    success: response.json.data.success.length,
                    failed: response.json.data.failed.length
                  });
                }
                Alfresco.util.PopupManager.displayMessage({
                  text : message
                });
              },
              scope: this
            },
            failureCallback : {
              fn : function ExtDataListToolbar_onActionRevoke_failure(response) {
                Alfresco.util.PopupManager.displayMessage({
                  text : Alfresco.util.message("actions.complete-civil-measured-quantities-failed") +
                  (response.json ? response.json.message : response.serverResponse.statusText)
                });
              },
              scope : this
            },
            dataObj:
            {
              nodes: nodes
            }
        };

        Alfresco.util.Ajax.jsonRequest(config);
      },

      /**
       * Incomplete a Civil Measured Quantity
       *
       * @method onActionIncompleteCivilMeasuredQuantity
       * @param e
       *            {object} DomEvent
       * @param p_obj
       *            {object} Object passed back from addListener method
       */
      onActionIncompleteCivilMeasuredQuantity : function ExtDataListToolbar_onActionIncompleteCivilMeasuredQuantity(e, p_obj) {
        // Collect nodes to operate on.
        var nodes = [];
        for (var i = 0, j = e.length; i < j; i++) {
          var row = e[i];
          var nodeRef = {
              nodeRef : row.nodeRef
          };

          nodes.push(nodeRef);
        }

        var config =
        {
            method: "POST",
            url: Alfresco.constants.PROXY_URI + "lyse/api/incomplete-civil-measured-quantities",
            successCallback:
            {
              fn: function (response)
              {
                // Fire "dataItemsDuplicated" event to refresh datagrid
                Bubbling.fire("dataItemsDuplicated");
                // Fire to update the "Selected items" menu
                Bubbling.fire("selectedItemsChanged");
                var message = Alfresco.util.message("actions.incomplete-civil-measured-quantities-success");
                if (response.json.data.failed.length > 0) {
                  message = Alfresco.util.message("actions.incomplete-civil-measured-quantities-partial-success", this, {
                    success: response.json.data.success.length,
                    failed: response.json.data.failed.length
                  });
                }
                Alfresco.util.PopupManager.displayMessage({
                  text : message
                });
              },
              scope: this
            },
            failureCallback : {
              fn : function ExtDataListToolbar_onActionRevoke_failure(response) {
                Alfresco.util.PopupManager.displayMessage({
                  text : Alfresco.util.message("actions.incomplete-civil-measured-quantities-failed") +
                  (response.json ? response.json.message : response.serverResponse.statusText)
                });
              },
              scope : this
            },
            dataObj:
            {
              nodes: nodes
            }
        };

        Alfresco.util.Ajax.jsonRequest(config);
      },

      onActionCivilMilestoneSubmitInvoice : function ExtDataListToolbar_onActionCivilMilestoneSubmitInvoice(e, p_obj) {
        // Collect nodes to operate on.
        var nodes = [];
        for (var i = 0, j = e.length; i < j; i++) {
          var row = e[i];
          var nodeRef = {
              nodeRef : row.nodeRef
          };
          nodes.push(nodeRef);
        }

        var config =
        {
          method: "POST",
          url: Alfresco.constants.PROXY_URI + "lyse/api/civil-milestone-submit-invoice",
          successCallback:
          {
            fn: function (response)
            {
              // Fire "dataItemsDuplicated" event to refresh datagrid
              Bubbling.fire("dataItemsDuplicated");
              // Fire to update the "Selected items" menu
              Bubbling.fire("selectedItemsChanged");
              var message = Alfresco.util.message("actions.civil-milestone-submit-invoice-success");
              if (response.json.data.failed.length > 0) {
                message = Alfresco.util.message("actions.civil-milestone-submit-invoice-partial-success", this, {
                  success: response.json.data.success.length,
                  failed: response.json.data.failed.length
                });
              }
              Alfresco.util.PopupManager.displayMessage({
                text : message
              });
            },
            scope: this
          },
          failureCallback : {
            fn : function ExtDataListToolbar_onActionRevoke_failure(response) {
              Alfresco.util.PopupManager.displayMessage({
                text : Alfresco.util.message("actions.civil-milestone-submit-invoice-failed") +
                (response.json ? response.json.message : response.serverResponse.statusText)
              });
            },
            scope : this
          },
          dataObj:
          {
            nodes: nodes
          }
        };

        Alfresco.util.Ajax.jsonRequest(config);
      },

      /**
       * Complete a safe work permit
       *
       * @method onActionCompleteSafeWorkPermit
       * @param e
       *            {object} DomEvent
       * @param p_obj
       *            {object} Object passed back from addListener method
       */
      onActionCompleteSafeWorkPermit : function ExtDataListToolbar_onActionCompleteSafeWorkPermit(e, p_obj) {
        // Collect nodes to operate on.
        var nodes = [];
        for (var i = 0, j = e.length; i < j; i++) {
            var row = e[i];
            var nodeRef = {
                nodeRef : row.nodeRef
            };

            if (typeof row.itemData.prop_lysedl_workflowId == 'undefined' || typeof row.itemData.prop_lysedl_workflowId == '') {
                // ??
            }
            else {
                nodes.push(nodeRef);
            }
        }

        var config =
            {
                method: "POST",
                url: Alfresco.constants.PROXY_URI + "lyse/api/complete-safe-work-permit",
                successCallback:
                    {
                        fn: function (response)
                        {
                            // Fire "dataItemsDuplicated" event to refresh datagrid
                            Bubbling.fire("dataItemsDuplicated");
                            // Fire to update the "Selected items" menu
                            Bubbling.fire("selectedItemsChanged");
                            var message = Alfresco.util.message("actions.complete-safe-work-permit-success");
                            if (response.json.data.failed.length > 0) {
                                message = Alfresco.util.message("actions.complete-safe-work-permit-partial-success", this, {
                                  success: response.json.data.success.length,
                                  failed: response.json.data.failed.length
                                });
                            }
                            Alfresco.util.PopupManager.displayMessage({
                                text : message
                            });
                        },
                        scope: this
                    },
                failureCallback : {
                    fn : function ExtDataListToolbar_onActionRevoke_failure(response) {
                        Alfresco.util.PopupManager.displayMessage({
                            text : Alfresco.util.message("actions.complete-safe-work-permit-failed") +
                            (response.json ? response.json.message : response.serverResponse.statusText)
                        });
                    },
                    scope : this
                },
                dataObj:
                    {
                        nodes: nodes
                    }
            };

        Alfresco.util.Ajax.jsonRequest(config);
    },

    /**
     * New Row button click handler
     *
     * @method onNewRow
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onNewRow : function ExtDataListToolbar_onNewRow(e, p_obj) {
      var datalistMeta = this.modules.dataGrid.datalistMeta, destination = datalistMeta.nodeRef, itemType = datalistMeta.itemType;

      // Intercept before dialog show
      var doBeforeDialogShow = function DataListToolbar_onNewRow_doBeforeDialogShow(p_form, p_dialog) {
        Alfresco.util.populateHTML([ p_dialog.id + "-dialogTitle", this.msg("label.new-row.title") ], [ p_dialog.id + "-dialogHeader", this.msg("label.new-row.header") ]);
      };

      var templateUrl = YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&itemId={itemId}&destination={destination}&mode={mode}&submitType={submitType}&site={site}&showCancelButton=true", {
        itemKind : "type",
        itemId : itemType,
        destination : destination,
        mode : "create",
        submitType : "json",
        site: Alfresco.constants.SITE
      });

      // Using Forms Service, so always create new instance
      var createRow = new Alfresco.module.SimpleDialog(this.id + "-createRow");

      createRow.setOptions({
        width : "800px",
        templateUrl : templateUrl,
        actionUrl : null,
        destroyOnHide : true,
        doBeforeDialogShow : {
          fn : doBeforeDialogShow,
          scope : this
        },
        onSuccess : {
          fn : function DataListToolbar_onNewRow_success(response) {
            YAHOO.Bubbling.fire("dataItemCreated", {
              nodeRef : response.json.persistedObject
            });

            Alfresco.util.PopupManager.displayMessage({
              text : this.msg("message.new-row.success")
            });
          },
          scope : this
        },
        onFailure : {
          fn : function DataListToolbar_onNewRow_failure(response) {
            Alfresco.util.PopupManager.displayMessage({
              text : this.msg("message.new-row.failure")
            });
          },
          scope : this
        }
      }).show();
    }

  }, true);
})();
