(function()
{
   /**
    * YUI Library aliases
    */
   var Dom = YAHOO.util.Dom;
	
    Alfresco.ChangePermissionDialog = function(htmlId)
    {
	      Alfresco.ChangePermissionDialog.superclass.constructor.call(this, htmlId);

	      this.eventGroup = htmlId;
	      this.currentValues = [];
	      this.selectedValues = {};
	      return this;
    };
    
	YAHOO.extend(Alfresco.ChangePermissionDialog, Alfresco.module.SimpleDialog,
	{
		  preDefinedChoices: null,
          callBackMethod:
          {
             fn: null,
             obj: null,
             scope: this
          },
          
	      currentValues: null,
	      selectedValues: null,
	      
	      eventGroup: null,
	      nodeRef: null,
	      site: null,
	      url: null,
	      _visible: true,
          _removedGroups: [],
          _addedGroups: [],
          _originalGroups: [],
          _groups: [],
         
	      setOptions: function ChangePermissionDialog_setOptions(obj)
		  {
	    	 // nodeRef is used to get specific permissions on a noderef
	    	 this.nodeRef = obj.nodeRef,
	    	 
	    	 // url is used to 
	    	 this.url = obj.url,
	    	 
	    	 // callbackmethod is used if we dont want to "submit" anything but return data instead
	    	 this.callBackMethod = obj.callBackMethod,
	    	 
	    	 // Predefinedchoices is used to show certain groups as "added"
	    	 this.preDefinedChoices = obj.preDefinedChoices,
	    	 
	    	 Alfresco.ChangePermissionDialog.superclass.setOptions.call(this,
	         {
	            doBeforeDialogShow:
	            {
	               fn: this.doBeforeDialogShow,
	               obj: null,
	               scope: this
	            },
	            doBeforeFormSubmit:
	            {
	               fn: this.doBeforeFormSubmit,
	               obj: null,
	               scope: this
	            }
	         });

	         this.options = YAHOO.lang.merge(this.options, obj);
	         return this;
	      },
	      doBeforeFormSubmit: function ChangePermissionDialog_doBeforeFormSubmit(){
			// Make JSON with all selected groups
		    var addedGroups = [];
	        for (var group in this._groups)
	        {
		      if(this._groups[group].hasOwnProperty('displayName')){  
	    	  addedGroups.push({
	    		  "displayName" : this._groups[group].displayName, 
	    		  "itemName" : this._groups[group].itemName
	    		  });
		      }
		    }
	      
		    // No groups selected, lets just send null. 
	        //(SetPermissionOnNoderef will put inherit=true on noderef if null arrives).
		    if(addedGroups.length < 1){
			  addedGroups = null;
		  	}
			  
    		// Invoke the callback if one was supplied
            if (this.callBackMethod && typeof this.callBackMethod.fn == "function")
            {
               this.callBackMethod.fn.call(this.callBackMethod.scope, addedGroups, this.callBackMethod.obj);
               this.onHideEvent();
            }
	    	else if(!(this.returnData) && this.nodeRef){
		      // If property is set to false (default) and nodeRef exists
			  // Call webscript SetPermissionOnNoderef
	    	  var nodeRefParts = this.ParseNodeRefString(this.nodeRef);
              var url = 'api/lyse/setPermissions/' + nodeRefParts.storeType + '/' + nodeRefParts.storeId + '/' + nodeRefParts.id;
	          Alfresco.util.Ajax.jsonRequest({
	              method: "POST",
	              url: Alfresco.constants.PROXY_URI + url,
	              dataObj : {
	                groups : addedGroups
	              }
	            });
	    	  }
	      },
	      onDialogDestroy: function() {
			  // Make sure all is cleared!
			  this.resetGroups();
              YAHOO.Bubbling.unsubscribe("itemSelected",this.onGroupSelected, this);
              YAHOO.Bubbling.unsubscribe("removeGroupUpdate", this.onRemoveGroupUpdate, this);
              YAHOO.Bubbling.unsubscribe("formContainerDestroyed", this.clearcrap, this);
	      },
	      doBeforeDialogShow: function ChangePermissionDialog_doBeforeDialogShow()
	      {
	    	  // This is to clear old events so they wont mess with new dialogs etc.
	          YAHOO.Bubbling.on("formContainerDestroyed",this.onDialogDestroy,this);

              // events we are interested in
              YAHOO.Bubbling.on("itemSelected",this.onGroupSelected, this);
              YAHOO.Bubbling.on("removeGroupUpdate", this.onRemoveGroupUpdate, this);
            
	          // Load in the Groups Finder component from the server
	          Alfresco.util.Ajax.request(
	          {
	             url: Alfresco.constants.URL_SERVICECONTEXT + "components/people-finder/lyse-group-finder",
	             dataObj:
	             {
	                htmlid: this.id + "-update-groupfinder"
	             },
	             successCallback:
	             {
	                fn: this.onGroupFinderLoaded,
	                scope: this
	             },
	             failureMessage: "Could not load Group Finder component",
	             execScripts: true
	          });
	      },
	      ParseNodeRefString: function CommentAuthorityDialog_ParseNodeRefString(nodeRefString){
		    var nodeRefRegEx = new RegExp(/^(\w+):\/\/(\w+)\/([\w\d\-]+)$/);
		    var match = nodeRefString.match(nodeRefRegEx);
		    if(match === null){
		      return false;
		    }
		    return {
		      nodeRef : match[0],
		      storeType : match[1],
		      storeId : match[2],
		      id : match[3],
		      forURL : match[1] + '/' + match[2] + '/' + match[3]
		    };
		  },
          onGroupFinderLoaded: function onGroupFinderLoaded(res)
          {
             // Inject the component from the XHR request into it's placeholder DIV element
             var finderDiv = Dom.get(this.id + "-update-groupfinder");
             finderDiv.innerHTML = res.serverResponse.responseText;
             
             // Find the Group Finder by container ID 
             this.modules.updateGroupFinder = Alfresco.util.ComponentManager.get(this.id + "-update-groupfinder");

             // Set our custom options to lyse-group-finder
             var shortName = (Alfresco.constants.SITE != "") ? Alfresco.constants.SITE : (this.site != null) ? this.site : "";
             this.modules.updateGroupFinder.setOptions(
             {
                viewMode: Alfresco.LyseGroupFinder.VIEW_MODE_COMPACT,
                singleSelectMode: false,
                makeSelectOnlyMode: true,
                searchWhenLoaded: true,
                initSearchTerm: "notnull",
                dataWebScript: "api/lyse/"+shortName+"/getSiteGroups"
             });
             
			 // Make sure variables is cleared!
			 this.resetGroups();
             
			 
			 // This if-else statement is used to pre-add groups in permission dialog.
			 if (this.callBackMethod && typeof this.callBackMethod.fn == "function")
	         {
			   // If we have a callback method, we could also have some already chosen groups, lets add them!
			   if(this.preDefinedChoices)
			   {
				 this.preAddGroups(this.preDefinedChoices);
			   }
	         }else{
				 // If we do not have a callback method, 
	        	 // this statement calls a webscript to get current permissions on nodeRef
	           if(this.nodeRef){
				 var preAddGroups = 
				 {			 
				   success: function(o) 
				   {
				     var values = YAHOO.lang.JSON.parse(o.responseText);
				     this.preAddGroups(values.data);
				   },
				   failure: function(o) 
				   {
					   Alfresco.util.PopupManager.displayMessage({text: "Could not load values!"});
				   },
				   scope: this
				 };
				 var nodeRefParts = this.ParseNodeRefString(this.nodeRef);
				 var url = Alfresco.constants.PROXY_URI +  this.url + nodeRefParts.storeType + '/' + nodeRefParts.storeId + '/' + nodeRefParts.id;
				 YAHOO.util.Connect.asyncRequest('GET', url, preAddGroups, null);
	           }
	         } 
         },
         preAddGroups: function (groupArr){
           for(var group in groupArr){
			 if (groupArr.hasOwnProperty(group)) {
               // If we have inherit, do not add any groups.
               if(!groupArr[group].hasOwnProperty('inherit')){
       	         // Show group as added.
	 	         this.addGroup(groupArr[group]);
	 	         // Disable groups "add"-button
     	         this.modules.updateGroupFinder.selectedItems[groupArr[group].itemName] = true; 
               } 
             }
           }
         },
         /**
          *  Below functions is to make lyse-group-finder work. 
          */
         onGroupSelected: function onGroupSelected(e, args)
         {
             if (this._visible)
             {
                this.addGroup(args[1]);
             }
         },
         addGroup: function addGroup(group)
         {
            var found = false;
            
            var groupFinder = this.modules.updateGroupFinder;
            if(!groupFinder){
            	groupFinder = Alfresco.util.ComponentManager.get(this.id + "-update-groupfinder");
            }
            
            if (Alfresco.util.findInArray(this._groups, group.itemName, "itemName"))
            {
               found = true;
            }
            if (!found)
            {
               this._groups.push(group);

               var groupDiv = Dom.get(this.id + "-update-groups"),
                  idx = (this._groups.length-1),
                  groupEl = document.createElement("span");
               groupEl.setAttribute("id", this.id + "_group" + idx);
               groupEl.setAttribute("title", "Remove Group");
               Dom.addClass(groupEl, "group-item");
               groupEl.innerHTML = group.displayName;
               groupDiv.appendChild(groupEl);

               Alfresco.util.useAsButton(groupEl, function(e, obj)
               {
                  // Remove group from ui
                  YAHOO.Bubbling.fire('removeGroupUpdate', { id: obj.idx, itemName: obj.group.itemName });

                  // Tell group finder to deselect the group
                  YAHOO.Bubbling.fire('itemDeselected', { eventGroup: groupFinder, itemName: obj.group.itemName });
               }, { idx: idx, group: group });

               // if this group wasn't one of the original list, then add it to the addition list
               found = false;
               if (Alfresco.util.findInArray(this._originalGroups, group.itemName, "itemName"))
               {
                  found = true;
               }

               if (!found)
               {
                  this._addedGroups.push(group.itemName);
               }

               // if the group has been removed before, remove it from the removed groups list
               if (Alfresco.util.arrayContains(this._removedGroups, group.itemName))
               {
                  Alfresco.util.arrayRemove(this._removedGroups, group.itemName);
               }
            }
         },
         onRemoveGroupUpdate: function onRemoveGroupUpdate(e, args)
         {
            var id = args[1].id,
                itemName = args[1].itemName;
            var group = Alfresco.util.findInArray(this._groups, itemName, "itemName");
            if (group != null)
            {
            	// find group we clicked on, then remove it.
               var el = Dom.get(this.id + "_group" + id);
               el.parentNode.removeChild(el);
               Alfresco.util.arrayRemove(this._groups, group);

               // if this group was one of the original list, then add it to the removed list
               if (Alfresco.util.findInArray(this._originalGroups, group.itemName, "itemName"))
               {
                  this._removedGroups.push(group.itemName);
               }

               // also remove from the added groups list
               if (Alfresco.util.arrayContains(this._addedGroups, group.itemName))
               {
                  Alfresco.util.arrayRemove(this._addedGroups, group.itemName);
               }
            }
         },
         getAddedGroups: function getAddedGroups()
         {
            return this._addedGroups;
         },
         getRemovedGroups: function getRemovedGroups()
         {
            return this._removedGroups;
         },
         resetGroups: function resetGroups()
         {
            this._groups = [];
            this._addedGroups = [];
            this._removedGroups = [];
            Dom.get(this.id + "-update-groups").innerHTML = "";
         }
         
	  });

})();

