(function()
{
   /**
    * YUI Library aliases
    */
   var Dom = YAHOO.util.Dom;
	
    Alfresco.CommentAuthorityDialog = function(htmlId)
    {
        this.isFormOwner = false;
	      Alfresco.CommentAuthorityDialog.superclass.constructor.call(this, htmlId);
	      this.eventGroup = htmlId;
	      return this;
    };
    
	YAHOO.extend(Alfresco.CommentAuthorityDialog, Alfresco.module.SimpleDialog,
	{
		    addedGroups: null,
	      eventGroup: null,
	      nodeRef: null,
	      site: null,
	      url: null,
         
	      setOptions: function CommentAuthorityDialog_setOptions(obj)
		  {
	    	 // First set our custom options, then put SimpleDialog options.
	    	 this.nodeRef = obj.nodeRef,
	    	 this.url = obj.url,
	    	 Alfresco.CommentAuthorityDialog.superclass.setOptions.call(this,
	         {
	            doBeforeDialogShow:
	            {
	               fn: this.doBeforeDialogShow,
	               obj: null,
	               scope: this
	            },
	            doBeforeFormSubmit:
	            {
	               fn: this.doBeforeFormSubmit,
	               obj: null,
	               scope: this
	            },
	         });

	         this.options = YAHOO.lang.merge(this.options, obj);
	         return this;
	      },
	      ParseNodeRefString: function CommentAuthorityDialog_ParseNodeRefString(nodeRefString){
		    var nodeRefRegEx = new RegExp(/^(\w+):\/\/(\w+)\/([\w\d\-]+)$/);

		    var match = nodeRefString.match(nodeRefRegEx);
		    if(match === null){
		      return false;
		    }

		    return {
		      nodeRef : match[0],
		      storeType : match[1],
		      storeId : match[2],
		      id : match[3],
		      forURL : match[1] + '/' + match[2] + '/' + match[3]
		    };
		  },
	      doBeforeFormSubmit: function CommentAuthorityDialog_doBeforeFormSubmit(){
	    	  // Call webscript to add comment
          var commentBody = window.commentEditor.getContent();
	          
	    	  var nodeRefParts = this.ParseNodeRefString(this.nodeRef);
	          Alfresco.util.Ajax.jsonPost({
	              url : Alfresco.constants.PROXY_URI
	              + this.url
	              + nodeRefParts.storeType
	              + '/'
	              + nodeRefParts.storeId
	              + '/' + nodeRefParts.id,
	              dataObj : {
		            content : commentBody,
		            permission : "All",
	                groups : this.addedGroups
	              },
	            });
              commentsDataTable.refreshData();
              this.onHideEvent();
	      },
	      addGroups: function(response){
		    this.addedGroups = response;	
		    this.resetGroupsFromDialog();	
		    this.addGroupsToDialog();
		  },
      permissionDialog: function(evt) {
        // Get the comment-dialog and its functions to use as callback and prepopulate permission dialog.
        var commentDialog = Alfresco.util.ComponentManager.get(evt.target.commentDialogId);
        var changePermissionDialog = new Alfresco.ChangePermissionDialog("${controlId}-changePermissionDialog");
        var templateUrl = Alfresco.constants.URL_SERVICECONTEXT + "components/comments/change-permission-dialog";
        var shortName = (Alfresco.constants.SITE != "") ? Alfresco.constants.SITE : (this.site != null) ? this.site : "";
        changePermissionDialog.setOptions(
        {
          nodeRef: this.nodeRef,
          site: shortName,
          url: 'api/lyse/getPermissions/',
          width: "40em",
          templateUrl: templateUrl,
          destroyOnHide: true,
          preDefinedChoices: commentDialog.addedGroups,
          callBackMethod:
          {
          fn: commentDialog.addGroups,
          scope: commentDialog
          }
        });
        changePermissionDialog.show();
	      },
	      doBeforeDialogShow: function CommentAuthorityDialog_doBeforeDialogShow()
	      {
	    	  // Make our comment textbox a richtext box.
	    	  var editor = new Alfresco.util.RichEditor(
              Alfresco.constants.HTML_EDITOR, this.id + "-editorForComment",{
              menubar : false,
              statusbar : false,
              language : 'sv'
              }
          );

	    	  editor.render();
	    	  window.commentEditor = editor;
	    	  window.commentDialog = this;

	    	  
	    	  // Disable post-button at first!
          var okButton = Dom.get(this.id + "-ok-button");
          window.commentDialog.widgets.okButton.set("disabled", true);
          okButton.setAttribute("class", "post-button-disabled");
	    	  
            // Setup event that enables post-button if comment area has any content.
          editor.getEditor().on('keyup', function(e) {
            var currentEditorContent = this.getContent();
            window.commentDialog.widgets.okButton.set("disabled", currentEditorContent === "");
            if(window.commentDialog.widgets.okButton.get("disabled"))
              okButton.setAttribute("class", "post-button-disabled");
            else
              okButton.removeAttribute("class");
          });
	      },
	      // Below functions is for comment-window gui to display groups
	      resetGroupsFromDialog: function(){
	        var groupDiv = Dom.get(this.id + "-update-groups");
	        while (groupDiv.firstChild) {
	    	  groupDiv.removeChild(groupDiv.firstChild);
	    	}
	      },
	      addGroupsToDialog: function (){
	    	var me = this;
		    for(var group in this.addedGroups){
	          var groupDiv = Dom.get(this.id + "-update-groups"),
            idx = (this.addedGroups.length-1),
            groupEl = document.createElement("span");
	          groupEl.setAttribute("id", this.addedGroups[group].itemName);
	          groupEl.setAttribute("title", "Remove Group");
	          Dom.addClass(groupEl, "group-item");
	          groupEl.innerHTML = this.addedGroups[group].displayName;
	          groupDiv.appendChild(groupEl);
	          
              Alfresco.util.useAsButton(groupEl, function(e, obj)
              {
        	    var button = Dom.get(this.id);
        	    button.parentNode.removeChild(button);
  		        for(var group in me.addedGroups){
	    	      if(me.addedGroups[group].itemName == this.id && group > -1)
	    	      {
	    	    	  me.addedGroups.splice(group, 1);
	    	      }
  		        }
              }, { idx: idx, group: me.addedGroups[group] });
	        }
	      }
	  });

})();

