var console = console || {log:function(e){},error:function(){}};

(function()
    {
  window.SVK = window.SVK || {};
  window.SVK.documentCommentDataTable = window.SVK.documentCommentDataTable || {};

  window.SVK.parseNodeRefString = function(nodeRefString){
    var nodeRefRegEx = new RegExp(/^(\w+):\/\/(\w+)\/([\w\d\-]+)$/);

    var match = nodeRefString.match(nodeRefRegEx);
    if(match === null){
      return false;
    }

    return {
      nodeRef : match[0],
      storeType : match[1],
      storeId : match[2],
      id : match[3],
      forURL : match[1] + '/' + match[2] + '/' + match[3]
    };
  };

  var documentCommentDataTable = {
      getCommentDataTable : function(options){

        if(options.editable === undefined){
          options.editable = true;
        }

        options.allowAnswerImage = 'res/images/mail-reply.png';
        options.padlockImage = 'res/components/images/padlock.gif';
        options.padlockImageRed = 'res/components/images/padlockred.gif';

        var Dom = YAHOO.util.Dom;
        var container = Dom.get(options.containerId);

        var versionWidth = 40;
        var userNameWidth = 142;
        var dateWidth = 100;
        var answerWidth = 0;
        var permissionWidth = 60;
        var contentWidth;

        // Calculate width of content column
        var tableWidth = Dom.get(container).clientWidth;
        // padding right, padding left, border right, border-spacing-right, border-spacing-left
        var margin = 10 + 10 + 1 + 2 + 2;
        contentWidth = tableWidth - (versionWidth+margin) - (permissionWidth+margin) - (userNameWidth+margin) - (dateWidth+margin) - (answerWidth+margin);

        var commentIsDoneFormatter = options.commentIsDoneFormatter || "checkbox";
        var checkboxClickEvents = options.checkboxClickEvents || {};
        var documentNodeRef = options.documentNodeRef;
        var replyToCommentFunction = options.replyToCommentFunction || function(nodeRef){console.log('placeholder answerCommentFuction', nodeRef, arguments)};
        var changePermissionFunction = options.changePermissionFunction || function(nodeRef){console.log('placeholder changePermissionFunction', nodeRef, arguments)};

        if(options.editable === false){
          //console.log('Noep, not editable. disable the answer-click function and show another reply image that is gray')
          commentIsDoneFormatter = SVK.DataTable.formatters.trueFalseIndicatorFactory();

          // Function that does not doe anything.
          replyToCommentFunction = function(){};

          options.allowAnswerImage = 'res/images/mail-reply-disabled.png';
        }

        var groups = [];
        
        var commentDataTableColumnDefs = [
	      {key: "documentCommentDocumentVersion", label: Alfresco.util.message('label.documentCommentsVersionLabel'), sortable: true, width:versionWidth},
	      {key: "inheritParentPermission", label: "", sortable: true, formatter: SVK.DataTable.formatters.imageFormatterFactory(
	          {
	            showImageFunction : function(inheritParentPermission, oRecord){
	            	if(!inheritParentPermission){
	            		groups = JSON.parse(oRecord.getData('authority'));
	            	}
	            	else{
	            		groups = [{itemName: "all_members", displayName: "<<All Members>>"}];
	            	}
	            },
	            getImageSource : function(inheritParentPermission){
	            	if(inheritParentPermission){
	            		return Alfresco.constants.URL_CONTEXT + options.padlockImage;
	            	}else{
	            		return Alfresco.constants.URL_CONTEXT + options.padlockImageRed;
	            	}
	            },
	            getTitleTextFunction : function(){
	            	return groups;
	            },
	            showPointer : true
	          },
	          {
	            showImageFunction : function(allowAnswer, oRecord){
	              if(!allowAnswer){
	                return false;
	              }
	
	              if(oRecord.getData('documentCommentIsDone') === true){
	                return false;
	              }
	
	              return true;
	            },
	            getImageSource : function(){
	              return Alfresco.constants.URL_CONTEXT + options.allowAnswerImage;
	            },
	            getTitleTextFunction : function(){
	              if(options.editable === false){
	                return '';
	              }
	              return Alfresco.util.message('label.documentCommentsAnswerTitleLabel');
	            },
	            showPointer : true
	          }
	      ), width: permissionWidth},
	      {key: "commentBody", label: Alfresco.util.message('label.documentCommentsBodyReplyLabel'), sortable: true, width: contentWidth},
	      {key: "userName", label:Alfresco.util.message('label.documentCommentsUserNameLabel'), sortable: true, width:userNameWidth},
	      {key: "dateCreated", label: Alfresco.util.message('label.documentCommentsDateLabel'), sortable: true, width:dateWidth, formatter: SVK.DataTable.formatters.dateFormatterFactory()}
	    ];

        var commentsDataTable = SVK.DataTable.getDataTable(
            {
              tableId : options.containerId,
              dataSourceURL: Alfresco.constants.PROXY_URI + "svk/document/getcomments?nodeRef=" + documentNodeRef,
              responseSchema : {
                resultsList: "records",
                fields: ["documentCommentDocumentVersion", "allowAnswer", "inheritParentPermission","owner","authority", "postNodeRef", "version", "commentBody", "userName", "dateCreated", "documentCommentIsDone"]
              },
              columnDefs: commentDataTableColumnDefs,
              serializerConf : {
                fields : {
                  postNodeRef : 'value',
                  version : "value",
                  inheritParentPermission: "value",
                  userName : "value",
                  date : "value",
                  documentCommentIsDone : "value",
                  allowUser : "value",
                  documentCommentDocumentVersion : "value"
                }
              },
              checkboxClickEvents : checkboxClickEvents,
              linkClickEvents : {
/*
            	  commentpermission : function(record){
            		  // If we are owner of comment we can edit permissions!
                      if(record._oData.owner == Alfresco.constants.USERNAME){
                          var nodeRef = record.getData('postNodeRef');
                		  changePermissionFunction(nodeRef);
                          return true;
                        }
                      return undefined;
            	  },
*/
            	  commentreply : function(record) {
                  if(record.getData('allowAnswer') !== true){
                    return undefined;
                  }
                  if(record.getData('documentCommentIsDone') === true){
                    return undefined;
                  }
                  var nodeRef = record.getData('postNodeRef');

                  // Call the funtion we defined earlier.
                  replyToCommentFunction(nodeRef);

                  return true;
                }
              },
              layout: {
                width: Dom.get(container).clientWidth + "px"
              },
              messages: {
                empty : Alfresco.util.message('label.documentCommentsNoCommentsFound')
              }
            }
        );
        return commentsDataTable;
      }
  };

  window.SVK.documentCommentDataTable = documentCommentDataTable;
    })();
