(function() {
  window.SVK = window.SVK || {};

  var writeCommentPopupFunction = function(options) {
    var selectBox ="<div id='editorForComment'></div><br/>";
    if(!options.isReply) {
      selectBox = selectBox +
      "<label>Permission</label><br/>" +
      "<select id='permissionSelectBox'>" +
      "<option value=All>All</option>" +
      "</select>";
    }
    var nodeRef = Alfresco.util.parseURL().queryParams.nodeRef;
    Alfresco.util.Ajax.jsonGet({
      url: Alfresco.constants.PROXY_URI + "api/lyse/people/groups-in-site/?nodeRef=" + nodeRef + "&userName="+Alfresco.constants.USERNAME,
      responseContentType : "application/json",
      successCallback: {
        fn: function (response) {
          if (response.json !== undefined) {
            var contractorGroups = response.json.contractorGroups;
            var companyGroups = response.json.companyGroups;
            var selectId = document.getElementById("permissionSelectBox");
            var option;
            if(contractorGroups != null && contractorGroups.length > 0 && selectId) {
              for(var i = 0; i < contractorGroups.length; i++) {
                option = document.createElement("option");
                option.text = "Contractor: "+contractorGroups[i].title;
                option.value = "Contractor: "+contractorGroups[i].shortName;
                selectId.add(option);
              }
            }
            if(companyGroups != null && companyGroups.length > 0 && selectId) {
              option = document.createElement("option");
              option.text = "Company";
              option.value = "Company";
              selectId.add(option);
            }
          }
        },
        scope: this
      }
    });

    var dialog = Alfresco.util.PopupManager.getUserInput({
      title : options.title || Alfresco.util.message('label.newCommentPopupTitleGR1'),
      close : false,
      buttons : [{
        text : Alfresco.util.message('label.gr1NewCommentPopupSaveButtonLabel'),
        handler : function() {
          var commentBody = window.commentEditor.getContent();
          var nodeRefParts = SVK.parseNodeRefString(options.nodeRefString);
          var permission = typeof(permissionSelectBox) === "undefined" ? null: permissionSelectBox.value;

          Alfresco.util.Ajax.jsonPost({
            url : Alfresco.constants.PROXY_URI
            + options.url
            + nodeRefParts.storeType
            + '/'
            + nodeRefParts.storeId
            + '/' + nodeRefParts.id,
            dataObj : {
              content : commentBody,
              permission : permission
            },
            failureMessage : Alfresco.util
            .message('label.gr1NewCommentErrorMessage'),
            successCallback : {
              fn : function() {
                this.hide();
                Alfresco.util.PopupManager.displayMessage({
                  text : options.successMessage || Alfresco.util.message('label.gr1NewCommentSaved')
                });

                commentsDataTable.refreshData();
              },
              scope : this
            }
          });
        }
      },
      {
        text : Alfresco.util.message('label.gr1NewCommentPopupCancelButtonLabel'),
        handler : function() {
          this.hide();
        }
      }],
      html: selectBox
    });

    // Instantiate a new rich text editor.
    var editor = new Alfresco.util.RichEditor(
        Alfresco.constants.HTML_EDITOR, "editorForComment", {
        menubar : false,
        statusbar : false,
          language : 'sv'
        });
    editor.render();

    // Globalize editor and dialog
    window.commentEditor = editor;
    window.commentDialog = dialog;

    // bind keyup on the new RichTextEditor and toggle the 'Save' button
    editor.getEditor().on('keyup', function(e) {
      var currentEditorContent = this.getContent();
      // Toggle enable/disable on the Save button
      dialog.getButtons()[0].set("disabled", currentEditorContent === "");
    });

  };

  window.SVK.documentComments = window.SVK.documentComments || {};

  window.SVK.documentComments.writeCommentPopup = writeCommentPopupFunction;
}());
