// @overridden projects/slingshot/source/web/components/documentlibrary/documentlist.js

/**
 *
 * Copy paste original function generateFilefolderLinkMarkup
 *
 * Added: at the end of method add sitename to links.
 *
 */
(function (generateFileFolderLinkMarkup) {
    /**
     * This is a copy of the original one with one modification: instead of redirecting to the document library of the
     * repository, it now closes the window OR redirects to the user home.
     */
    Alfresco.DocumentList.generateFileFolderLinkMarkup = function Lyse_DL_generateFileFolderLinkMarkup(scope, record)
    {
      var jsNode = record.jsNode,
        recordSite = Alfresco.DocumentList.getRecordSite(record),
        currentSite = scope.options.siteId,
        recordPath = record.location.path,
        recordRepoPath =  record.location.repoPath,
        html;

      if (jsNode.isLink)
      {
        var fileName = Alfresco.util.isValueSet(jsNode.linkedNode.properties) ? jsNode.linkedNode.properties.name : null;
        var linkedNodeIsContainer = jsNode.linkedNode.isContainer;

        if (!linkedNodeIsContainer && (Alfresco.constants.PAGECONTEXT == "shared" || Alfresco.constants.PAGECONTEXT == "mine")) {
          if (jsNode.linkedNode.nodeRef != undefined) {

            var strNodeRef = jsNode.linkedNode.nodeRef.toString();
            html = window.location.protocol + "//" + window.location.host + Alfresco.constants.URL_PAGECONTEXT + "document-details?nodeRef=" + strNodeRef;
          }
          else
          {
            Alfresco.logger.debug("The original document was deleted! So the node reference is null!");
          }
        }
        else if (linkedNodeIsContainer)
        {
          if (Alfresco.util.isValueSet(scope.options.siteId) && record.location.site && record.location.site.name !== scope.options.siteId)
          {
            html = $siteURL("documentlibrary?path=" + encodeURIComponent(recordPath + (recordPath != "/" ? "/" : "") + fileName),
              {
                site: record.location.site.name
              });
          }
          else
          {
            html = window.location.protocol + "//" + window.location.host + Alfresco.constants.URL_PAGECONTEXT + "repository?path=" + encodeURIComponent(recordRepoPath + (recordRepoPath != "/" ? "/" : "") + fileName);
          }
        }
        else
        {
          if (Alfresco.util.isValueSet(scope.options.siteId) && record.location.site && record.location.site.name !== scope.options.siteId)
          {
            html = scope.getActionUrls(record, record.location.site.name).documentDetailsUrl;
          }
          else
          {
            html = scope.getActionUrls(record).documentDetailsUrl;
          }
        }
      }
      else
      {
        if (jsNode.isContainer)
        {
          // fix for MNT-15347 - browsing non primary folders from another site
          if (currentSite !== "" && recordSite !== null && currentSite !== recordSite)
          {
            recordPath = scope.currentPath;
          }
          if (record.parent.isContainer || record.node.isContainer)
          {
            // handle folder parent node
            var location = {};
            location.path = recordPath;
            location.file = record.location.file;
            html = '#" class="filter-change" rel="' + Alfresco.DocumentList.generatePathMarkup(location);
          }
          else if (recordPath === "/")
          {
            // handle Repository root parent node (special store_root type - not a folder)
            html = '#" class="filter-change" rel="' + Alfresco.DocumentList.generateFilterMarkup(
              {
                filterId: "path",
                filterData: $combine(recordPath, "")
              });
          }
          else
          {
            // handle unknown parent node types
            html = '#';
          }
        }
        else
        {
          var actionUrls = scope.getActionUrls(record);
          html = actionUrls.documentDetailsUrl;
        }
      }

      // Lyse changes below
      if(Alfresco.constants.SITE){
        html = html.replace("/page","/page/site/" + Alfresco.constants.SITE);
      }
      // End lyse changes

      return '<a href="' + html + '">';
    };

	var showButtons = function()
	{
    var fileUpload = Dom.getElementsByClassName("file-upload")[0];
    if(fileUpload)
    {
      fileUpload.style.display = "block";
    }
    var createContent = Dom.getElementsByClassName("create-content")[0];
    if(createContent)
    {
      createContent.style.display = "block";
    }
	};
	var hideButtons = function()
	{
    var fileUpload = Dom.getElementsByClassName("file-upload")[0];
    if(fileUpload)
    {
      fileUpload.style.display = "none";
    }
    var createContent = Dom.getElementsByClassName("create-content")[0];
    if(createContent)
    {
      createContent.style.display = "none";
    }
	};

  var ready = Alfresco.DocumentList.prototype.onReady;
  Alfresco.DocumentList.prototype.onReady = function()
	{
		ready.bind(this)();

		hideButtons();
    YAHOO.Bubbling.on("doclistMetadata",(function()
    {
      var nodeRef = this.doclistMetadata.container;
      if(!nodeRef)
			{
				return showButtons();
			}
      Alfresco.util.Ajax.jsonGet({
        url: Alfresco.constants.PROXY_URI + "/api/metadata?nodeRef=" + nodeRef,
        responseContentType : "application/json",
        successCallback: {
          fn: function (response) {
            if(!response.json.properties["{http://www.alfresco.org/model/content/1.0}lockType"])
            {
							showButtons();
            }
            else
						{
              var css = document.createElement("style");
              css.type = "text/css";
              css.innerHTML = ".docListInstructionsWithDND { display:none }";
              document.body.appendChild(css);
						}
          },
          scope: this
        },
				failureCallback :{
        	fn:function()
					{
            showButtons();
					},
					scope:this

				}
      });
    }).bind(this));

	}

}(Alfresco.DocumentList.generateFileFolderLinkMarkup));
