//@overridden projects/slingshot/source/web/components/folder-details/folder-actions.js
(function (__onActionDeleteConfirm, onNewVersionUploadCompleteCustom) {

  /**
   * This is a copy of the original one with one modification: instead of redirecting to the document library of the
   * repository, it now closes the window OR redirects to the user home.
   */
  Alfresco.FolderActions.prototype._onActionDeleteConfirm = function Lyse_FolderActions_onActionDeleteConfirm(asset) {
    var path = asset.location.path;
    // Update the path for My Files and Shared Files...
    if (Alfresco.constants.PAGECONTEXT === "mine" || Alfresco.constants.PAGECONTEXT === "shared") {
      // Get rid of the first "/"
      var tmpPath = path.substring(1);
      if (Alfresco.constants.PAGECONTEXT === "mine") {
        tmpPath = tmpPath.substring(tmpPath.indexOf("/") + 1);
      }
      var slashIndex = tmpPath.indexOf("/");
      if (slashIndex !== -1) {
        path = tmpPath.substring(slashIndex);
      }
      else {
        path = "";
      }
    }

    var fileName = asset.fileName,
    displayName = asset.displayName,
    nodeRef = new Alfresco.util.NodeRef(asset.nodeRef),
    encodedPath = path.length > 1 ? "?path=" + encodeURIComponent(path) : "";

    var doDelete = function(callbackUrl) {
      this.modules.actions.genericAction(
          {
            success: {
              activity: {
                siteId: this.options.siteId,
                activityType: "file-deleted",
                page: "documentlibrary",
                activityData: {
                  fileName: fileName,
                  path: path,
                  nodeRef: nodeRef.toString()
                }
              },
              callback: {
                fn: function FolderActions_oADC_success(data) {
                  if (window.opener || window.history.length === 1) {
                    Lyse.util.closeWindow();
                  }
                  else if(window.history.length>1) 
                  {
                    window.history.back();
                  }
                  else if (callbackUrl != null) {
                    window.location = callbackUrl;
                  }
                  else {
                    Lyse.util.navigateForward();
                  }
                }
              }
            },
            failure: {
              message: this.msg("message.delete.failure", displayName)
            },
            webscript: {
              method: Alfresco.util.Ajax.DELETE,
              name: "file/node/{nodeRef}",
              params: {
                nodeRef: nodeRef.uri
              }
            }
          });

    };

    Alfresco.util.Ajax.jsonGet({
      url : Alfresco.constants.PROXY_URI + "/api/lyse/source-associated-datalistitem?nodeRef=" + asset.nodeRef,
      successCallback : {
        fn : function(response) {
          var dlUrl = response.json.data.datalistUrl;
          doDelete.call(this, dlUrl);
        },
        scope : this
      },
      failureCallback:
      {
        fn: function(response)
        {
          doDelete.call(this, null);
        },
        scope: this
      }

    });
  };
}(Alfresco.FolderActions.prototype._onActionDeleteConfirm, Alfresco.FolderActions.prototype.onNewVersionUploadCompleteCustom));
