  
    // Ensure RPLP namespace exists
    if (typeof RPLP === "undefined" || !RPLP) 
    {
        var RPLP = {};
    }
    
    (function() 
    {
      RPLP.FilterCategorySelectMany = function FilterCategorySelectMany_constructor(htmlId) 
      {
        RPLP.FilterCategorySelectMany.superclass.constructor.call(this, htmlId);
              
        this.name = "RPLP.FilterCategorySelectMany";
        this.id = htmlId;
      
        Alfresco.util.ComponentManager.register(this);
        Alfresco.util.YUILoaderHelper.require(["button", "container"], this.onComponentsLoaded, this);
      
          return this;
      };
    
      YAHOO.extend(RPLP.FilterCategorySelectMany, Alfresco.component.Base, 
      {
        options:
        {
        	fetchFromParent: "false",
        	mergeValuesFromType: "none",
        	sort: false,
        },
        setOptions: function FilterCategorySelectMany_setOptions(obj) 
        {
            this.options = YAHOO.lang.merge(this.options, obj);
            return this;
        },
        setMessages: function FilterCategorySelectMany_setMessages(obj) 
        {
          Alfresco.util.addMessages(obj, this.name);
          return this;
        },
        onReady: function FilterCategorySelectMany_onReady()
        {
          var selectedValue = this.options.selectedValue; 
          var setOptionsCallback = 
          {
            success: function(o) 
            {
              var values, i;
              var listbox = YAHOO.util.Dom.get(this.id + "-entry");
            
              try 
              {
                values = YAHOO.lang.JSON.parse(o.responseText);
                listbox.remove(listbox.length - 1); // Remove "Loading..." text
              } 
              catch (x) 
              {
                console.log("Json parse failed! " + x);
                return;
              }
              
              for(i = 0; i < values.length; i++) 
              {
                var v = values[i];
                var option = new Option('option');
                
                option.value = (v.value === null || v.value === "") ? v.label : v.value;
                option.text = v.label;
                option.selected = (option.value === selectedValue);
                listbox.add(option);
              }
            },
              failure: function(o) 
              {
                Alfresco.util.PopupManager.displayMessage({text: "Could not load values!"});
              },
              scope: this
          };
          
          
          
          var url = Alfresco.constants.PROXY_URI + "api/lyse/forms/subcategories-new/" + this.options.mergeValuesFromType + "/"+ Alfresco.constants.SITE +"/" + this.options.categoryParentName + "?sort=" + this.options.sort +"&fetchFromParent=" + this.options.fetchFromParent;
          
          var transaction = YAHOO.util.Connect.asyncRequest('GET', url, setOptionsCallback, null);
        },
        _delselectValues: function FilterCategorySelectMany__delselectValues(event)
        {
        	//Dom.get(this.id).value = "";
           	var lists = YAHOO.util.Selector.query('select');
            for(i = 0; i < lists.length; i++){
                if(lists[i].id.endsWith('-entry')){
                    Dom.get(lists[i].id.replace('-entry','')).value = "";
                }
            }
        }
      });
    })();
