
    // Ensure RPLP namespace exists
    if (typeof RPLP === "undefined" || !RPLP)
    {
        var RPLP = {};
    }

    (function()
    {
      RPLP.PropertyBasedCategorySelectOne = function PropertyBasedCategorySelectOne_constructor(htmlId)
      {
        RPLP.PropertyBasedCategorySelectOne.superclass.constructor.call(this, htmlId);

        this.name = "RPLP.PropertyBasedCategorySelectOne";
        this.id = htmlId;

        Alfresco.util.ComponentManager.register(this);
        Alfresco.util.YUILoaderHelper.require(["button", "container"], this.onComponentsLoaded, this);

          return this;
      };

      YAHOO.extend(RPLP.PropertyBasedCategorySelectOne, Alfresco.component.Base,
      {
        options:
        {
        	fetchFromParentType: "none",
        	sort: false,
            defaultType: "",
            disabledOptions: null
        },
        setOptions: function PropertyBasedCategorySelectOne_setOptions(obj)
        {
            this.options = YAHOO.lang.merge(this.options, obj);
            return this;
        },
        setMessages: function PropertyBasedCategorySelectOne_setMessages(obj)
        {
          Alfresco.util.addMessages(obj, this.name);
          return this;
        },
        onReady: function PropertyBasedCategorySelectOne_onReady()
        {
          var selectedValue = this.options.selectedValue;
          var setOptionsCallback =
          {
            success: function(o)
            {
              var values, i;
              var listbox = YAHOO.util.Dom.get(this.id);

              try
              {
                values = YAHOO.lang.JSON.parse(o.responseText);
                listbox.remove(listbox.length - 1); // Remove "Loading..." text
              }
              catch (x)
              {
                console.log("Json parse failed! " + x);
                return;
              }
              if (this.options.addEmptyOption){
            	  var emptyOption = new Option('option');
            	  emptyOption.value = "";
            	  emptyOption.text = "";
            	  listbox.add(emptyOption);
              }
              for(i = 0; i < values.length; i++)
              {
                var v = values[i];
                var option = new Option('option');

                option.value = (v.value === null || v.value === "") ? v.label : v.value;
                option.text = v.label;
                option.selected = (option.value === selectedValue || selectedValue.split(",").indexOf(option.value) >= 0);
                option.disabled = (this.options.allowedOptions != null && this.options.allowedOptions.indexOf(option.value) < 0);
                listbox.add(option);
              }
              YAHOO.Bubbling.fire("categorySelectLoaded", {
                htmlId: this.id
              })

            },
              failure: function(o)
              {
                Alfresco.util.PopupManager.displayMessage({text: "Could not load values!"});
              },
              scope: this
          };



          var url = Alfresco.constants.PROXY_URI + "api/lyse/forms/subcategories/" + this.options.fetchFromParentType + "/" + this.options.siteShortName +"/" + this.options.categoryParentName +"?sort=" + this.options.sort + "&nodeRef="+this.options.nodeRef+"&defaultType="+this.options.defaultType+"&parentNodeRef="+this.options.parentNodeRef+"&propertyName="+this.options.propertyName+"&listboxSuffixName="+this.options.listboxSuffixName;

          var transaction = YAHOO.util.Connect.asyncRequest('GET', url, setOptionsCallback, null);
        }
      });
    })();
