  
    // Ensure RPLP namespace exists
    if (typeof RPLP === "undefined" || !RPLP) 
    {
        var RPLP = {};
    }
    
    (function() 
    {
      RPLP.ContractorSelectOne = function ContractorSelectOne_constructor(htmlId) 
      {
        RPLP.ContractorSelectOne.superclass.constructor.call(this, htmlId);
              
        this.name = "RPLP.ContractorSelectOne";
        this.id = htmlId;
      
        Alfresco.util.ComponentManager.register(this);
        Alfresco.util.YUILoaderHelper.require(["button", "container"], this.onComponentsLoaded, this);
      
          return this;
      };
    
      YAHOO.extend(RPLP.ContractorSelectOne, Alfresco.component.Base, 
      {
        options:
        {
        	siteShortName: null,
        	sort: false,
            defaultType: "",
        },
        setOptions: function ContractorSelectOne_setOptions(obj) 
        {
            this.options = YAHOO.lang.merge(this.options, obj);
            return this;
        },
        setMessages: function ContractorSelectOne_setMessages(obj) 
        {
          Alfresco.util.addMessages(obj, this.name);
          return this;
        },
        onReady: function ContractorSelectOne_onReady()
        {
          var selectedValue = this.options.selectedValue; 
          var setOptionsCallback = 
          {
            success: function(o) 
            {
              var values, i;
              var listbox = YAHOO.util.Dom.get(this.id);
            
              try 
              {
                values = YAHOO.lang.JSON.parse(o.responseText);
                listbox.remove(listbox.length - 1); // Remove "Loading..." text
              } 
              catch (x) 
              {
                console.log("Json parse failed! " + x);
                return;
              }
              if (this.options.addEmptyOption){
            	  var emptyOption = new Option('option');
            	  emptyOption.value = "";
            	  emptyOption.text = ""
            	  listbox.add(emptyOption);
              }
              for(i = 0; i < values.length; i++) 
              {
                var v = values[i];
                var option = new Option('option');
                option.value = (v.value === null || v.value === "") ? v.label : v.value;
                option.text = v.label;
                option.selected = (option.value === selectedValue || selectedValue.split(",").indexOf(option.value) >= 0);
                listbox.add(option);
              }
              
              
            },
              failure: function(o) 
              {
                Alfresco.util.PopupManager.displayMessage({text: "Could not load values!"});
              },
              scope: this
          };
          

          var url = Alfresco.constants.PROXY_URI + "api/lyse/forms/contractors/" + this.options.siteShortName;
          YAHOO.util.Connect.asyncRequest('GET', url, setOptionsCallback, null);
        }
      });
    })();