    if (typeof RPLP == "undefined" || !RPLP) {
      var RPLP = {};
    }
        
    (function() 
    {
      RPLP.SelectTemplate = function SelectTemplate_constructor(htmlId) 
      {
        RPLP.SelectTemplate.superclass.constructor.call(this, htmlId);
        
        this.name = "RPLP.SelectTemplate";
        this.id = htmlId;
      
        Alfresco.util.ComponentManager.register(this);
        Alfresco.util.YUILoaderHelper.require(["button", "container"], this.onComponentsLoaded, this);
        return this;
      };
    
      YAHOO.extend(RPLP.SelectTemplate, Alfresco.component.Base, 
      {
        options:
        {
        },
        setOptions: function SelectTemplate_setOptions(obj) 
        {
            this.options = YAHOO.lang.merge(this.options, obj);
            return this;
        },
        setMessages: function SelectTemplate_setMessages(obj) 
        {
          Alfresco.util.addMessages(obj, this.name);
          return this;
        },
        onChange: function SelectTemplate_onChange(obj) 
        {
            
          Alfresco.util.Ajax.jsonGet(
	      {
	    	 url: Alfresco.constants.PROXY_URI + 'datalist-template/' + this.options.datalistType + "/" + obj.value,
	         successCallback:
	         {
	            fn: function (response)
	            {
	               if (response.json !== undefined)
	               {
	            	   var defaultFilenameField = YAHOO.util.Dom.get(this.id+'-defaultfilename');
	            	   defaultFilenameField.value = response.json.defaultFilename;
	               }
	            },
	            scope: this
	         },
	         failureMessage: this.msg("message.defaultFileName.failed")
	      });

        },

        onReady: function SelectTemplate_onReady()
        {
          var setOptionsCallback = 
          {
            success: function(o) 
            {
              var values, i;
              var listbox = YAHOO.util.Dom.get(this.id);
              var defaultFilenameField = YAHOO.util.Dom.get(this.id+'-defaultfilename');
            
              try 
              {
                values = YAHOO.lang.JSON.parse(o.responseText);
                
                listbox.remove(listbox.length - 1); // Remove "Loading..." text
              } 
              catch (x) 
              {
                console.log("Json parse failed! " + x);
                return;
              }
              
              for(i = 0; i < values.length; i++) 
              {
                var v = values[i];
                var option = new Option('option');
                
                option.value = this.options.datalistType + "/" + v.ftlPath;
                
                option.text = v.name;
                if (v.defaultTemplate == "true"){
                	option.selected = this.options.datalistType + "/" + v.ftlPath;
                	defaultFilenameField.value = v.defaultFilename;      
                }
                          
                
                listbox.add(option);
              }
              
              // If theres only one option and the default checkbox has not been marked
              // set the default filename anyway.
              if (values.length === 1){
              	defaultFilenameField.value = values[0].defaultFilename;
              }

            },
              failure: function(o) 
              {
                Alfresco.util.PopupManager.displayMessage({text: "Could not load values!"});
              },
              scope: this
          };
          var listUrl = Alfresco.constants.PROXY_URI + "ftl-templates/" + this.options.datalistType;
          var transaction = YAHOO.util.Connect.asyncRequest('GET', listUrl, setOptionsCallback, null);
        }
      });
    })();