if (!Lyse) {
  var Lyse = {};
}
if (!Lyse.component) {
  Lyse.component = {};
}
/**
 * Upload attachment module
 *
 * Upload of attachments
 *
 * @namespace Lyse.component
 * @class Lyse.component.UploadNewRevision
 */
(function()
{

  var Dom = YAHOO.util.Dom,
    Event = YAHOO.util.Event,
    Element = YAHOO.util.Element,
    KeyListener = YAHOO.util.KeyListener;
  
  /**
    * Alfresco Slingshot aliases
    */
   var $html = Alfresco.util.encodeHTML;

  /**
  * UploadNewRevision constructor.
  *
  * @param htmlId {string} A unique id for this component
  * @return {Lyse.component.UploadNewRevision} 
  * @constructor
  */
  Lyse.component.UploadNewRevision = function(htmlId)
  {
    Lyse.component.UploadNewRevision.superclass.constructor.call(this, "Lyse.component.UploadNewRevision", htmlId, ["button", "container"]);

    this.config =
    {
      htmlId: htmlId
    };

    this.widgets = {};

    return this;
  };

  YAHOO.extend(Lyse.component.UploadNewRevision, Alfresco.component.Base,
  {
	  /**
	   * Object container for initialization options
	   *
	   * @property options
	   * @type object
	   */
	  options:
	  {
	     
	     /**
	      * Node reference of the item to comment about
	      */
	     updateNodeRef: null,

	     /**
	      * Id of the site the document resides in.
	      */
	     siteId: null
	  },
	  
    onReady: function() {
     
      this.widgets.addButton = Alfresco.util.createYUIButton(this, "addBtn", this.uploadNewVersion);
      
      Alfresco.util.Ajax.jsonGet(
      {
        url: Alfresco.constants.PROXY_URI + "/api/lyse/" + Alfresco.util.NodeRef(this.options.updateNodeRef).uri + "/site-shortname",
        responseContentType : "application/json",
        successCallback:
        {
        	fn: function (response)
    		{
        		this.options.siteId = response.json.shortName;
    		},
    		scope: this
        }
        
      });
    },


    uploadNewVersion: function LyseUploadNewVersion() {
        if (!this.fileUpload)
        {
           this.fileUpload = Alfresco.getFileUploadInstance();
        }
        var singleUpdateConfig =
        {
           updateNodeRef: this.options.updateNodeRef,
           suppressRefreshEvent: true,
           overwrite: true,
           mode: this.fileUpload.MODE_SINGLE_UPDATE,
           onFileUploadComplete:
           {
              fn: this.onFileUploadComplete,
              scope: this
           }

        };
        if (Alfresco.util.isValueSet(this.options.siteId))
        {
           singleUpdateConfig.siteId = this.options.siteId;
           singleUpdateConfig.containerId = "documentLibrary";
        }
        this.fileUpload.show(singleUpdateConfig);

        // Hide the version information div
        var versionSectionID = this.fileUpload.uploader.id;
        Dom.addClass(Dom.get(versionSectionID + "-versionSection-div"), "hidden");

    },
    
    /**
     * File Upload complete event handler
     *
     * @method onFileUploadComplete
     * @param complete {object} Object literal containing details of successful and failed uploads
     */
    onFileUploadComplete: function DLTB_onFileUploadComplete(complete)
    {
       var success = complete.successful.length, file;
       if (success > 0)
       {
         for (var i = 0; i < success; i++)
         {
            file = complete.successful[i];
            file.name = file.fileName;
         }
         var addedFile = document.createElement("div");
         addedFile.innerHTML = file.name;
         Dom.addClass(addedFile, "lyseFile");
         
         var filelistDiv = Dom.get(this.id + "-filelist");
         filelistDiv.appendChild(addedFile);
         // Disable the upload new revision button
         this.widgets.addButton._configs.disabled = true;
         
       }
    },
    
    onUploadFailure : {
      fn : function uploadNewVersion_failure(response) {
        // just show a dialog with an error message
        Alfresco.util.PopupManager.displayMessage({
          text : Alfresco.util.message("Lyse.control.attachment.upload.failureMsg")
        });
      },
      scope : this
    },
  });
})();

Lyse.component.getUploadNewRevisionInstance = function()
{
  var instanceId = "lyse-upload-new-revision-instance";
  return Alfresco.util.ComponentManager.get(instanceId);
};