//@overridden projects/slingshot/source/web/components/form/workflow/activiti-transitions.js
(function (_onReady, _onClick, __processTransitions) {
  Alfresco.ActivitiTransitions.prototype.onReady = function lyse_onReady() {
    _onReady.call(this);
    if (this.options.propertyName != null){
      this.options.propertyId = this.options.htmlId + "_" + this.options.propertyName;
    }
  };

  Alfresco.ActivitiTransitions.prototype.onClick = function lyse_onClick(e, p_obj) {
    //MNT-2196 fix, disable transition button to prevent multiple execution
    p_obj.set("disabled", true);
    // determine what button was pressed by it's id
    var buttonId = p_obj.get("id");
    var transitionId = buttonId.substring(this.id.length+1);

    // get the hidden field
    var hiddenField = this._getHiddenField();

    // set the hidden field value
    Dom.setAttribute(hiddenField, "value", transitionId);

    if (Alfresco.logger.isDebugEnabled())
      Alfresco.logger.debug("Set transitions hidden field to: " + transitionId);

    // generate the hidden transitions field
    this._generateTransitionsHiddenField();

    // ===========================  LYSE CHANGES BELOW  ================================================================
    YAHOO.Bubbling.fire("beforeSubmitWorkflowForm", {
      fieldName: this.options.hiddenFieldName,
      transitionId: transitionId
    });

    // ATTACHMENT VALIDATION FOR MCC PACKAGES/COMMISSIONING
    var workflowTasks = ["prop_lysewf_mccPackagesReportMechanicalCompletionUserTaskOutcome", "prop_lysewf_mccPackagesApproveMechanicalCompletionUserTaskOutcome",
                         "prop_lysewf_mccPackagesApproveTakeOverUserTaskOutcome", "prop_lysewf_mccPackagesReportReadyForCompletionUserTaskOutcome",
                         "prop_lysewf_mccPackagesApproveCompletionUserTaskOutcome", "prop_lysewf_mccCommissioningPackagesReportReadyForCommissioningUserTaskOutcome",
                         "prop_lysewf_mccCommissioningPackagesApproveTrialRunUserTaskOutcome"
                         ];
    if (workflowTasks.indexOf(this.options.hiddenFieldName) >= 0){
      // Get html input elements
      var comments = document.getElementsByName('assoc_lysewf_relatedDatalistItem')[0];

      if(comments && tinyMCE.activeEditor.getContent() === ""){
        Alfresco.util.PopupManager.displayPrompt(
            {
              title: Alfresco.util.message("label.validation.failed"),
              text:  "Add a comment to validate task"
            });
        comments.focus();
        p_obj.set("disabled", false);
        return false;
      }
    } else if ((this.options.hiddenFieldName === "prop_lysewf_mccForClosingUserTaskOutcome" || this.options.hiddenFieldName === "prop_lysewf_actionWithProjectForClosingUserTaskOutcome" || this.options.hiddenFieldName === "prop_lysewf_siteQueryForClosingUserTaskOutcome") && transitionId === "close"){
      // CONCLUSION VALIDATION FOR MCC ACTION & Action with project
      // Get html input elements
      var conclusion;
      if(this.options.hiddenFieldName === "prop_lysewf_mccForClosingUserTaskOutcome"){
        conclusion = document.getElementsByName('prop_lyse_mccActionConclusion')[0];
      } else if(this.options.hiddenFieldName === "prop_lysewf_actionWithProjectForClosingUserTaskOutcome") {
        conclusion = document.getElementsByName('prop_lyse_actionWithProjectConclusion')[0];
      } else if(this.options.hiddenFieldName === "prop_lysewf_siteQueryForClosingUserTaskOutcome") {
        conclusion = document.getElementsByName('prop_lyse_siteQueryConclusion')[0];
      }

      if(conclusion && conclusion.value === "") {
        Alfresco.util.PopupManager.displayPrompt(
            {
              title: Alfresco.util.message("label.mandatory.field"),
              text:  Alfresco.util.message("label.mcc.action.conclusion.invalid")
            });
        conclusion.focus();
        p_obj.set("disabled", false);
        return false;
      }
    } else if ((this.options.hiddenFieldName == "prop_lysewf_mccSafeWorkPermitReviewRequestUserTaskOutcome" && transitionId == "swpReviewRequestOutcome.reject")
          ||(this.options.hiddenFieldName == "prop_lysewf_civilMeasuredQuantityForApprovalUserTaskOutcome" && transitionId == "returned")) {
        // When rejecting, a comment is mandatory (#42459)
        var comments = document.getElementsByName('assoc_lysewf_relatedDatalistItem')[0];
        if(comments) {
            // Use the component manager to find the correct editor (there could be multiple rich text editors)
            var editor = Alfresco.util.ComponentManager.get(comments.id + "-addCommentText");
            if (editor && editor.editor.getContent() === "") {
                Alfresco.util.PopupManager.displayPrompt(
                    {
                        title: Alfresco.util.message("label.validation.failed"),
                        text: "Please enter a comment to complete the task!"
                    });
                comments.focus();
                p_obj.set("disabled", false);
                return false;
            }
        }

      // When clicking "Reject" disable these mandatory fields so they won't be validated
      var toDisable = [ "prop_lyse_swpPermitStartTime", "prop_lyse_swpPermitEndTime", "prop_lyse_swpRiskLevel", "prop_lyse_swpConditions" ];
      for (i = 0; i < toDisable.length; i++) {
        var input = document.getElementsByName(toDisable[i]);
        if (input.length > 0) {
          for (j= 0; j < input.length; j++) {
            input[j].disabled = true;
          }
        }
      }
    } else if (this.options.hiddenFieldName == "prop_lysewf_mccSafeWorkPermitConsiderNewRequestUserTaskOutcome" && transitionId == "swpConsiderNewRequestOutcome.complete") {
        // When clicking "Complete" disable these mandatory fields so they won't be validated
        var toDisable = [ "prop_lyse_swpRequestedStartTime", "prop_lyse_swpRequestedEndTime" ];
        for (i = 0; i < toDisable.length; i++) {
            var input = document.getElementsByName(toDisable[i]);
            if (input.length > 0) {
                for (j= 0; j < input.length; j++) {
                    input[j].disabled = true;
                }
            }
        }
    } else if (this.options.hiddenFieldName == "prop_lysewf_civilVoReportQuantitiesOrderTaskOutcome") {
      var modifiedOn = document.getElementById('civilVorContrasignedDocumentModifiedOn');
      var comments = document.getElementsByName('assoc_lysewf_relatedDatalistItem')[0];
      // check if VO/DVO response has been uploaded with a new version or a comment is added
      // the uploaded should not be older then 5 minutes
      if((Date.now() - new Date(modifiedOn.value) > 300000) && (comments && tinyMCE.activeEditor.getContent() === "")) {
        Alfresco.util.PopupManager.displayPrompt(
        {
          title: Alfresco.util.message("label.validation.failed"),
          text:  "Add a comment or attach a new version of VO/DVO response to validate task"
        });
        comments.focus();
        p_obj.set("disabled", false);
        return false;
      }
    }

    // Lyse conditional validation added below.
    if (this.options.propertyName != null && this.options.transitionValue != null && this.options.transitionValue == transitionId) {
      var propertyField = Dom.get(this.options.propertyId);
      if (propertyField.value == null || propertyField.value.length ==0){
        Alfresco.util.PopupManager.displayPrompt(
            {
              title: Alfresco.util.message("label.validation.failed"),
              text:  Alfresco.util.message(this.options.messageKey)
            });
        propertyField.focus();
        p_obj.set("disabled", false);
        return false;
      }
    }


    // ============================================================================================================================

    // attempt to submit the form
    Alfresco.util.submitForm(p_obj.getForm());

    // MNT-11361 fix, enable transition button
    p_obj.set("disabled", false);

  };

  Alfresco.ActivitiTransitions.prototype._processTransitions = function lyse__processTransitions(e, p_obj) {
    // process the current value and create the list of transitions
    this.options.transitions = [];

    if (Alfresco.logger.isDebugEnabled())
      Alfresco.logger.debug("Processing transitions for field '" + this.id + "': " + this.options.currentValue);

    // process the transitions
    if (this.options.currentValue !== null && this.options.currentValue.length > 0)
    {
      var transitionPairs = this.options.currentValue.split("#alf#");
      for (var i = 0, ii = transitionPairs.length; i < ii; i++)
      {
        // retrieve the transition info and split
        var transitionInfo = transitionPairs[i].split("|");

        if (this.options.hideId == transitionInfo[0]) continue; // Lyse change choosen to hide
        // add the transition as an object
        this.options.transitions.push(
            {
              id: transitionInfo[0],
              label: transitionInfo[1]
            });
      }
    }

    if (Alfresco.logger.isDebugEnabled())
      Alfresco.logger.debug("Built transitions list: " + YAHOO.lang.dump(this.options.transitions));

  }
}(Alfresco.ActivitiTransitions.prototype.onReady, Alfresco.ActivitiTransitions.prototype.onClick, Alfresco.ActivitiTransitions.prototype._processTransitions))
;