// @overridden projects/slingshot/source/web/components/form/workflow/transitions.js

/**
 * Overridden methods in the Alfresco Transitions form component.
 * 
 * Customized with a validation of that a new version is uploaded of a file
 * only used in conjunction with the attachmentsMod-component.
 * We inject options for validationField-name and messageKey in the creation of
 * this component in the lyse-transitions.ftl
 * 
 * @namespace Alfresco
 * @class Alfresco.Transitions
 */
(function (_onReady, _onClick) {
  
  Alfresco.Transitions.prototype.onReady = function lyse_onReady() {
	    _onReady.call(this);
	    if (this.options.newVersionFieldName != null){
	      this.options.newVersionFieldName = this.options.htmlId + "_" + this.options.newVersionFieldName;
	    }
  };
  
  Alfresco.Transitions.prototype.onClick = function lyse_onClick(e, p_obj) {
      // Do we have any validations for new versions to be uploaded?
      var attachmentFieldToValidate = Dom.get(this.options.newVersionFieldName + '-cntrl-newVersionUploaded');
      
      if (attachmentFieldToValidate != null){
        if (attachmentFieldToValidate.value == "false"){
          Alfresco.util.PopupManager.displayPrompt(
           {
             title: Alfresco.util.message("label.validation.failed"),
             text:  Alfresco.util.message(this.options.messageKey)
           });
           return false;
        }
      }
        
      //MNT-2196 fix, disable transition button to prevent multiple execution
      p_obj.set("disabled", true);
      // determine what button was pressed by it's id
      var buttonId = p_obj.get("id");
      var transitionId = buttonId.substring(this.id.length+1);
      
      // get the hidden field
      var hiddenField = this._getHiddenField();

      // set the hidden field value
      Dom.setAttribute(hiddenField, "value", transitionId);
      
      if (Alfresco.logger.isDebugEnabled())
         Alfresco.logger.debug("Set transitions hidden field to: " + transitionId);
      
      // attempt to submit the form
      Alfresco.util.submitForm(p_obj.getForm());

  };


}(Alfresco.ActivitiTransitions.prototype.onReady, Alfresco.Transitions.prototype.onClick))
