//@overridden projects/slingshot/source/web/components/search/search-lib.js

/**
 * Base component for various Search related components.
 * 
 * Provides helper functions to generate search related URLs, text and image thumbnails
 * 
 * @namespace Alfresco.component
 * @class Alfresco.component.SearchBase
 */
(function(_buildPath)
{

    /**
     * Alfresco Slingshot aliases
     */
    var $html = Alfresco.util.encodeHTML,
        $msg = Alfresco.util.message;

    Alfresco.component.SearchBase.prototype.buildPath = function Lyse_Search_buildPath(type, path, site)
    {
         var result = '';
         if (type === "document" || type === "folder")
         {
            if (site)
            {
               if (!path)
               {
                  path = "";
               }
               result += '<div class="details">' + $msg("message.infolderpath") + ': ' +
                  $html('/' + path) + '</div>';
            }
            else
            {
               if (path)
               {
                  result += '<div class="details">' + $msg("message.infolderpath") + ': ' +
                       $html(path) + '</div>';
               }
            }
         }
         return result;
      }

}(Alfresco.component.SearchBase.prototype.buildPath));
