// @overridden projects/slingshot/source/web/components/site-members/site-groups.js
window.RPLP = window.RPLP || {};
/**
 * site-groups extend
 * to add members to groups
 */
(function(doAddMember){
  Alfresco.SiteGroups.prototype.doAddMember = function Lyse_SiteGroups_doAddMember(event, group)
  {
     var searchURI = Alfresco.constants.PROXY_URI + "api/sites/" + Alfresco.constants.SITE;
     var siteNodeRef;
     // Need the site short name passed to the form
     window.RPLP.global_alf_group = group.fullName;
     window.RPLP.global_alf_group_displayName = group.displayName;
     var members = [];
     
     for(var member in group.members){
    	 if(group.members[member].nodeRef){
    		 members.push(group.members[member].nodeRef);
    	 }
     }
     
	 window.RPLP.global_alf_members = members.join(',');

     var openFormDialog = function(response)
     {
        if (response.json !== undefined)
        {
	       siteNodeRef = response.json.node.replace("/alfresco/s/api/node/","").replace("/","://");
	   	   var templateUrl = YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&itemId={itemId}&destination={destination}&mode={mode}&submitType={submitType}&showCancelButton=true",
	   	   {
	   	      itemKind: "action",
	   	      itemId: "lyse.action.form-popup",
	   	      mode: "create",
	   	      destination: siteNodeRef,
	   	      submitType: "json"
	       });
		   var doBeforeDialogShow = function(p_form, p_dialog)
	       {
	          Alfresco.util.populateHTML(
	             [ p_form.formId + "-container_h", "Edit members" ],
	             [ p_form.formId + "-submit-button", "Save" ]
	          );
	       };
	   	   var dialog = new Alfresco.module.SimpleDialog(this.id + "-formPopup");
	   	   dialog.setOptions(
		   {
	         templateUrl: templateUrl,
	         actionUrl: null,
	         destroyOnHide: true,
             doBeforeDialogShow:
             {
                fn: doBeforeDialogShow,
                scope: this
             },
	         width: "400px",
	         onSuccess:
	         {
	           fn: function(response) {
	        	   this.doSearch();
	           },
	           scope: this
	         }
	       }).show();
   	    }
     };
    
    if(Alfresco.constants.SITE)
    {
      Alfresco.util.Ajax.jsonGet(
      {
        url: searchURI,
        successCallback:
        {
          fn: openFormDialog,
          scope: this
        }
      });
	}
  }
}(Alfresco.SiteGroups.prototype.doAddMember));

/**
* __setupDataTable override
* Change from original: removed columns.
*/
(function(__setupDataTable){
  Alfresco.SiteGroups.prototype._setupDataTable = function Lyse_SiteGroups_setupDataTable()
  {
	  var $html = Alfresco.util.encodeHTML;
      var me = this;
       
      var renderCellIcon = function SiteGroups_renderCellIcon(elCell, oRecord, oColumn, oData)
      {
         Dom.setStyle(elCell.parentNode, "width", oColumn.width + "px");
         elCell.innerHTML = '<img src="' + Alfresco.constants.URL_RESCONTEXT + "components/images/group-64.png" + '" alt="group" />';
      };

      var renderCellDescription = function SiteGroups_renderCellDescription(elCell, oRecord, oColumn, oData)
      {
         // Currently rendering all results the same way
         var displayName = oRecord.getData("displayName"),
         members = [];
         members_id = [];
         var datastuff = oRecord.getData("members");
         for(var k in datastuff) {
        	 if(datastuff.length > 0 && datastuff[k].displayName){
        		 members.push(datastuff[k].displayName);
        	 }
         }
         
         if(members.length < 1){
        	members = 'None'; 
         }
         else {
         	members = members.join(', ');
         }
         var desc = '<h3>' + $html(displayName) + '</h3>';
         
         var subGroups = oRecord.getData("subGroups");
         if(subGroups.length > 0) {
           subGroups.forEach(function(subGroup) { 
             var subGroupTitle = subGroup.displayName;
             var members = [];
             subGroup.members.forEach(function(member) {
               members.push(member.displayName);
             });
             if(members.length < 1){
               members = 'None'; 
              }
              else {
               members = members.join(', ');
              }
             desc += '<div><span class="attr-name"><b>' + subGroupTitle +'</b>: '+ members +  '</span>&nbsp;<span class="attr-value"></span></div>';
           });
           
         }
           
         desc += '<div><span class="attr-name">Members: </span>&nbsp;<span class="attr-value">' + $html(members) + '</span></div>';
         
         elCell.innerHTML = desc;
      };
      
      var renderCellAddMember = function SiteGroups_renderCellAddMember(elCell, oRecord, oColumn, oData)
      {
          Dom.setStyle(elCell.parentNode, "width", oColumn.width + "px");
          var isContainerGroup = oRecord.getData("isContainerGroup");

          if (me.isCurrentUserSiteAdmin && !isContainerGroup)
          {
             // create HTML for representing buttons
             var groupName = oRecord.getData("fullName");
             elCell.innerHTML = '<span id="' + me.id + '-button-' + groupName + '"></span>';
             
             // create the uninvite button
             var button = new YAHOO.widget.Button(
             {
                 container: me.id + '-button-' + groupName,
                 label: "Edit members",
                 onclick:
                 {
                    fn: me.doAddMember,
                    obj: oRecord.getData(),
                    scope: me
                   }
             });
             
             // store the buttons
             me.buttons[groupName + "-button"] =
             {
                button: button
             };
          }
          else
          {
             // output padding div so layout is not messed up due to missing buttons
             elCell.innerHTML = '<div></div>';
          }

      };
      
      // DataTable column defintions
      var columnDefinitions = [
      {
         key: "displayName", label: "Group Name", sortable: false, formatter: renderCellIcon, width: 64
      },
      {
         key: "members", label: "Details", sortable: false, formatter: renderCellDescription
      },
      {
         key: "addMember", label: "Add member", sortable: false, formatter: renderCellAddMember, width: 80
      }
      ];

      // DataTable definition
      this.widgets.dataTable = new YAHOO.widget.DataTable(this.id + "-groups", columnDefinitions, this.widgets.dataSource,
      {
         renderLoopSize: 32,
         initialLoad: false,
         MSG_EMPTY: '<span style="white-space: nowrap;">' + this._msg("site-groups.enter-search-term") + '</span>'
      });

      // Override abstract function within DataTable to set custom error message
      this.widgets.dataTable.doBeforeLoadData = function SiteGroups_doBeforeLoadData(sRequest, oResponse, oPayload)
      {
         if (oResponse.error)
         {
            try
            {
               var response = YAHOO.lang.JSON.parse(oResponse.responseText);
               me.widgets.dataTable.set("MSG_ERROR", response.message);
            }
            catch(e)
            {
               me._setDefaultDataTableErrors(me.widgets.dataTable);
            }
         }
         else if (oResponse.results)
         {
            if (oResponse.results.length === 0)
            {
               me.widgets.dataTable.set("MSG_EMPTY", '<span style="white-space: nowrap;">' + me._msg("message.empty") + '</span>');
            }
            me.renderLoopSize = Alfresco.util.RENDERLOOPSIZE;
         }
         
         // Must return true to have the "Searching..." message replaced by the error message
         return true;
      };
  };
}(Alfresco.SiteGroups.prototype._setupDataTable));

/**
 * onReady override
 * Change from original: Changed webscript to custom webscript. 
 */
(function(onReady) {
  Alfresco.SiteGroups.prototype.onReady = function Lyse_SiteGroups_onReady() 
  {
    var me = this;

	// DataSource definition
    var uriSearchResults = Alfresco.constants.PROXY_URI + "api/lyse/" + me.options.siteId + "/getSiteGroups?";
	this.widgets.dataSource = new YAHOO.util.DataSource(uriSearchResults, {
		responseType : YAHOO.util.DataSource.TYPE_JSON,
		connXhrMode : "queueRequests",
		responseSchema : {
			resultsList : "items"
		}
	});
	this.widgets.dataSource.doBeforeParseData = function SiteGroups_doBeforeParseData(oRequest, oFullResponse) {
		var updatedResponse = oFullResponse.data;
		
		if (oFullResponse.data) {
			var items = [];
	
			// create a data format that the DataTable can use
			for (var x = 0, xx = oFullResponse.data.length; x < xx; x++) {
				var memberData = oFullResponse.data[x];
	
				// create object to represent member
				var member = {
					"displayName" : memberData.displayName,
					"fullName" : memberData.fullName,
					"members" : memberData.members,
					"role" : memberData.role,
					"isContainerGroup" : memberData.isContainerGroup,
					"subGroups": memberData.subGroups,
				};
				
				// add member to list
				items.push(member);
			}
	
			// Sort the memeber list by name
			items.sort(function(membership1, membership2) {
				var name1 = membership1.displayName, name2 = membership2.displayName;
				return (name1 > name2) ? 1 : (name1 < name2) ? -1 : 0;
			});
	
			// we need to wrap the array inside a JSON object so the DataTable is happy
			updatedResponse = {
				"items" : items
			};
		}
		return updatedResponse;
	};
	
	// determine if current user is a site administrator
	if (me.options.currentUserRole !== undefined && me.options.currentUserRole === "SiteManager") {
		this.isCurrentUserSiteAdmin = true;
	}
	
	// setup of the datatable.
	this._setupDataTable();
	
	// setup the buttons
	this.widgets.searchButton = Alfresco.util.createYUIButton(this, "button", this.doSearch);
	this.widgets.addGroups = Alfresco.util.createYUIButton(this,"addGroups", null, {
	  type : "link"
	});
	
	// register the "enter" event on the search text field
	var searchInput = Dom.get(this.id + "-term"), enterListener = new YAHOO.util.KeyListener(
	searchInput, {
		keys : 13
		}, {
		fn : function() {
			me.doSearch();
		},
		scope : this,
		correctScope : true 
	}, "keydown");
	enterListener.enable();
	
	if (this.options.error) {
		enterListener.disable();
		this.widgets.dataTable.set("MSG_ERROR", this.options.error);
		this.widgets.dataTable.showTableMessage(this.options.error,YAHOO.widget.DataTable.CLASS_ERROR);
		// Deactivate controls
		YAHOO.Bubbling.fire("deactivateAllControls");
	}
	
	// Set initial focus?
	if (this.options.setFocus) {
		searchInput.focus();
	}
	
	// This is a quick solution for showing all members of the site. The default search string 
	// is empty and equates to a global search.
	if (window.location.hash === "#showall" || this.options.minSearchTermLength === 0) {
		this.doSearch();
	}
	
	// Finally show the component body here to prevent UI artifacts on YUI button decoration
	Dom.setStyle(this.id + "-body", "visibility", "visible");
  };
}(Alfresco.SiteGroups.prototype.onReady));

