//@overridden projects/slingshot/source/web/components/upload/dnd-upload.js
(function()
{
  var Dom = YAHOO.util.Dom,
    KeyListener = YAHOO.util.KeyListener,
    Event = YAHOO.util.Event;

  YAHOO.util.Event.onDOMReady(function()
  {
    if(!Alfresco.DNDUpload)
    {
      return;
    }
    Alfresco.DNDUpload.prototype.show = function DNDUpload_show(config)
    {
      // Create an alias for this (it is required for the listener functions declared later)
      var _this = this;

      // Merge the supplied config with default config and check mandatory properties
      this.suppliedConfig = config;
      this.showConfig = YAHOO.lang.merge(this.defaultShowConfig, config);
      if (!this.showConfig.uploadDirectory && !this.showConfig.updateNodeRef && !this.showConfig.destination && !this.showConfig.uploadURL)
      {
        throw new Error("An updateNodeRef, uploadDirectory, destination or uploadURL must be provided");
      }

      if (this.showConfig.uploadDirectory !== null && this.showConfig.uploadDirectory.length === 0)
      {
        this.showConfig.uploadDirectory = "/";
      }

      // Apply the config before it is shown
      this._resetGUI();

      // Apply the config before it is shown
      this._applyConfig();

      // If files is not defined then assume we need to select them...
      if (this.showConfig.files == null || this.showConfig.files.length == 0)
      {
        // Display the file select section of the dialog
        // Hide the file and progress information...
        Dom.removeClass(this.id + "-file-selection-controls", "hidden");
        Dom.addClass(this.id + "-filelist-table", "hidden");
        Dom.addClass(this.aggregateDataWrapper, "hidden");

        if (YAHOO.env.ua.ie > 9 || window.navigator.userAgent.indexOf('Edge/') !== -1)
        {
          // Create a new file selection input element (to ensure old data is retained we will remove any old instance...
          if (this.fileSelectionInput && this.fileSelectionInput.parentNode)
          {
            this.fileSelectionInputParent = this.fileSelectionInput.parentNode;
            this.fileSelectionInput.parentNode.removeChild(this.fileSelectionInput); // Remove the old node...
          }
          else
          {
            this.fileSelectionInputParent = this.widgets.fileSelectionOverlayButton._button.parentNode;
            this.fileSelectionInputParent.removeChild(this.widgets.fileSelectionOverlayButton._button);
          }

          this.fileSelectionInput = document.createElement("input");
          Dom.setAttribute(this.fileSelectionInput, "type", "file");

          // Only set the multiple attribute on the input element if running in multi-file upload
          // (i.e. we don't want to allow multiple file selection when updating a file)
          if (this.suppliedConfig.mode !== this.MODE_SINGLE_UPLOAD && this.suppliedConfig.mode !== this.MODE_SINGLE_UPDATE)
          {
            Dom.setAttribute(this.fileSelectionInput, "multiple", "");
          }
          Dom.setAttribute(this.fileSelectionInput, "name", "files[]");
          Dom.addClass(this.fileSelectionInput, "ie10-dnd-file-selection-button");
          Event.addListener(this.fileSelectionInput, "change", this.onFileSelection, this, true);

          // MNT-12948
          new KeyListener(this.fileSelectionInput,
            {
              keys: KeyListener.KEY.ENTER
            },
            {
              fn: function enter_key_pressed(obj)
              {
                this.fileSelectionInput.click();
              },
              scope: this,
              correctScope: true
            }).enable();

          this.fileSelectionInputParent.appendChild(this.fileSelectionInput);
        }
        else
        {
          // Create a new file selection input element (to ensure old data is retained we will remove any old instance...
          if (this.fileSelectionInput && this.fileSelectionInput.parentNode)
          {
            this.fileSelectionInput.parentNode.removeChild(this.fileSelectionInput); // Remove the old node...
          }

          this.fileSelectionInput = document.createElement("input");
          Dom.setAttribute(this.fileSelectionInput, "type", "file");

          // Only set the multiple attribute on the input element if running in multi-file upload
          // (i.e. we don't want to allow multiple file selection when updating a file)
          if (this.suppliedConfig.mode !== this.MODE_SINGLE_UPLOAD && this.suppliedConfig.mode !== this.MODE_SINGLE_UPDATE)
          {
            Dom.setAttribute(this.fileSelectionInput, "multiple", "");
          }
          Dom.setAttribute(this.fileSelectionInput, "name", "files[]");
          Dom.addClass(this.fileSelectionInput, "dnd-file-selection-button");
          Event.addListener(this.fileSelectionInput, "change", this.onFileSelection, this, true);
          this.widgets.fileSelectionOverlayButton._button.parentNode.appendChild(this.fileSelectionInput);
        }

        // Enable the Esc key listener
        this.widgets.escapeListener.enable();
        this.widgets.enterListener = new KeyListener(this.widgets.fileSelectionOverlayButton._button,
          {
            keys: KeyListener.KEY.ENTER
          },
          {
            fn: function enter_key_pressed(obj)
            {
              this.fileSelectionInput.click();
            },
            scope: this,
            correctScope: true
          });
        this.widgets.enterListener.enable();
        this.panel.setFirstLastFocusable();
        this.panel.show();
      }
      else
      {
        Dom.removeClass(this.id + "-filelist-table", "hidden");
        Dom.removeClass(this.aggregateDataWrapper, "hidden");
        Dom.addClass(this.id + "-file-selection-controls", "hidden");
        this.processFilesForUpload(this.showConfig.files);
      }
    };
  });
})();
