YAHOO.util.Event.onDOMReady(function () {
    if (window.opener) {
        var openerHref = window.opener.location.href;
        // Displays a message and closes the current tab when submitting/cancelling the task form
        var originalNavigateForward = Alfresco.component.FormManager.prototype.navigateForward;
        Alfresco.component.FormManager.prototype.navigateForward = function(submitted) {
            var closeWindow = function (message) {
                var displayTime = 3;
                Alfresco.util.PopupManager.displayMessage({
                    text: message,
                    displayTime: displayTime
                });
                if (window.opener && window.opener.location.href == openerHref) {
                    // Refresh the datagrid or window that opened this window,
                    // but only it the URL has not changed to prevent losing any changes!
                    if (window.opener.refreshDataGrid) {
                      window.opener.refreshDataGrid();
                    }
                    else{
                      // Fallback to reloading whole page. Should not happen.
                      console.warn("No refreshDataGrid function in opener!");
                      window.opener.location.reload();
                    }
                }
                window.setTimeout(Lyse.util.closeWindow, displayTime * 1000);
            };
            // If referrer is the same as the submitUrl/cancelUrl we also allow closing the window (since RL workflow redirect module sets submitUrl to document.referrer if submitUrl is empty)
            if (submitted && (!this.options.submitUrl || this.options.submitUrl == document.referrer)) {
                closeWindow(this.msg("message.close-window.submitted"));
            }
            else if (!submitted && (!this.options.cancelUrl || this.options.cancelUrl == document.referrer)) {
                closeWindow(this.msg("message.close-window.cancelled"));
            }
            else {
                originalNavigateForward.call(this, submitted);
            }
        };
    }
});
