<%-- @overridden projects/slingshot/source/web/error500.jsp --%>
<%--
 * Copyright (C) 2005-2016 Alfresco Software Limited.
 *
 * This file is part of Alfresco
 *
 * Alfresco is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Alfresco is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Alfresco. If not, see <http://www.gnu.org/licenses/>.
--%>
<%@ page isErrorPage="true" %>
<%@ page import="java.io.*" %>
<%@ page import="org.springframework.extensions.webscripts.ui.common.StringUtils" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <style type="text/css">
    .text-jumbo {
      font-size: 60px;
      font-weight: 700;
      color:#484848;
    }
    .left-div
    {
      margin: 0 auto;
      width: 90%;
    }
    .h2
    {
      font-weight: normal;
      font-size:32px;
      margin-top: 0px;
      margin-bottom: 0px;
      color:#484848;
    }
    .h4
    {
      font-size:14px;
      font-weight:bold;
      color:#767676;
    }
    #myBar {
      width: 10%;
      height: 30px;
      background-color: #4CAF50;
      text-align: center; /* To center it horizontally (if you want) */
      line-height: 30px; /* To center it vertically */
      color: white;
    }
  </style>
  <title>Alfresco Share &raquo; System Error</title>
</head>
<body>
<div class="left-div">
  <img src="${pageContext.request.contextPath}/res/themes/lysetheme/images/logo.png" alt="" width="93px" height="48px" border="0"/>
  <h1 class="text-jumbo">Oops, something went wrong. :(</h1>
  <h2>Please contact your Alfresco administrators with the following information:</h2>
  <b>URL</b>: ${requestScope['javax.servlet.forward.request_uri']}<br/>
  <b>Time</b>: <%= new java.util.Date() %><br/>
  <b>Error code</b>: ${requestScope['javax.servlet.error.status_code']} : ${requestScope['javax.servlet.error.exception']}<br/><br/>
  <div id="myProgress" style="display: none;">
    <b>Attempting to solve problem....</b>
    <div id="myBar">0%</div>
  </div>
</div>
</body>

<div>
  <script>
    function move() {
      var elem = document.getElementById("myBar");
      var width = 10;
      var id = setInterval(frame, 69);
      function frame() {
        if (width >= 98) {
          clearInterval(id);
        } else {
          width++;
          elem.style.width = width + '%';
          elem.innerHTML = width * 1 + '%';
        }
      }
    }
    // Match the URL to make sure we are trying to access a site with /site/xxx/dashboard
    var regexSiteDashboardURL = "^/site/.+/dashboard$";
    var regexExpectedException = "javax\.servlet\.ServletException: Could not resolve view with name 'site\/.+\/dashboard' in servlet with name 'Spring Surf Dispatcher Servlet'$";
    if(("${requestScope['javax.servlet.forward.path_info']}".match(regexSiteDashboardURL) != null) && ("${requestScope['javax.servlet.error.exception']}".match(regexExpectedException) != null)) {
      // Just for fun
      document.getElementById("myProgress").style.display = 'block';
      move();
      //-------------
      var shortName = "${requestScope['javax.servlet.forward.path_info']}".match("\/site\/(.*)\/dashboard")[1];
      var url = "";
      if (!window.location.origin) {
        // IE<9
        url = window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '');
      } else {
        url = window.location.origin
      }

      url += "/share/service/rl/support/reset-site-dashboard?shortName=";
      url += shortName;
      var oReq = new XMLHttpRequest();
      oReq.onreadystatechange = function () {
        if(oReq.readyState === 4 && oReq.status === 200) {
          console.log("Attempting to reset dashboard with URL:" + url);
          location.reload();
        }
      };
      oReq.open("GET", url);
      oReq.send();
    }
  </script>
  <%
    out.println("<!--");
    StringWriter sw = new StringWriter();
    PrintWriter pw = new PrintWriter(sw);
    if (exception != null)
    {
      exception.printStackTrace(pw);
      out.print(StringUtils.encode(sw.toString()));
      sw.close();
      pw.close();
      out.println("-->");
      LogFactory.getLog("org.alfresco.web.site").error(exception, exception.getCause());
    }
  %>
</div>
</div>
</body>
</html>
