// @overridden share/web-framework-commons/src/main/webapp/js/forms-runtime.js
YAHOO.util.Event.onDOMReady(function() {
  (function(_submitInvoked) {
	  var Dom = YAHOO.util.Dom,
    	Event = YAHOO.util.Event;
	  
	  Alfresco.forms.Form.prototype._submitInvoked = function(event) {
		  if (Alfresco.logger.isDebugEnabled())
	            Alfresco.logger.debug("Submit invoked on formId: ", this.formId);

       this._setAllFieldsAsVisited();

       // Run all validators
       if (this._runValidations(event, null, Alfresco.forms.Form.NOTIFICATION_LEVEL_CONTAINER))
       {
          // validation was successful

          // get the form element
          var form = Dom.get(this.formId);

          // call the pre-submit function, passing the form for last-chance processing
          this.doBeforeFormSubmit.fn.call(this.doBeforeFormSubmit.scope, form, this.doBeforeFormSubmit.obj);

          // fire event to inform any listening components that the form will be submitted
          YAHOO.Bubbling.fire("formBeforeSubmit", this);

          // should submission be done using AJAX, or let
          // the browser do the submit?
          if (this.ajaxSubmit)
          {
             // stop the browser from submitting the form
             if (typeof event.cancelBubble !== 'unknown' && typeof event.returnValue !== 'unknown')
             {
                Event.stopEvent(event);
             }

             // get the form's action URL
             var submitUrl = form.attributes.action.nodeValue;

             if (Alfresco.logger.isDebugEnabled())
             {
                Alfresco.logger.debug("Performing AJAX submission to url: ", submitUrl);
             }

             // determine how to submit the form, if the enctype
             // on the form is set to "application/json" then
             // package the form data as an AJAX string and post
             if (form.enctype && form.enctype == "multipart/form-data")
             {
                var d = form.ownerDocument;
                var iframe = d.createElement("iframe");
                iframe.style.display = "none";
                Dom.generateId(iframe, "formAjaxSubmit");
                iframe.name = iframe.id;
                document.body.appendChild(iframe);

                // makes it possible to target the frame properly in IE.
                window.frames[iframe.name].name = iframe.name;

                // Pass the CSRF token if the CSRF token filter is enabled
                if (Alfresco.util.CSRFPolicy.isFilterEnabled())
                {
                   form.attributes.action.nodeValue = this._setCSRFParameter(submitUrl);
                }

                form.target = iframe.name;
                form.submit();
                return;
             }
             else
             {
                // Only disable submit elements for XMLHttpRequests since we then have a chance of enabling them on failure
                this._toggleSubmitElements(false);
             }

             // create config object to pass to request helper
             var config =
             {
                method: this.ajaxSubmitMethod,
                url: submitUrl
             };

             if (this.ajaxSubmitHandlers)
             {
                this.ajaxSubmitHandlers = this.ajaxSubmitHandlers || {};
                config.successMessage = this.ajaxSubmitHandlers.successMessage;
                config.successCallback = {
                   fn: function(response, successCallback)
                   {
                      if (Dom.get(this.formId))
                      {
                         // The form still exists
                         this._resetAllVisitedFields();
                         if (this.reusable)
                         {
                            if (this.showSubmitStateDynamically)
                            {
                               // Update using validation
                               this.updateSubmitElements();
                            }
                            else
                            {
                               // Enable submit buttons
                               this._toggleSubmitElements(true);
                            }
                         }
                      }
                      if (successCallback.fn)
                      {
                         successCallback.fn.call(successCallback.scope || this, response, successCallback.obj);
                      }
                   },
                   obj: this.ajaxSubmitHandlers.successCallback || {},
                   scope: this
                };
                config.failureMessage = this.ajaxSubmitHandlers.failureMessage;
                config.failureCallback = {
                   fn: function(response, failureCallback)
                   {
                      if (Dom.get(this.formId))
                      {
                         // The form still exists
                         this._resetAllVisitedFields();
                         if (this.showSubmitStateDynamically)
                         {
                            // Update using validation
                            this.updateSubmitElements();
                         }
                         else
                         {
                            // Enable submit buttons
                            this._toggleSubmitElements(true);
                         }
                      }
                      if (failureCallback.fn)
                      {
                         failureCallback.fn.call(failureCallback.scope || this, response, failureCallback.obj);
                      }
                   },
                   obj: this.ajaxSubmitHandlers.failureCallback || {},
                   scope: this
                };
             } else {
          	   //Start Lyse customization
               //In case submithandlers are missing
          	   //config.successMessage = this.ajaxSubmitHandlers.successMessage;
          	   config.successCallback = {
                         fn: function(response, successCallback)
                         {
                            if (Dom.get(this.formId))
                            {
                               // The form still exists
                               this._resetAllVisitedFields();
                               if (this.reusable)
                               {
                                  if (this.showSubmitStateDynamically)
                                  {
                                     // Update using validation
                                     this.updateSubmitElements();
                                  }
                                  else
                                  {
                                     // Enable submit buttons
                                     this._toggleSubmitElements(true);
                                  }
                               }
                            }
                            if (successCallback && successCallback.fn)
                            {
                               successCallback.fn.call(successCallback.scope || this, response, successCallback.obj);
                            }
                         },
                         scope: this
                      };
          	   //config.failureMessage = this.ajaxSubmitHandlers.failureMessage;
                 config.failureCallback = {
                    fn: function(response, failureCallback)
                    {
                       if (Dom.get(this.formId))
                       {
                          // The form still exists
                          this._resetAllVisitedFields();
                          if (this.showSubmitStateDynamically)
                          {
                             // Update using validation
                             this.updateSubmitElements();
                          }
                          else
                          {
                             // Enable submit buttons
                             this._toggleSubmitElements(true);
                          }
                       }
                       if (failureCallback && failureCallback.fn)
                       {
                          failureCallback.fn.call(failureCallback.scope || this, response, failureCallback.obj);
                       }
                    },
                    scope: this
                 };
          	   //End Lyse customization
             }
             if (this.submitAsJSON)
             {
                var jsonData = this._buildAjaxForSubmit(form);

                // set up specific config
                config.dataObj = jsonData;
                config.noReloadOnAuthFailure = this.ajaxNoReloadOnAuthFailure;

                // call the pre-request function, passing the config object for last-chance processing
                if (this.doBeforeAjaxRequest.fn.call(this.doBeforeAjaxRequest.scope, config, this.doBeforeAjaxRequest.obj))
                {
                   if (Alfresco.logger.isDebugEnabled())
                      Alfresco.logger.debug("Submitting JSON data: ", config.dataObj);

                   Alfresco.util.Ajax.jsonRequest(config);
                }
                else
                {
              	 //Start Lyse customization, move toggle
              	 this._toggleSubmitElements(true);
                   if (Alfresco.logger.isDebugEnabled())
                      Alfresco.logger.debug("JSON data request cancelled in doBeforeAjaxRequest()");
                }
                //this._toggleSubmitElements(true);
                //End Lyse customization
             }
             else
             {
                if (Alfresco.logger.isDebugEnabled())
                   Alfresco.logger.debug("Submitting data in form: ", form.enctype);

                // set up specific config
                config.dataForm = form;
                Alfresco.util.Ajax.request(config);
             }
          }
          else
          {
             if (form.enctype && form.enctype == "multipart/form-data" && Alfresco.util.CSRFPolicy.isFilterEnabled())
             {
                // We are submitting the form as  multipart/form-data and leaving the page, make sure the CSRF token is set
                form.attributes.action.nodeValue = this._setCSRFParameter(form.attributes.action.nodeValue);
             }
          }
       }
       else
       {
          // stop the event from continuing and sending the form.
          Event.stopEvent(event);

          if (Alfresco.logger.isDebugEnabled())
             Alfresco.logger.debug("Submission prevented as validation failed");
          
          // Enable submit buttons
          this._toggleSubmitElements(true);
       }
	  };
  }(Alfresco.forms.Form.prototype._submitInvoked));
});
