/**
 * Created by magnus on 2016-09-28.
 */

(function()
{
  var Event = YAHOO.util.Event;
  Lyse.DatalistActions = {};
  Lyse.DatalistActions =
    {
      onActionEdit: function DataGrid_onActionEdit(nodeRef, formId, fn)
      {
        // Intercept before dialog show
        var doBeforeDialogShow = function DataGrid_onActionEdit_doBeforeDialogShow(p_form, p_dialog)
        {
          Alfresco.util.populateHTML(
            [ p_dialog.id + "-dialogTitle", this.msg("label.edit-row.title") ]
          );

        };

        var templateUrl = YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&itemId={itemId}&mode={mode}&submitType={submitType}&site={site}&showCancelButton=true",
          {
            itemKind: "node",
            itemId: nodeRef,
            mode: "edit",
            submitType: "json",
            site: Alfresco.constants.SITE
          });

        if (formId) {
          templateUrl += "&formId=" + formId;
        }

        // Using Forms Service, so always create new instance
        var editDetails = new Alfresco.module.SimpleDialog(this.id + "-editDetails");
        editDetails.setOptions(
          {
            width: "1000px",
            templateUrl: templateUrl,
            actionUrl: null,
            destroyOnHide: true,
            doBeforeDialogShow:
              {
                fn: doBeforeDialogShow,
                scope: this
              },
            onSuccess:
              {
                fn: function DataGrid_onActionEdit_success(response)
                {
                  if(fn)
                  {
                    fn.call(this,response);
                  }
                },
                scope: this
              },
            onFailure:
              {
                fn: function DataGrid_onActionEdit_failure(response)
                {
                  Alfresco.util.PopupManager.displayPrompt(
                    {
                      text: this.msg("message.details.failure")
                    });
                },
                scope: this
              }
          }).show();
      },
      onActionStartShareForInformationWorkflow: function ExtDataGrid_onActionStartShareForInformationWorkflow(nodeRef,fn) {
        var doBeforeDialogShow = function(p_form, p_dialog)
        {
          Alfresco.util.populateHTML(
            [ p_dialog.id + "-dialogTitle", this.msg("actions.start-share-workflow.for-information") ],
            [ p_dialog.id + "-form-submit-button", this.msg("actions.start-share-workflow.send") ]
          );
        };

        var templateUrl = YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&itemId={itemId}&destination={destination}&mode={mode}&submitType={submitType}&showCancelButton=true",
          {
            itemKind: "action",
            itemId: "lyse.action.share-for-information",
            mode: "create",
            destination: nodeRef,
            submitType: "json"
          });

        var dialog = new Alfresco.module.SimpleDialog(this.id + "-shareForInformation");
        dialog.setOptions(
          {
            templateUrl: templateUrl,
            actionUrl: null,
            destroyOnHide: true,
            doBeforeDialogShow:
              {
                fn: doBeforeDialogShow,
                scope: this
              },
            onSuccess:
              {
                fn: function(response)
                {
                  if(fn)
                  {
                    fn.call(this,response);
                  }

                },
                scope: this
              },
            onFailure:
              {
                fn: function(response)
                {
                  Alfresco.util.PopupManager.displayPrompt(
                    {
                      text: this.msg("actions.start-share-workflow.error")
                    });
                },
                scope: this
              },
            width: "800px"
          }).show();
      },
      onActionStartShareForCommentingWorkflow: function ExtDataGrid_onActionStartShareForCommentingWorkflow(nodeRef,fn) {
        var doBeforeDialogShow = function(p_form, p_dialog)
        {
          Alfresco.util.populateHTML(
            [ p_dialog.id + "-dialogTitle", this.msg("actions.start-share-workflow.for-commenting") ],
            [ p_dialog.id + "-form-submit-button", this.msg("actions.start-share-workflow.send") ]
          );
        };

        var templateUrl = YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&itemId={itemId}&destination={destination}&mode={mode}&submitType={submitType}&showCancelButton=true",
          {
            itemKind: "action",
            itemId: "lyse.action.share-for-commenting",
            mode: "create",
            destination: nodeRef,
            submitType: "json"
          });

        var dialog = new Alfresco.module.SimpleDialog(this.id + "-shareForCommenting");
        dialog.setOptions(
          {
            templateUrl: templateUrl,
            actionUrl: null,
            destroyOnHide: true,
            doBeforeDialogShow:
              {
                fn: doBeforeDialogShow,
                scope: this
              },
            onSuccess:
              {
                fn: function(response)
                {
                  if(fn)
                  {
                    fn.call(this,response);
                  }
                },
                scope: this
              },
            onFailure:
              {
                fn: function(response)
                {
                  Alfresco.util.PopupManager.displayPrompt(
                    {
                      text: this.msg("actions.start-share-workflow.error")
                    });
                },
                scope: this
              },
            width: "800px"
          }).show();
      },
      onShowShareHistoryList: function ExtDataGrid_onShowShareHistoryList(nodeRef) {
        var panel = Alfresco.util.PopupManager.displayWebscript(
          {
            title: this.msg("dialog.title.share-history"),
            url: YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "/components/workflow/lyse-share-history?nodeRef={nodeRef}", { nodeRef: nodeRef }),
            properties: {
            }
          }
        );
        // Register the ESC key to close the panel
        var escapeListener = new YAHOO.util.KeyListener(document,
          {
            keys: YAHOO.util.KeyListener.KEY.ESCAPE
          },
          {
            fn: function(id, keyEvent)
            {
              this.destroy();
            },
            scope: panel,
            correctScope: true
          });
        escapeListener.enable();
      },
      onShowEditors: function ExtDataGrid_onShowEditors(nodeRef) {
        var panel = Alfresco.util.PopupManager.displayWebscript(
          {
            title: this.msg("dialog.title.editors"),
            url: YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "/components/permissions/lyse-show-editors?nodeRef={nodeRef}", { nodeRef: nodeRef }),
            properties: {
            }
          }
        );
        // Register the ESC key to close the panel
        var escapeListener = new YAHOO.util.KeyListener(document,
          {
            keys: YAHOO.util.KeyListener.KEY.ESCAPE
          },
          {
            fn: function(id, keyEvent)
            {
              this.destroy();
            },
            scope: panel,
            correctScope: true
          });
        escapeListener.enable();
      },

      onShowWorkflowHistoryList: function ExtDataGrid_onShowWorkflowHistoryList(nodeRef) {
        var panel = Alfresco.util.PopupManager.displayWebscript(
          {
            title: this.msg("dialog.title.workflow-history"),
            url: YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "/components/workflow/lyse-workflow-history?nodeRef={nodeRef}", { nodeRef: nodeRef }),
            properties: {
            }
          }
        );
        // Register the ESC key to close the panel
        var escapeListener = new YAHOO.util.KeyListener(document,
          {
            keys: YAHOO.util.KeyListener.KEY.ESCAPE
          },
          {
            fn: function(id, keyEvent)
            {
              this.destroy();
            },
            scope: panel,
            correctScope: true
          });
        escapeListener.enable();
      },


      datalistConstraintsTrue : function ExtDataGrid_datalistConstraintsTrue(item)
      {
        if (item === undefined){
          return false;
        }
        if(!item.value) {
          return false;
        }
        if(item.length === 0) {
          return false;
        }
        return true;
      },
      /**
       * Upload new revision of contractors document.
       * Its possible to upload a new revision even if there is an active confirm-task (status "approvedWithComments")
       * In that case the user will be asked if she wants to just set the status to review or initiate a new "Review round"
       * (new workflow instance)
       *
       * @method onActionUploadNewRevision
       * @param item {object} Object literal representing one data item
       */
      onActionUploadNewRevision: function ExtDataGrid_onActionUploadNewRevision(item)
      {
        var datalistType = "";

        if(this.itemType){
          datalistType = this.itemType;
        }
        else if(this.datalistMeta){
          if(this.datalistMeta.itemType){datalistType = this.datalistMeta.itemType;}
        }
        if (datalistType === "lysedl:contractDataList"){

          if(!Lyse.DatalistActions.datalistConstraintsTrue(item.itemData.prop_lysedl_contractContractorReviewResponsibleAsText)){
            Alfresco.util.PopupManager.displayPrompt({text: Alfresco.util.message("message.missingContractReviewers")});
            return;
          }
        }
        else if(datalistType === "lysedl:civilContractDataList"){
          if(!Lyse.DatalistActions.datalistConstraintsTrue(item.itemData.prop_lysedl_civilContractContractorReviewResponsibleAsText))
          {
            Alfresco.util.PopupManager.displayPrompt({text: Alfresco.util.message("message.missingContractReviewers")});
            return;
          }
        }

        if (!this.fileUpload)
        {
          this.fileUpload = Alfresco.getFileUploadInstance();
        }
        var nodeToUpdate = "";

        var hasWorkflowStatus = true;
        var isApprovable = false;
        if (item.itemData.assoc_lyse_cdlDocument != undefined){
          nodeToUpdate = item.itemData.assoc_lyse_cdlDocument.value.toString();
          isApprovable = (item.itemData.prop_lyse_cdlReviewStatus.value == "approvedWithComments");
          hasWorkflowStatus = (item.itemData.prop_lyse_cdlReviewStatus.value != "draft");
        }else if (item.itemData.assoc_lyse_companysDocument != undefined){
          nodeToUpdate = item.itemData.assoc_lyse_companysDocument.value.toString();
          isApprovable = (item.itemData.prop_lyse_companysDocumentReviewStatus.value == "approvedWithComments");
          hasWorkflowStatus = (item.itemData.prop_lyse_companysDocumentReviewStatus.value != "draft");
        }else if (item.itemData.assoc_lyse_genericDocument != undefined){
          nodeToUpdate = item.itemData.assoc_lyse_genericDocument.value.toString();
          isApprovable = false; // no workflow
        }else if (item.itemData.assoc_lyse_civilCdlDocument != undefined){
          nodeToUpdate = item.itemData.assoc_lyse_civilCdlDocument.value.toString();
          isApprovable = (item.itemData.prop_lyse_civilCdlReviewStatus.value == "approvedWithComments");
          hasWorkflowStatus = (item.itemData.prop_lyse_civilCdlReviewStatus.value != "draft");
        }
        var singleUpdateConfig =
          {
            updateNodeRef: nodeToUpdate,
            suppressRefreshEvent: true,
            overwrite: true,

            mode: this.fileUpload.MODE_SINGLE_UPDATE,
            onFileUploadComplete:
              {
                fn: function(complete){
                  if(complete.failed === undefined || complete.failed.length === 0)
                  {
                    Lyse.DatalistActions.onActionPopupEditForm.call(this, "label.edit-revision.title", "edit-revision", item, function () {
                      var me = this;
                      // No workflow for generic docs.
                      if (item.itemData.assoc_lyse_genericDocument != undefined) {
                        if (me.refreshItem !== undefined) {
                          me.refreshItem(item.nodeRef, "message.details.success");
                        } else {
                          window.location.reload();
                        }
                      }
                      else {
                        Alfresco.util.PopupManager.displayPrompt(
                          {
                            title: Alfresco.util.message("datalist.prompt.CDLstartworkflow"),
                            text: isApprovable ? Alfresco.util.message("datalist.prompt.CDLstartworkflow.approve") : Alfresco.util.message("datalist.prompt.CDLstartworkflow.draft"),
                            buttons: [
                              {
                                text: isApprovable ? Alfresco.util.message("button.startCDL") : Alfresco.util.message("button.yes"),
                                handler: function () {
                                  this.destroy();

                                  // If its apporvable, end current worfklow with webscript before start new.
                                  if(hasWorkflowStatus){
                                    Alfresco.util.Ajax.jsonPut({
                                      url: Alfresco.constants.PROXY_URI
                                        + "api/lyse/set-approved/"
                                        + item.nodeRef.replace("://", "/")
                                        + "/true?uploadNewRevision=true",
                                      successCallback: {
                                        fn: function(response){
                                          me.onActionStartWorkflow(item);
                                        },
                                        scope: me
                                      }
                                    });
                                  }else{
                                    me.onActionStartWorkflow(item);
                                  }

                                },
                                isDefault: true
                              },
                              {
                                text: isApprovable ? Alfresco.util.message("button.aproveCDL") : Alfresco.util.message("button.no"),
                                handler: function () {
                                  this.destroy();
                                  if(isApprovable){
                                    Alfresco.util.Ajax.jsonPut({
                                      url: Alfresco.constants.PROXY_URI
                                        + "api/lyse/set-approved/"
                                        + item.nodeRef.replace("://", "/")
                                        + "/false?uploadNewRevision=true",
                                      successCallback: {
                                        fn: function(response){
                                          me.refreshItem(item.nodeRef, "message.details.success");
                                        },
                                        scope: me
                                      }
                                    });
                                  }
                                }
                              }]
                          });
                      }
                    });
                  }
                },
                scope: this
              }
          };
        if (Alfresco.util.isValueSet(this.options.siteId))
        {
          singleUpdateConfig.siteId = this.options.siteId;
          singleUpdateConfig.containerId = "documentLibrary";
        }

        this.fileUpload.show(singleUpdateConfig);

        // Hide the version information div
        this.fileUploadDialog = this.fileUpload.uploader.id;
        Dom.addClass(Dom.get(this.fileUploadDialog + "-versionSection-div"), "hidden");
        var fileSelectionButton = Dom.get(this.fileUploadDialog + "-file-selection-button-overlay-button");
        var fileSelectionInput = Dom.getNextSibling(fileSelectionButton);
        Event.addListener(fileSelectionInput, "change", Lyse.DatalistActions.onFileSelection, this, true);
      },

      /**
       * Called when files are selected from the input element.
       *
       * @method onBrowseButtonClick
       * @param event {object} a file selection "change" event
       */
      onFileSelection: function ExtDataGrid_onFileSelection(evt)
      {
        // FileList object
        var files = evt.target.files;
        if (files != null)
        {
          var statusSpan = Dom.get(this.fileUploadDialog + "-status-span");
          statusSpan.innerHTML = files[0].name;
          Dom.removeClass(statusSpan, "hidden");
        }
        else
        {
          // No files selected, do nothing.
        }
      },

      /**
       * Edit revision information for record pop-up
       *
       * @method onActionEditRevision
       * @param item {object} Object literal representing one data item
       */
      onActionPopupEditForm: function DataGrid_onActionPopupEditForm(dialogTitle, formId, item, fn)
      {
        // Intercept before dialog show
        var doBeforeDialogShow = function DataGrid_onActionPopupEditForm_doBeforeDialogShow(p_form, p_dialog)
        {
          Alfresco.util.populateHTML(
            [ p_dialog.id + "-dialogTitle", this.msg(dialogTitle) ]
          );

        };

        var templateUrl = YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&itemId={itemId}&mode={mode}&submitType={submitType}&formId={formId}&site={site}&showCancelButton=true",
          {
            itemKind: "node",
            itemId: item.nodeRef,
            mode: "edit",
            submitType: "json",
            formId: formId,
            site: Alfresco.constants.SITE
          });

        // Using Forms Service, so always create new instance
        var editDetails = new Alfresco.module.SimpleDialog(this.id + "-editDetails");
        editDetails.setOptions(
          {
            width: "1000px",
            templateUrl: templateUrl,
            actionUrl: null,
            destroyOnHide: true,
            doBeforeDialogShow:
              {
                fn: doBeforeDialogShow,
                scope: this
              },
            onSuccess:
              {
                fn: function DataGrid_onActionPopupEditForm_success(response)
                {
                  if(fn)
                  {
                    fn.call(this,response);
                  }

                },
                scope: this
              },
            onFailure:
              {
                fn: function DataGrid_onActionPopupEditForm_failure(response)
                {
                  if (response.serverResponse.responseText.contains("error.responsiblesMissing")){
                    Alfresco.util.PopupManager.displayPrompt(
                      {
                        text: this.msg("message.details.responsiblesMissing")
                      });
                  }else {
                    Alfresco.util.PopupManager.displayPrompt(
                      {
                        text: this.msg("message.details.failure")
                      });
                  }
                },
                scope: this
              }
          }).show();
      },

      onActionUploadIFC: function ExtDataGrid_onActionUploadIFC(item) {

        if (!this.fileUpload) {
          this.fileUpload = Alfresco.getFileUploadInstance();
        }
        var nodeToUpdate = "";

        nodeToUpdate = item.itemData.assoc_lyse_engIfcAttachment.value.toString();

        var singleUpdateConfig = {
          updateNodeRef: nodeToUpdate,
          suppressRefreshEvent: true,
          overwrite: true,

          mode: this.fileUpload.MODE_SINGLE_UPDATE,
          onFileUploadComplete: {
            fn: function(complete) {
              if (complete.failed === undefined || complete.failed.length === 0) {
                Lyse.DatalistActions.onActionPopupEditForm.call(this, "label.edit-revision.title", "upload-ifc", item, function () {
                  var me = this;

                  Alfresco.util.PopupManager.displayPrompt({
                    title: Alfresco.util.message("datalist.prompt.uploadIFC"),
                    text: Alfresco.util.message("datalist.prompt.confirmIFC"),
                    buttons: [{
                      text: Alfresco.util.message("button.yes"),
                      handler: function() {
                        this.destroy();
                        me.onActionStartConfirmIFCWorkflow(item);
                      },
                      isDefault: true
                    },
                      {
                        text: Alfresco.util.message("button.no"),
                        handler: function() {
                          this.destroy();
                          Alfresco.util.Ajax.jsonPut({
                            url: Alfresco.constants.PROXY_URI +
                              "api/lyse/set-status/" +
                              item.nodeRef.replace("://", "/") +
                              "?statusValue=ifc",
                            successCallback: {
                              fn: function(response) {
                                me.refreshItem(item.nodeRef, "message.details.success");
                              },
                              scope: me
                            }
                          });
                        }
                      }
                    ]
                  });

                });
              }
            },
            scope: this
          }
        };
        if (Alfresco.util.isValueSet(this.options.siteId)) {
          singleUpdateConfig.siteId = this.options.siteId;
          singleUpdateConfig.containerId = "documentLibrary";
        }

        this.fileUpload.show(singleUpdateConfig);

        // Hide the version information div
        this.fileUploadDialog = this.fileUpload.uploader.id;
        Dom.addClass(Dom.get(this.fileUploadDialog + "-versionSection-div"), "hidden");
        var fileSelectionButton = Dom.get(this.fileUploadDialog + "-file-selection-button-overlay-button");
        var fileSelectionInput = Dom.getNextSibling(fileSelectionButton);
        Event.addListener(fileSelectionInput, "change", Lyse.DatalistActions.onFileSelection, this, true);
      },

      onActionUploadAsBuilt: function ExtDataGrid_onActionUploadAsBuilt(item, itemType) {

        if (!this.fileUpload) {
          this.fileUpload = Alfresco.getFileUploadInstance();
        }
        var nodeToUpdate = "";

        nodeToUpdate = item.itemData.assoc_lyse_engAsBuiltAttachment.value.toString();

        var singleUpdateConfig = {
          updateNodeRef: nodeToUpdate,
          suppressRefreshEvent: true,
          overwrite: true,

          mode: this.fileUpload.MODE_SINGLE_UPDATE,
          onFileUploadComplete: {
            fn: function(complete) {
              if (complete.failed === undefined || complete.failed.length === 0) {
                Lyse.DatalistActions.onActionPopupEditForm.call(this, "label.edit-revision.title", "as-built", item, function () {
                  var me = this;
                  Alfresco.util.Ajax.jsonPut({
                    url: Alfresco.constants.PROXY_URI +
                      "api/lyse/set-status/" +
                      item.nodeRef.replace("://", "/") +
                      "?statusValue=asBuilt",
                    successCallback: {
                      fn: function(response) {
                        me.refreshItem(item.nodeRef, "message.details.success");
                      },
                      scope: me
                    }
                  });
                });
              }
            },
            scope: this
          }
        };
        if (Alfresco.util.isValueSet(this.options.siteId)) {
          singleUpdateConfig.siteId = this.options.siteId;
          singleUpdateConfig.containerId = "documentLibrary";
        }

        this.fileUpload.show(singleUpdateConfig);

        // Hide the version information div
        this.fileUploadDialog = this.fileUpload.uploader.id;
        Dom.addClass(Dom.get(this.fileUploadDialog + "-versionSection-div"), "hidden");
        var fileSelectionButton = Dom.get(this.fileUploadDialog + "-file-selection-button-overlay-button");
        var fileSelectionInput = Dom.getNextSibling(fileSelectionButton);
        Event.addListener(fileSelectionInput, "change", Lyse.DatalistActions.onFileSelection, this, true);
      },


      onActionSubmitForReview: function ExtDataGrid_onActionSubmitForReview(item,itemType,fn)
      {
        // Collect nodes to operate on.
        var payload = {
          firstUserTask : "default",
          nodes : [{nodeRef : item.nodeRef}]
        };

        if (itemType === "lysedl:cdlDataList") {
          if (item.itemData.prop_lysedl_cdlCompanyReviewResponsibleAsText === undefined ||
            item.itemData.prop_lysedl_cdlCompanyReviewResponsibleAsText.value === "") {
            Alfresco.util.PopupManager.displayPrompt(
              {
                text: Alfresco.util.message("message.missingReviewers")
              });
            return false;
          }
        }else  if (itemType === "lysedl:civilCdlDataList") {
          if (item.itemData.prop_lysedl_civilCdlCompanyReviewResponsibleAsText === undefined) {
            Alfresco.util.PopupManager.displayPrompt(
              {
                text: Alfresco.util.message("message.missingReviewers")
              });
            return false;

          }
        }else if (itemType === "lysedl:companysDocumentDataList") {
          if (item.itemData.prop_lysedl_companysDocumentCompanyReviewResponsibleAsText === undefined) {
            Alfresco.util.PopupManager.displayPrompt(
              {
                text: Alfresco.util.message("message.missingReviewers")
              });
            return false;

          }
        }
        else if (itemType === "lysedl:contractDataList") {
          if(!Lyse.DatalistActions.datalistConstraintsTrue(item.itemData.prop_lysedl_contractContractorReviewResponsibleAsText)){
            Alfresco.util.PopupManager.displayPrompt({text: Alfresco.util.message("message.missingContractReviewers")});
            return false;
          }
        }
        else if(itemType === "lysedl:civilContractDataList")
        {
          if(!Lyse.DatalistActions.datalistConstraintsTrue(item.itemData.prop_lysedl_civilContractContractorReviewResponsibleAsText))
          {
            Alfresco.util.PopupManager.displayPrompt({text: Alfresco.util.message("message.missingContractReviewers")});
            return false;
          }
        }
        else {
          if (item.itemData.prop_lysedl_civilContractContractorReviewResponsibleAsText === undefined) {
            Alfresco.util.PopupManager.displayPrompt(
              {
                text: Alfresco.util.message("message.missingContractorReviewers")
              });
            return false;

          }
        }

        // set-approved with the ending /true finishes confirm-tasks.
        Alfresco.util.Ajax.jsonPut({
          url: Alfresco.constants.PROXY_URI
            + "api/lyse/set-approved/"
            + item.nodeRef.replace("://", "/")
            + "/true",
          successCallback: {
            fn: function(response) {
              Alfresco.util.Ajax.jsonPost(
                {
                  url: Alfresco.constants.PROXY_URI + "/lyse/api/start-workflow",
                  responseContentType : "application/json",
                  dataObj: payload,
                  successCallback:
                    {
                      fn: function (response)
                      {
                        fn.call(this,response);
                      },
                      scope: this
                    },
                  failureCallback:
                    {
                      fn: function ExtDataGrid_onActionSubmitForReview_failure(response)
                      {
                        Alfresco.util.PopupManager.displayPrompt(
                          {
                            text: response.json.message
                          });
                      },
                      scope: this
                    }
                });
            }, scope: this
          }
        });

      },

      onActionStartConfirmIFCWorkflow: function ExtDataGrid_onActionStartConfirmIFCWorkflow(item, fn) {

        var payload = {
          firstUserTask: "IFC",
          nodes: [{
            nodeRef: item.nodeRef
          }]
        };

        Alfresco.util.Ajax.jsonPost({
          url: Alfresco.constants.PROXY_URI + "/lyse/api/start-workflow",
          responseContentType: "application/json",
          dataObj: payload,
          successCallback: {
            fn: function ExtDataGrid_onActionStartConfirmIFCWorkflow_success(response) {

              var refreshItem = true;
              if (response.json) {
                if (response.json.data.workflows.length > 0) {
                  if (response.json.data.workflows[0].tasks.length === 1) {
                    // Redirect to the assigned task if there is only one
                    var taskId = response.json.data.workflows[0].tasks[0].taskId;
                    var workflowId = response.json.data.workflows[0].workflowId;

                    refreshItem = false;
                    Alfresco.util.PopupManager.displayMessage({
                      text: this.msg("actions.start-workflow-success")
                    });
                    window.location.href = YAHOO.lang.substitute("{context}lyse-task-edit?taskId={taskId}&workflowId=" + workflowId, {
                      context: Alfresco.constants.URL_PAGECONTEXT,
                      taskId: taskId
                    });


                  }
                }
              }
              if (refreshItem) {
                this.refreshItem(item.nodeRef, "actions.start-workflow-success");
              }

            },
            scope: this
          },
          failureCallback: {
            fn: function ExtDataGrid_onActionStartConfirmIFCWorkflow_failure(response) {
              Alfresco.util.PopupManager.displayPrompt({
                text: response.json.message
              });
            },
            scope: this
          }
        });
      },
      onActionStartWorkflow: function ExtDataGrid_onActionStartWorkflow(nodeRef,fn)
      {

        var payload = {
          firstUserTask : "default",
          nodes : [{ nodeRef : nodeRef}]
        };

        Alfresco.util.Ajax.jsonPost( {
          url: Alfresco.constants.PROXY_URI + "/lyse/api/start-workflow",
          responseContentType : "application/json",
          dataObj: payload,
          successCallback:
            {
              fn: function ExtDataGrid_onActionStartWorkflow_success(response) {
                if (response.json) {
                  if (response.json.data.workflows.length > 0) {
                    if (response.json.data.workflows[0].tasks.length === 1) {
                      // Redirect to the assigned task if there is only one
                      var taskId = response.json.data.workflows[0].tasks[0].taskId;
                      var workflowId = response.json.data.workflows[0].workflowId;
                      Alfresco.util.PopupManager.displayMessage(
                        {
                          text: this.msg("actions.start-workflow-success")
                        });
                      // #39233 && #39577, We want the task to open in a new tab and not in the current window.
                      Alfresco.util.PopupManager.displayMessage({
                        text: this.msg('message.opened_in_new_window')
                      });


                      Alfresco.util.Ajax.jsonGet(
                        {
                          url: Alfresco.constants.PROXY_URI + "api/lyse/attachment-folder?nodeRef=" +nodeRef,
                          successCallback:
                            {
                              fn: function (response) {
                                if (response.json !== undefined && response.json.nodeRef !== "") {
                                  //Success, this datalist item has an attachment folder
                                  var attachmentFolder = response.json.nodeRef;
                                  window.open(Alfresco.constants.URL_PAGECONTEXT +'lyse-task-edit?taskId=' + taskId + '&workflowId=' + workflowId + "&docLib=" + attachmentFolder, "_blank");
                                }else{
                                  window.open(Alfresco.constants.URL_PAGECONTEXT +'lyse-task-edit?taskId=' + taskId + '&workflowId=' + workflowId, "_blank");
                                }
                              },
                              scope: this
                            }
                        });

                    }
                  }
                }
                this.refreshItem(nodeRef, "actions.start-workflow-success");
              },
              scope: this
            },
          failureCallback:
            {
              fn: function ExtDataGrid_onActionStartWorkflow_failure(response)
              {
                Alfresco.util.PopupManager.displayPrompt(
                  {
                    text: response.json.message
                  });
              },
              scope: this
            }
        });
      },
    }
})();
