(function() {
  //#47265 Accessing datalist items with the workflowId gives errors on fetching workflow image and sometime crashes other components.
  var workflowId = Alfresco.util.parseURL().queryParams.workflowId;
  var showHistory = Alfresco.util.parseURL().queryParams.showHistory;
  if(showHistory){
    if(showHistory == "true"){
      // Request to view workflow history only.
      return;
    }
  }
  if(workflowId) {
    Alfresco.util.Ajax.jsonGet({
      url: Alfresco.constants.PROXY_URI + "api/lyse/noderef-from-workflowid/"+workflowId,
      successCallback: {
        fn: function (response){
          if (response.json !== undefined && response.json.nodeRef !== "") {
            //Success, this datalist item has an attachment folder
            var nodeRef = response.json.nodeRef;
            var isActive = response.json.isActive;
            if(isActive == null) {
              Alfresco.util.Ajax.jsonGet({
                url: Alfresco.constants.PROXY_URI + "api/lyse/attachment-folder?nodeRef=" +nodeRef,
                successCallback: {
                  fn: function (response) {
                    if (response.json !== undefined && response.json.nodeRef !== "") {
                      //Success, this datalist item has an attachment folder
                      var attachmentFolder = response.json.nodeRef;
                      window.location.href = location.protocol + '//' + location.host + location.pathname + '?nodeRef=' + nodeRef + "&docLib=" + attachmentFolder;
                    } else{
                      window.location.href = location.protocol + '//' + location.host + location.pathname + '?nodeRef=' + nodeRef;
                    }
                  },
                  scope: this
                }
              });
            }

          }
        },
        scope: this
      }
    });
  } else {
    // #52312 We need to check if node has an active workflow.
    var nodeRef = Alfresco.util.parseURL().queryParams.nodeRef;
    Alfresco.util.Ajax.jsonGet(
      {
        url: Alfresco.constants.PROXY_URI + "api/metadata?nodeRef=" + nodeRef,
        successCallback:
          {
            fn: function (response) {
              if (response.json !== undefined) {
                var workflowId = response.json.properties["{http://ns.lyse.no/model/datalist/1.0}workflowId"];
                if(workflowId) {
                  Alfresco.util.Ajax.jsonGet({
                    url: Alfresco.constants.PROXY_URI + "api/lyse/attachment-folder?nodeRef=" +nodeRef,
                    successCallback: {
                      fn: function (response) {
                        if (response.json !== undefined && response.json.nodeRef !== "") {
                          //Success, this datalist item has an attachment folder
                          var attachmentFolder = response.json.nodeRef;
                          window.location.href = location.protocol + '//' + location.host + location.pathname + '?workflowId=' + workflowId + "&docLib=" + attachmentFolder;
                        } else{
                          window.location.href = location.protocol + '//' + location.host + location.pathname + '?workflowId=' + workflowId;
                        }
                      },
                      scope: this
                    }
                  });
                }
              }

            },
            scope: this
          }
      });
  }

})();
