// Define module requirements and callback...
define(["dojo/_base/declare","alfresco/header/AlfSitesMenu", "alfresco/header/AlfMenuItem"],
  function(declare, AlfSitesMenu, AlfMenuItem) {

  // Module returns a new widget that extends AlfSitesMenu
  return declare([AlfSitesMenu], {
    addUsefulGroup: function(showAddFavourite, showRemoveFavourite) {
      if (this.popup && this.showUsefulGroup) {
        this.inherited(arguments);
        if (this.showCreateSite) {
          this.createProject = new AlfMenuItem({
            id: this.id + "_CREATE_PROJECT",
            label: "menu.createProject",
            iconClass: this.createSiteIconClass,
            publishTopic: "ALF_CREATE_PROJECT"
          });

          this.createContractor = new AlfMenuItem({
              id: this.id + "_CREATE_CONTRACTOR",
              label: "menu.createContractor",
              iconClass: this.createSiteIconClass,
              publishTopic: "ALF_CREATE_CONTRACTOR",
              publishPayload: {
                  site: this.currentSite,
                  user: this.currentUser
               }
            });
 
          this.createEPCEng = new AlfMenuItem({
              id: this.id + "_CREATE_EPC_ENG",
              label: "menu.createEpcEng",
              iconClass: this.createSiteIconClass,
              publishTopic: "ALF_CREATE_EPC_ENGINEERING",
              publishPayload: {
                  site: this.currentSite,
                  user: this.currentUser
               }
            });

          this.createInterface = new AlfMenuItem({
              id: this.id + "_CREATE_INTERFACE",
              label: "menu.createInterface",
              iconClass: this.createSiteIconClass,
              publishTopic: "ALF_CREATE_INTERFACE",
              publishPayload: {
                  site: this.currentSite,
                  user: this.currentUser
               }
            });

          this.createHSE = new AlfMenuItem({
              id: this.id + "_CREATE_HSE",
              label: "menu.createHSE",
              iconClass: this.createSiteIconClass,
              publishTopic: "ALF_CREATE_HSE",
              publishPayload: {
                  site: this.currentSite,
                  user: this.currentUser
              }
          });
          
          this.createPS = new AlfMenuItem({
              id: this.id + "_CREATE_PS",
              label: "menu.createPS",
              iconClass: this.createSiteIconClass,
              publishTopic: "ALF_CREATE_PS",
              publishPayload: {
                  site: this.currentSite,
                  user: this.currentUser
              }
          });

          this.createMCC = new AlfMenuItem({
            id: this.id + "_CREATE_MCC",
            label: "menu.createMCC",
            iconClass: this.createSiteIconClass,
            publishTopic: "ALF_CREATE_MCC",
            publishPayload: {
                site: this.currentSite,
                user: this.currentUser
            }
          });

          this.createCivil = new AlfMenuItem({
            id: this.id + "_CREATE_CIVIL",
            label: "menu.createCivil",
            iconClass: this.createSiteIconClass,
            publishTopic: "ALF_CREATE_CIVIL",
            publishPayload: {
                site: this.currentSite,
                user: this.currentUser
            }
          });

            var usefulGroup = this.usefulGroup.getChildren();
          var insertIndex = usefulGroup.length;
          for (var i=0;i<usefulGroup.length;i++) {
            var item = usefulGroup[i];
            var createSiteId = this.id + "_CREATE_SITE";
            if (item.id==createSiteId) {
              insertIndex = i;
              break;
            }
          }
          // Remove standard site creation.
          this.usefulGroup.removeChild(insertIndex);

          this.usefulGroup.addChild(this.createProject, insertIndex + 1);
          this.usefulGroup.addChild(this.createContractor, insertIndex + 2);
          this.usefulGroup.addChild(this.createInterface, insertIndex + 3);
          this.usefulGroup.addChild(this.createHSE, insertIndex + 4);
          this.usefulGroup.addChild(this.createMCC, insertIndex + 5);
          this.usefulGroup.addChild(this.createCivil, insertIndex + 6);
          this.usefulGroup.addChild(this.createEPCEng, insertIndex + 7);
          this.usefulGroup.addChild(this.createPS, insertIndex + 8);
        }
        //this.popup.addChild(this.usefulGroup);
      }
    }

  });
});