/**
 * This code is cancer but it seems to work. It tries to reuse the same data which is being rendered with the purpose
 * of not duplicating the code and making it easier to extend. The reason for the very cancerous code is because of the
 * requirement that the exported csv has the same order and data as the rendered data.. I think this could be made better
 * if the backend somehow presented data better..
 */

define(["dojo/_base/declare",
    "dijit/_WidgetBase",
    "alfresco/core/Core",
    "dijit/_TemplatedMixin",
    "dojo/dom-construct",
    "dojo/request",
    "dojo/promise/all",
    "lyse/reports/datalist",
    "dojo/dom",
    "lyse/reports/papaparse.min"
  ],
  function(declare, _Widget,Core,_Templated, domConstruct, request, all,Datalist,dom,papaparse) {
    return declare([Core, _Widget, _Templated], {

      templateString : '<div data-dojo-type="overview"></div>',

      i18nScope : 'Reports',

      i18nRequirements : [ {
        i18nFile : 'reports.properties'
      } ],

      buildRendering:function()
      {
        this.inherited(arguments);
      },
      sortByStatus:function(a,b)
      {
        if(!this.orderList)
        {
          return 0;
        }
        if(this.orderList.indexOf(a.status)===-1)
        {
          console.warn("Could not find status %s in order array",a.status);
          return 0;
        }
        if(this.orderList.indexOf(b.status)===-1)
        {
          console.warn("Could not find status %s in order array",b.status);
          return 0;
        }
        return this.orderList.indexOf(a.status) > this.orderList.indexOf(b.status)?1:-1;
      },

      // Fetches visible datalists from site.
      // Calls fetchDatalistsConfig on success
      fetchVisibleDatalists:function()
      {
        Alfresco.util.Ajax.jsonGet({
          url : Alfresco.constants.PROXY_URI + "lyse/datalists/visiblelists/site/" + Alfresco.constants.SITE,
          successCallback:
            {
              fn: function(json){
                var datalists = [];
                json.json.datalists.forEach(function(item){
                  if(item.type != "lysedl:genericDocumentList" && item.type != "lysedl:genericActionList"){
                    datalists.push(item.type);
                  }
                });
                this.fetchDatalistConfigs(datalists, json.json);
              },
              scope: this
            },
          failureMessage: "Could not load site datalists.",
          scope: this,
          execScripts: true
        });
      },

      // Fetches datalist configs for visible datalists
      // Calls afterLoadData on success.
      fetchDatalistConfigs:function(datalists, lists)
      {
        Alfresco.util.Ajax.jsonGet({
          url : Alfresco.constants.URL_SERVICECONTEXT + "components/reports",
          dataObj: datalists,
          responseContentType : "application/json",
          successCallback:
            {
              fn: function(json){
                lists.datalists.forEach(function(item){
                  if(json.json[item.type] != undefined) {
                    json.json[item.type].name = item.name;
                    json.json[item.type].title = item.title;
                  }
                });
                this.afterLoadData(json.json, lists);
              },
              scope: this
            },
          failureMessage: "Could not load report data.",
          scope: this,
          execScripts: true
        });
      },

	    /*Configure collected data and present them.
	    Further labels & columns can be configured in reports.properties
	    Special reports can be configured in overview.get.js*/
      afterLoadData:function(data,lists) {
        var config = [];
        var sitetype = lists.sitetype;
        // Format collected data to present in GUI.
        for (var key in data){
          if(data[key].status.length > 0){

				  // Object structure
          var datalistObject = {
					dataList: key.split(":")[1],
          sitetype: sitetype,
					dataListName: data[key].title,
					dataListURLParam: data[key].name,
					filterOverdueProperties: {},
					filterStatusConstraints: {},
					filterStatusProperty: data[key].status[0].name,
					orderList: []
				  };

				    // Add all constraints to status
        		data[key].status[0].constraints.forEach(function(item){
        			datalistObject.filterStatusConstraints[item.label] = item.value;
                    if(item.label.toUpperCase().indexOf("OVERDUE") >= 0){
        				tempOrder.push(item.label);
        			}else{
        				datalistObject.orderList.push(item.label);
        			}
				});

	        	// Add all overdue properties
				var tempOrder = [];
        		if(data[key].overdue.length > 0){
	        		data[key].overdue.forEach(function(item){
	        			datalistObject.filterOverdueProperties[item.label] = item.name;
	        			tempOrder.push(item.label);
					});
				}

				// Add overdue to sortList last.
				if(tempOrder.length > 0){
					datalistObject.orderList = datalistObject.orderList.concat(tempOrder);
				}

				// Fetch columns defined in reports.properites.
				var columns = this.message(datalistObject.dataList+".columns");
				if(columns != undefined && columns != datalistObject.dataList+".columns"){
					datalistObject.columns = columns.split(",");
				}

				config.push(datalistObject);
			}
	    }

	    // Generic documents and generic actions may exists multiple times, lets add them all with their unique cm:name as identifier.
	    if(lists.datalists){
		    lists.datalists.forEach(function(item){
			    if(item.type == "lysedl:genericDocumentList"){
			    	var obj = {
						dataList: item.type.split(":")[1],
            sitetype: sitetype,
						dataListName: item.title,
            forceLinks: true,
						dataListURLParam: item.name,
						filterOverdueProperties: {},
						filterStatusConstraints: {},
						filterStatusProperty: "prop_lyse_genericDocumentStatus",
						orderList: []
					};
					config.push(obj);
				}else if(item.type == "lysedl:genericActionList"){
           var obj = {
           dataList: item.type.split(":")[1],
           sitetype: sitetype,
           dataListName: item.title,
           forceLinks: true,
           dataListURLParam: item.name,
           filterOverdueProperties: {"Overdue" : "prop_lyse_genericActionDueDate"},
           filterStatusConstraints: {
             "For action": "action",
             "Closed": "closed",
             "For closing": "for_closing",
             "Draft" : "draft"},
           filterStatusProperty: "prop_lyse_genericActionReviewStatus",
           orderList: []
          };
          config.push(obj);
          }
          });
        }
        // Hard-codes specific reports from overview.get.js
        this.params.dataLists.forEach(function(item){
          config.push(item);
        });


        // Overrides from overview.get.js
        this.params.overrides.forEach(function(item){

          // if datalist is visible
          if(lists.datalists.filter(function(newItem){ return newItem.type.split(":")[1] === item.override }).length > 0){

            // if config exists, replace it.
            if(config.filter(function(newItem){ return newItem.dataList === item.override }).length > 0){
              var index = config.indexOf(config.filter(function(newItem){ return newItem.dataList === item.override })[0]);
              config[index] = item;
            }else{

              // If item doesn't exist, push it.
              config.push(item);
            }
          }
        });

        // Extend specific data from overview.get.js
        this.params.extensions.forEach(function(item){

          // if datalist is visible
          if(lists.datalists.filter(function(newItem){ return newItem.type.split(":")[1] === item.extend }).length > 0){

            // if config exists
            if(config.filter(function(newItem){ return newItem.dataList === item.extend }).length > 0){
              var index = config.indexOf(config.filter(function(newItem){ return newItem.dataList === item.extend })[0]);

              // Add properties to found object.
              for (var property in item) {
                if (item.hasOwnProperty(property) && property !== "extend") {
                  config[index][property] = item[property];
                }
              }
            }
          }
        });

        // Sort datalists on displayname.
        function compare(a,b) {
          if (a.dataListName < b.dataListName)
            return -1;
          if (a.dataListName > b.dataListName)
            return 1;
          return 0;
        }

        function makeRequests(promises, self) {
          var requestURL = promises[0].url;
          var currentDatalistParams = promises[0].datalistParams;
          Alfresco.util.Ajax.jsonGet({
            url : requestURL,
            successCallback: {
              fn: function(response){
                var div = domConstruct.create("div");
                self.domNode.appendChild(div);
                if(typeof response != "undefined") {
                  self.orderList = currentDatalistParams.orderList;
                  self.reportRows[currentDatalistParams.dataListName] = response.json.results.sort(self.sortByStatus.bind(self));
                  self.localize(self.reportRows[currentDatalistParams.dataListName], currentDatalistParams.columns);
                  currentDatalistParams.reportRows = self.reportRows[currentDatalistParams.dataListName];
                  var datalist = new Datalist(currentDatalistParams, div);
                }

                promises.splice(0, 1);
                if(promises.length > 0) {
                  makeRequests(promises, self);
                } else {
                  self.createCsvStuff.bind(self);
                }
              }
            },
            failureMessage: "Could not load site datalists.",
            scope: this
          });
        }

        config.sort(compare);
        // Remove unwanted reports for this site-type
        var tempArr = [];
        tempArr = config.filter(function( obj ) {
          return obj.sitetype === sitetype;
        });

        this.params.dataLists = tempArr;

        /*Here is a good place to log if you want to debug this feature.
        console.log(this.params.dataLists);*/

        this.reportRows = {};
        var promises = [];
        this.params.dataLists.forEach(function(datalistParams, index) {
          var url = "";

          if(datalistParams.dataList == "genericDocumentList" || datalistParams.dataList == "genericActionList"){
            url = Alfresco.constants.PROXY_URI + "lyse/report/" + datalistParams.dataList + "/" + Alfresco.constants.SITE + "/" + datalistParams.dataListURLParam;
          }else{
            url = Alfresco.constants.PROXY_URI + "lyse/report/" + datalistParams.dataList + "/" + Alfresco.constants.SITE;
          }
          promises.push({url: url, datalistParams: datalistParams});
          if(this.params.dataLists.length == index+1) {
            makeRequests(promises, this);
          }

        },this);
      },

// Initiates datalists-reports fetch & format reports.
      postCreate:function()
      {
        this.fetchVisibleDatalists();
      },

      localize:function(items,columns)
      {
        items.forEach(function(item,itemsIndex)
        {
          if(columns)
          {
            columns.forEach(function(column)
            {
              var value = item[column];
              if(!value)
              {
                value = "";
              }
              if(column !=="status" && isNaN(value))
              {
                value = this.message(value);
              }
              items[itemsIndex][column] = value;
            },this);
          }
        },this);
      },

      filterAndLocalizeColumns:function(reportRows,columns)
      {
        var rows = [];
        reportRows.forEach(function(row)
        {
          var newRow = {};
          if(columns)
          {
            columns.forEach(function(column)
            {
              newRow[this.message(column)] = row[column];
            },this);
          }
          else
          {
            newRow["status"] = row["status"];
            newRow["count"] = row["count"];
          }
          rows.push(newRow);
        },this);
        return rows;
      },
      createCsvStuff:function()
      {
        var data ="data:text/csv;charset=utf-8,";
        this.params.dataLists.forEach(function(datalistParams)
        {
          if(datalistParams.showTotals)
          {
            var row = {status:"Total"};
            datalistParams.columns.forEach(function(column)
            {
              if(column!=="status")
              {
                var total = this.reportRows[datalistParams.dataListName].reduce(function(acc,item)
                {
                  var value = parseFloat(item[column]);
                  var derp = acc + ((!isNaN(value))?value:0);
                  return derp;
                },0);
                row[column] = total;
              }
            },this);
            this.reportRows[datalistParams.dataListName].push(row);
          }
          data += this.message(datalistParams.dataListName) + "\n" + papaparse.unparse(
            this.filterAndLocalizeColumns(this.reportRows[datalistParams.dataListName],datalistParams.columns)) + "\n\n";
        },this);
        data = encodeURI(data);
        var a = domConstruct.create("a", {
          innerHTML: "Download all reports as CSV",
          href: data,
          download: "export.csv",
          className:"lyse_aggregate_csv"
        });
        this.domNode.prepend(a);
      }
    });
});
