
var Lyse = Lyse || {};
Lyse.component = Lyse.component || {};

(function() {
  var Dom = YAHOO.util.Dom, Selector = YAHOO.util.Selector

  Lyse.component.customerService = function customerService_constructor(htmlId)
  {
    Lyse.component.customerService.superclass.constructor.call(this, "Lyse.component.customerService", htmlId, ["container", "datasource", "datatable"]);
    this.id = htmlId;
  };

  YAHOO.extend(Lyse.component.customerService, Alfresco.component.Base,
    {

      options:
      {
          siteId: "",
          listId: "",
          listTitle: "",
          ListContent: ""
      },
      persistData : function persistData(obj){
        Alfresco.util.Ajax.jsonGet({
          url: Alfresco.constants.PROXY_URI + "api/people/"+Alfresco.constants.USERNAME,
          responseContentType : "application/json",
          successCallback: {
            fn: function (response) {
              var isAdmin = response.json.isAdminAuthority;
              if(isAdmin){
                this.options.nodeRef = obj.nodeRef;
                this.options.listTitle = obj.title;
                this.options.ListContent = obj.content;
                this.renderContent();
                return;
              }
              var widgetIsEmpty = !obj.title && !obj.content;
              if(widgetIsEmpty){
                this.removeContent();
                return;
              }
              this.options.nodeRef = obj.nodeRef;
              this.options.listTitle = obj.title;
              this.options.ListContent = obj.content;
              this.renderContent();
            },
            scope: this
          }
        });
      },
      onReady: function customerService_onReady()
      {
        this.loadData();

        // Create edit button of the element in the ftl file defined as: ${el}-1-edit
        this.widgets.editButton = Alfresco.util.createYUIButton(this, this.options.listId+"-edit", this.onEditButton);
        Dom.removeClass(Selector.query(".toolbar div", this.id+"-"+this.options.listId, true), "hidden");
      },
      loadData: function customerService_loadData(){
        Alfresco.util.Ajax.jsonGet(
          {
            url: Alfresco.constants.PROXY_URI + "/lyse/project/customerService?content=serviceContent" + this.options.listId + "&title=serviceTitle" + this.options.listId,
            responseContentType : "application/json",
            successCallback:
              {
                fn: function (response)
                {
                  var obj = response.json;
                  if(obj){
                    this.persistData(obj);
                  }
                },
                scope: this
              }
          });
      },
      onEditButton: function customerService_onEditButton(event)
      {
        this.onCreateDialog();
      },

      renderContent: function customerService_renderContent()
      {
        Dom.get(this.id + "-" + this.options.listId + "-content").innerHTML = this.options.ListContent;
        Dom.get(this.id + "-" + this.options.listId + "-header").innerHTML = this.options.listTitle;
      },
      removeContent: function customerService_removeContent()
      {
        var getWidget = Dom.get(this.id + "-" + this.options.listId);
        if(getWidget){
          getWidget.parentElement.remove();
        }
      },
      onCreateDialog: function customerService_onCreateDialog(){
        var templateUrl = YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&formId={formId}&itemId={itemId}&mode={mode}&submitType={submitType}&showCancelButton=true&data={data}",
          {
            itemKind: "node",
            itemId: this.options.nodeRef,
            mode: "create",
            formId: "edit-information-" + this.options.listId,
            submitType: "json"
          });
        var doBeforeDialogShow = function(p_form, p_dialog)
        {
          Alfresco.util.populateHTML(
            [ p_form.formId + "-container_h", "Edit container" ],
            [ p_form.formId + "-submit-button", "Save" ]
          );
        };
        var dialog = new Alfresco.module.SimpleDialog(this.id + "-form-edit-" + Alfresco.util.generateDomId());
        dialog.setOptions(
          {
            templateUrl: templateUrl,
            actionUrl: null,
            destroyOnHide: true,
            doBeforeDialogShow:
              {
                fn: doBeforeDialogShow,
                scope: this
              },
            width: "400px",
            onSuccess:
              {
                fn: function(response) {
                  this.loadData();
                },
                scope: this
              }
          }).show();
      }
    });
})();
