require([Alfresco.constants.URL_RESCONTEXT + "components/form/rich-text.js", Alfresco.constants.URL_RESCONTEXT + "js/lyse/allsites/LyseRichTextControl.js"], function () {
    (function () {
        // This makes sure Alfresco.LyseRichTextControl.updateAll() is executed before the form is submitted.
        // Activated in: lyse-share-config.xml

        function updateRichText() {
            if (console) console.log("Updating rich text field");
            Alfresco.LyseRichTextControl.updateAll();
        }

        /**
         * Adds a submit event handler to a Share form.
         */
        function onBeforeFormRuntimeInit(layer, args) {
            var formUI = args[1];
            if (console) console.log("formUI=" + formUI);
            if (formUI) {
                var formId = formUI.eventGroup;
                if (console) console.log("formId=" + formId);
                var form = YUIDom.get(formId);
                if (form) {
                    if (console) console.log("form=" + form);
                    YAHOO.util.Event.on(form, "submit", updateRichText);
                }
            }
        }

        // Before runtime init here, so our submit handler is registered before the one in the form runtime
        YAHOO.Bubbling.on("beforeFormRuntimeInit", onBeforeFormRuntimeInit, this);
        if (console) console.log("Loaded rich text control support");
    })();
});