(function () {
    /*
     * When the "Consequence" dropdown is changed show/hide other fields depending on the selected value.
     */
    var initCivilReportingFormBehaviour = function (layer, args) {
        var formUI = args[1];
        // Check if it's a "new datalist item" or "task edit" form
        if (!formUI.runtime.formId.contains("createRow-form")
            && !formUI.runtime.formId.contains("editDetails-form")
            && !formUI.runtime.formId.contains("task-edit")
            && !formUI.runtime.formId.contains("start-workflow"))
            return;

        var htmlForm = YUIDom.get(formUI.runtime.formId);
        if (htmlForm) {
            // Find out what content type the form creates by looking at the form's action URL
            // Looks like this: "http://localhost:8081/share/proxy/alfresco/api/type/lysedl%3avariationOrderRequestItem/formprocessor"
            // TODO: is there an easier way to do this (couldn't find itemKind/formId parameters anywhere?!)
            //var actionURL = decodeURIComponent(htmlForm.action);
            //if (actionURL.indexOf('/api/type/lysedl:variationOrderRequestItem/formprocessor') > -1) {

            // We have the correct type, now add an event handler
        	var month = document.getElementsByName('prop_lyse_month')[0];
            var week = document.getElementsByName('prop_lyse_week')[0];


            if (month && week) {

                var showHideField = function (element, isDisabled) {
                    if (element) {
                        // Enable/disable the actual input field so it will not be submitted if disabled
                        if (isDisabled) {
                            element.disabled = 'disabled'
                        }
                        else {
                            element.removeAttribute('disabled')
                        }
                        // Show/hide the parent container (so also the label and help is hidden)
                        var field = YAHOO.util.Dom.getAncestorByClassName(element, 'form-field');
                        if (field) {
                            YAHOO.util.Dom.setStyle(field, 'display', isDisabled ? 'none' : 'inherit')
                        }
                    }
                };

                var showHideMonthField = function () {
                    var disableMonth = month.value == '' && week.value != '';
                    showHideField(month, disableMonth);
                    
                };
                
                var showHideWeekField = function () {
                    var disableWeek = week.value == '' && month.value != '';
                    showHideField(week, disableWeek);
                };

                // Only initialize behaviour if the fields were not initially set to read only in the form
                if (!month.disabled) {
                    showHideMonthField();
                    YAHOO.util.Event.on(week.id, 'change', function () {
                        // Update
                        showHideMonthField();
                    });
                }
                
                if (!week.disabled) {
                    showHideWeekField();
                    YAHOO.util.Event.on(month.id, 'change', function () {
                        // Update
                        showHideWeekField();
                    });
                }

            }

            //}
        }

    };

    YAHOO.Bubbling.on("afterFormRuntimeInit", initCivilReportingFormBehaviour, this);
})();
