(function () {
    /*
     * When the "Consequence" dropdown is changed show/hide other fields depending on the selected value.
     */
    var initCivilVarationOrderFormBehaviour = function (layer, args) {
        var formUI = args[1];
        // Check if it's a "new datalist item" or "task edit" form
        if (!formUI.runtime.formId.contains("createRow-form")
            && !formUI.runtime.formId.contains("editDetails-form")
            && !formUI.runtime.formId.contains("task-edit")
            && !formUI.runtime.formId.contains("start-workflow"))
            return;

        var htmlForm = YUIDom.get(formUI.runtime.formId);
        if (htmlForm) {
            // Find out what content type the form creates by looking at the form's action URL
            // Looks like this: "http://localhost:8081/share/proxy/alfresco/api/type/lysedl%3avariationOrderRequestItem/formprocessor"
            // TODO: is there an easier way to do this (couldn't find itemKind/formId parameters anywhere?!)
            //var actionURL = decodeURIComponent(htmlForm.action);
            //if (actionURL.indexOf('/api/type/lysedl:variationOrderRequestItem/formprocessor') > -1) {

            // We have the correct type, now add an event handler
            var costConsequenceSelect = document.getElementsByName('prop_lysedl_civilVorCostConsequence')[0];
            var costConsequenceNOK = document.getElementsByName('prop_lysedl_civilVorConsequenceNOK')[0];
            var costConsequenceEUR = document.getElementsByName('prop_lysedl_civilVorConsequenceEUR')[0];

            if (costConsequenceSelect && costConsequenceNOK && costConsequenceEUR) {

                var showHideField = function (element, isDisabled) {
                    if (element) {
                        // Enable/disable the actual input field so it will not be submitted if disabled
                        if (isDisabled) {
                            element.disabled = 'disabled'
                        }
                        else {
                            element.removeAttribute('disabled')
                        }
                        // Show/hide the parent container (so also the label and help is hidden)
                        var field = YAHOO.util.Dom.getAncestorByClassName(element, 'form-field');
                        if (field) {
                            YAHOO.util.Dom.setStyle(field, 'display', isDisabled ? 'none' : 'inherit')
                        }
                    }
                };

                var showHideCostConsequenceFields = function () {
                    var isDisabled = costConsequenceSelect.value == 'no_consequence';
                    showHideField(costConsequenceNOK, isDisabled);
                    showHideField(costConsequenceEUR, isDisabled);
                };

                // Only initialize behaviour if the fields were not initially set to read only in the form
                if (!costConsequenceSelect.disabled) {
                    showHideCostConsequenceFields();
                    YAHOO.util.Event.on(costConsequenceSelect.id, 'change', function () {
                        // Update
                        showHideCostConsequenceFields();
                    });
                }

            }

            var scheduleConsequenceSelect = document.getElementsByName('prop_lysedl_civilVorScheduleConsequence')[0];
            var scheduleConsequence = document.getElementsByName('prop_lysedl_civilVorConsequenceSchedule')[0];

            if (scheduleConsequenceSelect && scheduleConsequence) {
                var showHideScheduleConsequenceFields = function () {
                    var isDisabled = scheduleConsequenceSelect.value == 'no_consequence';
                    showHideField(scheduleConsequence, isDisabled);
                };

                // Only initialize behaviour if the fields were not initially set to read only in the form
                if (!scheduleConsequenceSelect.disabled) {
                    // Initialize
                    showHideScheduleConsequenceFields();
                    YAHOO.util.Event.on(scheduleConsequenceSelect.id, 'change', function () {
                        // Update
                        showHideScheduleConsequenceFields();
                    });
                }
            }
            //}
        }

    };

    YAHOO.Bubbling.on("afterFormRuntimeInit", initCivilVarationOrderFormBehaviour, this);
})();
