(function () {
    /*
     * When the "Purpose" dropdown is changed show/hide other fields depending on the selected value.
     */
    var initHseActionFormBehaviour = function (layer, args) {
        var formUI = args[1];
        // Check if it's a "new datalist item" or "task edit" form
        if (!formUI.runtime.formId.contains("createRow-form")
            && !formUI.runtime.formId.contains("editDetails-form")
            && !formUI.runtime.formId.contains("task-edit")
            && !formUI.runtime.formId.contains("start-workflow"))
            return;

        var htmlForm = YUIDom.get(formUI.runtime.formId);
        if (htmlForm) {
            
            // Now add an event handler
            var purposeSelect = document.getElementsByName('prop_lyse_hseActionPurpose')[0];
            var hseDueDate = document.getElementsByName('prop_lyse_hseDueDate')[0];
 
            if (purposeSelect && hseDueDate ) {

                var showHideField = function (element, isDisabled) {
                    if (element) {
                        // Enable/disable the actual input field so it will not be submitted if disabled
                        if (isDisabled) {
                            element.disabled = 'disabled'
                        }
                        else {
                            element.removeAttribute('disabled')
                        }
                        // Show/hide the parent container (so also the label and help is hidden)
                        var field = YAHOO.util.Dom.getAncestorByClassName(element, 'form-field');
                        if (field) {
                            YAHOO.util.Dom.setStyle(field, 'display', isDisabled ? 'none' : 'inherit')
                        }
                    }
                };

                var showHideFields = function () {
                    var isDisabled = purposeSelect.value == 'information';
                    showHideField(hseDueDate, isDisabled);
                };

                // Only initialize behaviour if the fields were not initially set to read only in the form
                if (!purposeSelect.disabled) {
                    showHideFields();
                    YAHOO.util.Event.on(purposeSelect.id, 'change', function () {
                        // Update
                        showHideFields();
                    });
                }

            }

        }

    };

    YAHOO.Bubbling.on("afterFormRuntimeInit", initHseActionFormBehaviour, this);
})();
