// see hseAction... in same folder

(function () {

  var names=['prop_lyse_losArrivalTimePreliminaryProp','prop_lyse_losArrivalTimePlannedProp'];
  var values={};
  var inputs=[];

  function onAfterFormRuntimeInit(layer,args){

    // Ran each time a new edit window is opened
    values={};
    inputs=[];

    var formUI = args[1];
    var formId=formUI.runtime.formId;
    var formEl=document.getElementById(formId);
    var formAction=formEl.action;

    // Locate expected input elemets
    // Store original values
    for (var i=0;i<names.length;i++){
      var input=document.getElementsByName(names[i]);
      if (input.length===1){
        inputs.push(input[0]);
        values[names[i]]=formUI.runtime.getFormData()[names[i]];
      }
    }


    if (inputs.length===names.length) {
      // Only if all the executed input fields are present
      // Which should be all or none, if not something is wrong

      function customOnClickSubmitListener(event,args){
        // Replacing the original listener.
        // Validates the date fields using ajax call to a
        // repository side webscript.
        //
        // When done, it calls submitForm, triggering the normal
        // validation process.
        //
        var data={
          "formdata":formUI.runtime.getFormData(),
          "editinfo":getEditInfo()
        };

        // Before submitting form, check if the date conflicts with any existing dates
        Alfresco.util.Ajax.jsonPost({
          url: Alfresco.constants.PROXY_URI + '/slingshot/datalists/los/checkdates/',
          dataObj: data,
          successCallback:{
            fn: function(response){
              var item = response.json.item;

              if (response.json.conflicts.preliminary.length>0 || response.json.conflicts.planned.length>0) {
                  Alfresco.util.PopupManager.displayPrompt(
                      {
                          title: Alfresco.util.message("error.losDateConflict.title"),
                          text: Alfresco.util.message("error.losDateConflict.text"),
                          buttons: [
                              {
                                text: Alfresco.util.message("button.ok"),
                                handler: function() {
                                    this.destroy();
                                    okbutton.submitForm();
                                }
                              },
                              {
                                text: Alfresco.util.message("button.cancel"),
                                handler: function() {
                                    this.destroy();
                                }
                              }
                          ]
                      });
              }
              else {
                okbutton.submitForm();
              }
            },
            scope: this
          },
          failureCallback:{
            fn: function(response){
              // Best way to display errors?
              alert("Something went wrong validating the dates.");
            },
            scope: this
          }
        });
      }

      var odbfs=formUI.runtime.doBeforeFormSubmit;
      var okbutton=odbfs.scope.widgets.okButton; // There might be better ways to find the widgets?
      var getEditInfo=function(){  // Will be relpaced in code.
        return {'status':'unknown'};
      };

      // Replace listener with own listener
      okbutton.removeListener();
      okbutton.addListener('click',customOnClickSubmitListener,{},this);


      if (formAction.search(Alfresco.constants.PROXY_URI + "api/type/")===0) {
        getEditInfo=function(){
          return {
            'status':"new"
          };
        };
      }
      if (formAction.search(Alfresco.constants.PROXY_URI + "api/node/")===0) {
        (function(){
          var actionsplit=formAction.split('/');
          var target="workspace://SpacesStore/"+actionsplit[actionsplit.length-2];
          getEditInfo=function(){
            return {
              'status':'edit',
              'current_id':target
            };
          };
        })();
      }
    }

  }

  YAHOO.Bubbling.on("afterFormRuntimeInit", onAfterFormRuntimeInit, this);
})();
