(function () {
  /*
   * Hide/show input fields based on user input, this javascript file is inspired by vor_validation.js
   */
  var initMCCPackagesFormBehaviour = function (layer, args) {
    var formUI = args[1];
    // Check if it's a "new datalist item" or "task edit" form
    if (!formUI.runtime.formId.contains("createRow-form")
        && !formUI.runtime.formId.contains("editDetails-form")
        && !formUI.runtime.formId.contains("task-edit")
        && !formUI.runtime.formId.contains("start-workflow"))
      return;

    var htmlForm = YUIDom.get(formUI.runtime.formId);
    if (htmlForm) {
      // Seems to be some issues here, see L16-20 in vor_validation.js

      // We have the correct type, now add an event handler
      var fat = document.getElementsByName('prop_lyse_mccPackagesFAT')[0];
      var fatPlanned = document.getElementsByName('prop_lyse_mccPackagesFATPlanned')[0];
      var fatForecast = document.getElementsByName('prop_lyse_mccPackagesFATForecast')[0];

      if (fat && fatPlanned && fatForecast) {
        //Get the actual input fields
        fat = document.getElementById(fat.id+"-entry");

        var showHideField = function (element, enabled) {
          if (element) {
            // Enable/disable the actual input field so it will not be submitted if disabled
            if (!enabled) {
              element.disabled = 'disabled';
            } else {
              element.removeAttribute('disabled');
            }
            // Show/hide the parent container (so also the label and help is hidden)
            var field = YAHOO.util.Dom.getAncestorByClassName(element, 'form-field');
            if (field) {
              YAHOO.util.Dom.setStyle(field, 'display', enabled ? 'inherit' : 'none');
            }
          }
        };

        var showHideFATFields = function () {
          var enabled = fat.checked;
          showHideField(fatPlanned, enabled);
          showHideField(fatForecast, enabled);
        };

        // Only initialize behaviour if the fields were not initially set to read only in the form
        if(!fat.disabled) {
          showHideFATFields();
          YAHOO.util.Event.on(fat.id, 'change', function () {
            // Update
            showHideFATFields();
          });
        }
      }
    }
  };

  YAHOO.Bubbling.on("afterFormRuntimeInit", initMCCPackagesFormBehaviour, this);
})();
