(function () {
    /*
     * Makes sure that either "Responsible user(s)" or "Responsible group(s)" has a value.
     */
    var initResponsiblesBehaviour = function (layer, args) {
        var formUI = args[1];
        // Make sure we are in an edit form or workflow form
        if (!formUI.runtime.formId.contains("editDetails-form") && !formUI.runtime.formId.contains("task-edit") && !formUI.runtime.formId.contains("start-workflow"))
            return;

        var htmlForm = YUIDom.get(formUI.runtime.formId);
        if (htmlForm) {
            // We need to find the hidden field which contains the current value, since the name
            // is set to "-" by the object finder to prevent submitting we try to find the other field
            // with the "_added" suffix. From there we can find it by removing "-added" from the ID.
            var responsibleUser = document.getElementsByName('assoc_lyse_hseResponsibleUser_added')[0]
                || document.getElementsByName('assoc_lyse_siteQueryNgResponsibleUsers_added')[0]
                || document.getElementsByName('assoc_lyse_civilTqResponsibleUsers_added')[0]
                || document.getElementsByName('assoc_lyse_actionResponsibleUser_added')[0];
            var responsibleGroup = document.getElementsByName('assoc_lyse_hseResponsibleGroup_added')[0]
                || document.getElementsByName('assoc_lyse_siteQueryNgResponsibleGroups_added')[0]
                || document.getElementsByName('assoc_lyse_civilTqResponsibleGroups_added')[0]
                || document.getElementsByName('assoc_lyse_actionResponsibleGroup_added')[0];

            if (responsibleUser && responsibleGroup) {
                // Find the actual hidden field, the one with the ID without the "-added" suffix
                responsibleUser = document.getElementById(responsibleUser.id.substring(0, responsibleUser.id.indexOf("-cntrl-added")));
                responsibleGroup = document.getElementById(responsibleGroup.id.substring(0, responsibleGroup.id.indexOf("-cntrl-added")));

                var responsibleValidation = function (field, args, event, form, silent, message) {
                    return ((responsibleUser && responsibleUser.value && responsibleUser.value.length > 0) || (responsibleGroup && responsibleGroup.value && responsibleGroup.value.length > 0));
                };

                formUI.runtime.addValidation(responsibleUser.id, responsibleValidation, null, "submit", Alfresco.util.message("error.missingResponsible"), {
                    validationType: "mandatory"
                });
                formUI.runtime.addValidation(responsibleGroup.id, responsibleValidation, null, "submit", Alfresco.util.message("error.missingResponsible"), {
                    validationType: "mandatory"
                });
            }
        }
    };

    YAHOO.Bubbling.on("afterFormRuntimeInit", initResponsiblesBehaviour, this);
})();
