/*
 Disables the "attachments" field when choosing the "Withdraw" or "Save" workflow transitions. This way
 the form can be submitted since disabled fields are not validated when submitting a form.
 */
(function () {
    var onSubmitWorkflowForm = function (e, obj) {
        if (obj && obj.length > 1) {
            var data = obj[1];
            if (data.fieldName == "prop_lysewf_vorEntryTaskOutcome") {
                // Find the attachment field
                var attachmentsField = YAHOO.util.Selector.query('input[id$=assoc_lysedl_attachments]');
                if (attachmentsField.length == 1) {
                    attachmentsField[0].disabled = (data.transitionId == "withdraw" || data.transitionId == "save");
                }
            }
        }
    };

    YAHOO.Bubbling.on("beforeSubmitWorkflowForm", onSubmitWorkflowForm, this);

})();