var Lyse = Lyse || {};

Lyse.reports = {
    renderDataTable : function(containerId, columnDefs, dataSourceUrl){
        // Clear the datatable
        var container = document.getElementById(containerId);

        var dataTableContainerElementId = containerId + '-dataTableContainer';
        var dataTableContainer = document.getElementById(dataTableContainerElementId);
        if(dataTableContainer !== null){
            dataTableContainer.remove();
        }

        dataTableContainer = document.createElement('div');
        dataTableContainer.id = dataTableContainerElementId;

        container.appendChild(dataTableContainer);

        var responseSchema = {
            resultsList : 'results',
            fields: []
        };

        for(var i = 0; i < columnDefs.length; i += 1){
            var field = {
                "key" : columnDefs[i].key
            };
            if (columnDefs[i].parser) {
                field.parser = columnDefs[i].parser;
            }
            responseSchema.fields.push(field);
        }

        var dataSourceWithProxy = Alfresco.constants.PROXY_URI + dataSourceUrl + '.json';
        
        var dataSource = YAHOO.util.DataSource(
        		dataSourceWithProxy
        );
        dataSource.responseSchema = responseSchema;

        new YAHOO.widget.DataTable(containerId, columnDefs, dataSource);
    },
    formatters : {
    		cellValueFormatter : function(labelPrefix){
    			return function(elCell, oRecord, oColumn, oData){
    				oData = oData || "_undefined_";
    				switch (Alfresco.util.message(labelPrefix)) {
                case "thousandsSeparator":
                    if (oData == "_undefined_"){
                        elCell.innerHTML= "0";
                    }else {
                        elCell.innerHTML = YAHOO.util.Number.format(oData, {thousandsSeparator: ' '});
                    }
                    break;
                default:
                    var messageKeyString = labelPrefix + '.' + oData + '.label';
                    console.log(messageKeyString);
                    elCell.innerHTML = Alfresco.util.message(messageKeyString);
                    break;
            }
          }
        }
    }
};
